function A = DF_prod(theta_n, xn, tau_n, n_u, n_s, ...
    Pu1, Pu2, Pu3, Ps1, Ps2, Ps3, alpha, tau, a, b, c)


K = n_u + n_s;
Kmid = ceil(K/2);
 
 %Image of theta_n under Ps:
 %Ps_xn = [horner(tau_n, A0s, order_1);
 %         horner(tau_n, B0s, order_1);
 %         horner(tau_n, C0s, order_1)];
 Ps_xn = [mid(polyval(Ps1, tau_n));
          mid(polyval(Ps2, tau_n));
          mid(polyval(Ps3, tau_n))];
 
 
 %Image of z_n = (s_n, t_n) Pu:
 %Pu_zn = evaluate_complexCase(theta_n(1), theta_n(2), A0u, B0u, C0u, N);
 z_theta = theta_n(1) + i*theta_n(2);
 z_theta_bar = theta_n(1) - i*theta_n(2);
 
 Pu_zn = [mid(real(polyval(Pu1, z_theta, z_theta_bar)));
          mid(real(polyval(Pu2, z_theta, z_theta_bar)));
          mid(real(polyval(Pu3, z_theta, z_theta_bar)))];
 
      
 
 %Differential of Ps(theta_n):
 
 
 
 %NOT CORRECT DERIVATIVE...
 DPu_theta1 = [ mid(real(polyval(pderiv(Pu1, 'x') + pderiv(Pu1, 'y'), ...
     theta_n(1) + i*theta_n(2), ...
     theta_n(1) - i*theta_n(2))));
                mid(real(polyval(pderiv(Pu2, 'x') + pderiv(Pu2, 'y'), ...
     theta_n(1) + i*theta_n(2), ...
     theta_n(1) - i*theta_n(2))));
                mid(real(polyval(pderiv(Pu3, 'x') + pderiv(Pu3, 'y'), ...
     theta_n(1) + i*theta_n(2), ...
     theta_n(1) - i*theta_n(2))))];

 DPu_theta2 = [ mid(real(polyval(i*pderiv(Pu1, 'x') - i*pderiv(Pu1, 'y'), ...
     theta_n(1) + i*theta_n(2), ...
     theta_n(1) - i*theta_n(2))));
                mid(real(polyval(i*pderiv(Pu2, 'x') -i*pderiv(Pu2, 'y'), ...
     theta_n(1) + i*theta_n(2), ...
     theta_n(1) - i*theta_n(2))));
                mid(real(polyval(i*pderiv(Pu3, 'x') -i*pderiv(Pu3, 'y'), ...
     theta_n(1) + i*theta_n(2), ...
     theta_n(1) - i*theta_n(2))))];
 
 DPu_theta = [DPu_theta1, DPu_theta2];
 
 
 
 
 
 %Differential of Pu(z_n):
 DPs_tau = [mid(polyval(Ps1', tau_n));
              mid(polyval(Ps2', tau_n));
              mid(polyval(Ps3', tau_n))];
 
 
 DFx = zeros(3*K, 3*K);
 DFx(1:3, 1:2) = -DPu_theta;
 DFx(1:3, 3:5) = inv_henon3D_differential(xn(1:3), alpha, tau, a, b, c);
 
 
 Id = eye(3);
 for j = 2:Kmid
    DFx((3*j - 2):(3*j), (3*j-3):(3*j-1)) = -Id;
    DFx((3*j - 2):(3*j), (3*j):(3*j+2)) = ...
        inv_henon3D_differential(xn((3*j-2):(3*j)), alpha, tau, a, b, c);
 end
 for j = (Kmid+1):(K-1)
    DFx((3*j-2):(3*j), (3*j-3):(3*j-1)) = ...
        henon3D_differential(xn((3*(j-1)-2):(3*(j-1))) , alpha, tau, a, b, c);
    DFx((3*j-2):(3*j), (3*j):(3*j+2)) = -Id;
 end
 
 DFx((3*K - 2):(3*K), (3*K-3):(3*K-1)) = ...
     henon3D_differential(xn((3*(K-1) - 2):(3*(K-1))) , alpha, tau, a, b, c);
 DFx((3*K - 2):(3*K), 3*K) = -DPs_tau;           
      
 
 A = DFx;