function DF = DF_prod_delayHenon_intval(...
    theta_n, xn, tau_n, n_u, n_s, ...
    p, A, Pu, N, a, b, conjDataVect, dimNum)



K = n_u + n_s;
Kmid = ceil(K/2);

coDim = dimNum - 1;


for j = 2:N+1
    DPu(:, j-1) = (j-1)*Pu(:, j);
end


Pu_zn = intval(zeros(dimNum, 1));
for j = 1:dimNum
    Pu_zn(j) = horner(theta_n, Pu(j, :), N); 
end


%complexify variables:
complexTau = intval(zeros(dimNum-1,1));
k = 1;
while k <= dimNum-1
    thisConj = conjDataVect(k);
    if thisConj == 1
       complexTau(k) = tau_n(k); 
       k = k+1;
    else
      complexTau(k) = tau_n(k) + i*tau_n(k+1);
      complexTau(k+1) = tau_n(k) - i*tau_n(k+1);
      k = k+2;
    end
end

Ps_xn = real(p + A*complexTau);


%Differential of Pu(z_n):
DPu_theta = intval(zeros(dimNum, 1));
for j = 1:dimNum
DPu_theta(j) = horner(theta_n, DPu(j,:), N-1);
end

%Differential of Ps(theta_n):
DPs_tauComplex = A;
 
%Real Differential:
DPs_tau = intval(zeros(dimNum, dimNum-1));
k = 1;
while k <= dimNum-1
    thisConj = conjDataVect(k);
    if thisConj == 1
       DPs_tau(:, k) = A(:, k); 
       k = k+1;
    else
      DPs_tau(:, k) = 2*real(A(:,k));
      DPs_tau(:, k+1) = -2*imag(A(:, k));
      k = k+2;
    end
end

 

%=========== Construct the Differential ===================================

DFx = intval(zeros(dimNum*K, dimNum*(K-1)));


DFx(1:dimNum, 1:dimNum) = ...
    henonLikeDifferential_inv_intval(xn(1:dimNum), a, b, dimNum); 
 
 
 Id = intval(eye(dimNum));
 for j = 2:Kmid
     
    DFx(dimNum*j - coDim:dimNum*j,dimNum*(j-1) -coDim:dimNum*(j-1)) = -Id;
    DFx(dimNum*j - coDim:dimNum*j, dimNum*j -coDim:dimNum*j) = ...
        henonLikeDifferential_inv_intval(xn(dimNum*j-coDim:dimNum*j), a, b, dimNum); 
 end
 for j = (Kmid+1):(K-1)
     
    DFx((dimNum*j-coDim):(dimNum*j), dimNum*(j-1) -coDim:dimNum*(j-1)) = ...
        henonLikeDifferential_intval(xn(dimNum*(j-1)-coDim:dimNum*(j-1)), a, b, dimNum);
    DFx(dimNum*j-coDim:dimNum*j, dimNum*j - coDim:dimNum*j) = -Id;
 end
  
DFx(dimNum*K-coDim:dimNum*K, dimNum*(K-1) - coDim: dimNum*(K-1)) =  ...
  henonLikeDifferential_intval(xn(dimNum*(K-1)-coDim:dimNum*(K-1)), a, b, dimNum);

 
DPu_theta_col = intval(zeros(dimNum*K, 1));
DPs_tau_col = intval(zeros(dimNum*K, 1:coDim));

DPu_theta_col(1:dimNum, 1) = -DPu_theta;
DPs_tau_col(dimNum*K - coDim:dimNum*K, 1:coDim) = -DPs_tau;


DF = [DPu_theta_col, DFx, DPs_tau_col];

 