function A = DF_prod_intval_6D(theta_n, ...
                      xn, ...
                      tau_n, ...
                      n_u, n_s, ...
                      Pu1, Pu2, Pu3, Pu4, Pu5, Pu6, ...
                      Ps1, Ps2, Ps3, Ps4, Ps5, Ps6, ...
                      alpha1, tau1, a1, b1, c1, ...
                      alpha2, tau2, a2, b2, c2, ...
                      epsilon);

                  
                  
                  

K = n_u + n_s;
Kmid = ceil(K/2);
 


%Image of theta_n under Ps:
 %Ps_xn = [horner(tau_n, A0s, order_1);
 %         horner(tau_n, B0s, order_1);
 %         horner(tau_n, C0s, order_1)];
 Ps_xn = [polyval(Ps1, tau_n(1), tau_n(2));
          polyval(Ps2, tau_n(1), tau_n(2));
          polyval(Ps3, tau_n(1), tau_n(2));
          polyval(Ps4, tau_n(1), tau_n(2));
          polyval(Ps5, tau_n(1), tau_n(2));
          polyval(Ps6, tau_n(1), tau_n(2))];
 
 
 %Image of z_n = (s_n, t_n) Pu:
 %Pu_zn = evaluate_complexCase(theta_n(1), theta_n(2), A0u, B0u, C0u, N);
 Pu_zn = [real(polyval(Pu1, theta_n(1)+i*theta_n(2), ...
                            theta_n(1)-i*theta_n(2), ...
                            theta_n(3)+i*theta_n(4), ...
                            theta_n(3)-i*theta_n(4)));
          real(polyval(Pu2, theta_n(1)+i*theta_n(2), ...
                            theta_n(1)-i*theta_n(2), ...
                            theta_n(3)+i*theta_n(4), ...
                            theta_n(3)-i*theta_n(4)));
          real(polyval(Pu3, theta_n(1)+i*theta_n(2), ...
                            theta_n(1)-i*theta_n(2), ...
                            theta_n(3)+i*theta_n(4), ...
                            theta_n(3)-i*theta_n(4)));
          real(polyval(Pu4, theta_n(1)+i*theta_n(2), ...
                            theta_n(1)-i*theta_n(2), ...
                            theta_n(3)+i*theta_n(4), ...
                            theta_n(3)-i*theta_n(4)));
          real(polyval(Pu5, theta_n(1)+i*theta_n(2), ...
                            theta_n(1)-i*theta_n(2), ...
                            theta_n(3)+i*theta_n(4), ...
                            theta_n(3)-i*theta_n(4)));
          real(polyval(Pu6, theta_n(1)+i*theta_n(2), ...
                            theta_n(1)-i*theta_n(2), ...
                            theta_n(3)+i*theta_n(4), ...
                            theta_n(3)-i*theta_n(4)))];
 
 
%Differential of Pu(theta_n):
 

 DPu_theta1 = [ ...
     real(polyval(pderiv(Pu1, 'w') + pderiv(Pu1, 'x'), ...
        theta_n(1) + i*theta_n(2), theta_n(1) - i*theta_n(2), ...
        theta_n(3) + i*theta_n(4), theta_n(3) - i*theta_n(4)));
     real(polyval(pderiv(Pu2, 'w') + pderiv(Pu2, 'x'), ...
        theta_n(1) + i*theta_n(2), theta_n(1) - i*theta_n(2), ...
        theta_n(3) + i*theta_n(4), theta_n(3) - i*theta_n(4)));
     real(polyval(pderiv(Pu3, 'w') + pderiv(Pu3, 'x'), ...
        theta_n(1) + i*theta_n(2), theta_n(1) - i*theta_n(2), ...
        theta_n(3) + i*theta_n(4), theta_n(3) - i*theta_n(4)));
     real(polyval(pderiv(Pu4, 'w') + pderiv(Pu4, 'x'), ...
        theta_n(1) + i*theta_n(2), theta_n(1) - i*theta_n(2), ...
        theta_n(3) + i*theta_n(4), theta_n(3) - i*theta_n(4)));
     real(polyval(pderiv(Pu5, 'w') + pderiv(Pu5, 'x'), ...
        theta_n(1) + i*theta_n(2), theta_n(1) - i*theta_n(2), ...
        theta_n(3) + i*theta_n(4), theta_n(3) - i*theta_n(4)));
     real(polyval(pderiv(Pu6, 'w') + pderiv(Pu6, 'x'), ...
        theta_n(1) + i*theta_n(2), theta_n(1) - i*theta_n(2), ...
        theta_n(3) + i*theta_n(4), theta_n(3) - i*theta_n(4)))];


DPu_theta2 = [ ...
     real(polyval(i*pderiv(Pu1, 'w') - i*pderiv(Pu1, 'x'), ...
        theta_n(1) + i*theta_n(2), theta_n(1) - i*theta_n(2), ...
        theta_n(3) + i*theta_n(4), theta_n(3) - i*theta_n(4)));
     real(polyval(i*pderiv(Pu2, 'w') - i*pderiv(Pu2, 'x'), ...
        theta_n(1) + i*theta_n(2), theta_n(1) - i*theta_n(2), ...
        theta_n(3) + i*theta_n(4), theta_n(3) - i*theta_n(4)));
     real(polyval(i*pderiv(Pu3, 'w') - i*pderiv(Pu3, 'x'), ...
        theta_n(1) + i*theta_n(2), theta_n(1) - i*theta_n(2), ...
        theta_n(3) + i*theta_n(4), theta_n(3) - i*theta_n(4)));
     real(polyval(i*pderiv(Pu4, 'w') - i*pderiv(Pu4, 'x'), ...
        theta_n(1) + i*theta_n(2), theta_n(1) - i*theta_n(2), ...
        theta_n(3) + i*theta_n(4), theta_n(3) - i*theta_n(4)));
     real(polyval(i*pderiv(Pu5, 'w') - i*pderiv(Pu5, 'x'), ...
        theta_n(1) + i*theta_n(2), theta_n(1) - i*theta_n(2), ...
        theta_n(3) + i*theta_n(4), theta_n(3) - i*theta_n(4)));
     real(polyval(i*pderiv(Pu6, 'w') - i*pderiv(Pu6, 'x'), ...
        theta_n(1) + i*theta_n(2), theta_n(1) - i*theta_n(2), ...
        theta_n(3) + i*theta_n(4), theta_n(3) - i*theta_n(4)))];


    
   
 DPu_theta3 = [ ...
     real(polyval(pderiv(Pu1, 'y') + pderiv(Pu1, 'z'), ...
        theta_n(1) + i*theta_n(2), theta_n(1) - i*theta_n(2), ...
        theta_n(3) + i*theta_n(4), theta_n(3) - i*theta_n(4)));
     real(polyval(pderiv(Pu2, 'y') + pderiv(Pu2, 'z'), ...
        theta_n(1) + i*theta_n(2), theta_n(1) - i*theta_n(2), ...
        theta_n(3) + i*theta_n(4), theta_n(3) - i*theta_n(4)));
     real(polyval(pderiv(Pu3, 'y') + pderiv(Pu3, 'z'), ...
        theta_n(1) + i*theta_n(2), theta_n(1) - i*theta_n(2), ...
        theta_n(3) + i*theta_n(4), theta_n(3) - i*theta_n(4)));
     real(polyval(pderiv(Pu4, 'y') + pderiv(Pu4, 'z'), ...
        theta_n(1) + i*theta_n(2), theta_n(1) - i*theta_n(2), ...
        theta_n(3) + i*theta_n(4), theta_n(3) - i*theta_n(4)));
     real(polyval(pderiv(Pu5, 'y') + pderiv(Pu5, 'z'), ...
        theta_n(1) + i*theta_n(2), theta_n(1) - i*theta_n(2), ...
        theta_n(3) + i*theta_n(4), theta_n(3) - i*theta_n(4)));
     real(polyval(pderiv(Pu6, 'y') + pderiv(Pu6, 'z'), ...
        theta_n(1) + i*theta_n(2), theta_n(1) - i*theta_n(2), ...
        theta_n(3) + i*theta_n(4), theta_n(3) - i*theta_n(4)))];


DPu_theta4 = [ ...
     real(polyval(i*pderiv(Pu1, 'y') - i*pderiv(Pu1, 'z'), ...
        theta_n(1) + i*theta_n(2), theta_n(1) - i*theta_n(2), ...
        theta_n(3) + i*theta_n(4), theta_n(3) - i*theta_n(4)));
     real(polyval(i*pderiv(Pu2, 'y') - i*pderiv(Pu2, 'z'), ...
        theta_n(1) + i*theta_n(2), theta_n(1) - i*theta_n(2), ...
        theta_n(3) + i*theta_n(4), theta_n(3) - i*theta_n(4)));
     real(polyval(i*pderiv(Pu3, 'y') - i*pderiv(Pu3, 'z'), ...
        theta_n(1) + i*theta_n(2), theta_n(1) - i*theta_n(2), ...
        theta_n(3) + i*theta_n(4), theta_n(3) - i*theta_n(4)));
     real(polyval(i*pderiv(Pu4, 'y') - i*pderiv(Pu4, 'z'), ...
        theta_n(1) + i*theta_n(2), theta_n(1) - i*theta_n(2), ...
        theta_n(3) + i*theta_n(4), theta_n(3) - i*theta_n(4)));
     real(polyval(i*pderiv(Pu5, 'y') - i*pderiv(Pu5, 'z'), ...
        theta_n(1) + i*theta_n(2), theta_n(1) - i*theta_n(2), ...
        theta_n(3) + i*theta_n(4), theta_n(3) - i*theta_n(4)));
     real(polyval(i*pderiv(Pu6, 'y') - i*pderiv(Pu6, 'z'), ...
        theta_n(1) + i*theta_n(2), theta_n(1) - i*theta_n(2), ...
        theta_n(3) + i*theta_n(4), theta_n(3) - i*theta_n(4)))];

      
    
 DPu_theta = [DPu_theta1, DPu_theta2, DPu_theta3, DPu_theta4];
 
 %Differential of Ps(tau_n):
 
 DPs_tau1 = [polyval(pderiv(Ps1, 'x'), tau_n(1), tau_n(2));
             polyval(pderiv(Ps2, 'x'), tau_n(1), tau_n(2));
             polyval(pderiv(Ps3, 'x'), tau_n(1), tau_n(2));
             polyval(pderiv(Ps4, 'x'), tau_n(1), tau_n(2));
             polyval(pderiv(Ps5, 'x'), tau_n(1), tau_n(2));
             polyval(pderiv(Ps6, 'x'), tau_n(1), tau_n(2))];


 DPs_tau2 = [polyval(pderiv(Ps1, 'y'), tau_n(1), tau_n(2));
             polyval(pderiv(Ps2, 'y'), tau_n(1), tau_n(2));
             polyval(pderiv(Ps3, 'y'), tau_n(1), tau_n(2));
             polyval(pderiv(Ps4, 'y'), tau_n(1), tau_n(2));
             polyval(pderiv(Ps5, 'y'), tau_n(1), tau_n(2));
             polyval(pderiv(Ps6, 'y'), tau_n(1), tau_n(2))];

  
 DPs_tau = [DPs_tau1, DPs_tau2]
 
 
 DFx = intval(zeros(6*K, 6*K));
 DFx(1:6, 1:4) = -DPu_theta;
 DFx(1:6, 5:10) = inv_henon6D_differential_intval(xn(1:6), ...
                                           alpha1, tau1, a1, b1, c1, ...
                                           alpha2, tau2, a2, b2, c2, ...
                                           epsilon);
           
          
 
 Id = intval(eye(6));
 for j = 2:Kmid
    DFx((6*j - 5):(6*j), (6*j-7):(6*j-2)) = -Id;
    
    DFx((6*j - 5):(6*j), (6*j-1):(6*j+4)) = ...
        inv_henon6D_differential_intval(xn((6*j-5):(6*j)), ...
                                 alpha1, tau1, a1, b1, c1, ...
                                 alpha2, tau2, a2, b2, c2, ...
                                 epsilon); 
 end
 for j = (Kmid+1):(K-1)
    DFx((6*j-5):(6*j), (6*j-7):(6*j-2)) = ...
        henon6D_differential_intval(xn((6*(j-1)-5):(6*(j-1))), ...
                             alpha1, tau1, a1, b1, c1, ...
                             alpha2, tau2, a2, b2, c2, ...
                             epsilon);
    
    DFx((6*j-5):(6*j), (6*j-1):(6*j+4)) = -Id;
 end
 
 
 DFx((6*K - 5):(6*K), (6*K-7):(6*K-2)) = ...
     henon6D_differential_intval(xn((6*(K-1) - 5):(6*(K-1))), ...
                          alpha1, tau1, a1, b1, c1, ...
                          alpha2, tau2, a2, b2, c2, ...
                          epsilon);
                      
 DFx((6*K - 5):(6*K), (6*K-1):(6*K)) = -DPs_tau;  
 
 
 A = DFx;
 
 
 
 
 
 
 
 