function D = Dfinvk_circ_P_1D(k, x, A, B, C, N, alpha, tau, a, b, c);

%Note that by the chain rule:
%
%  D[f^n o P](x) =  [Df]|_{f^(n-1) o P (x)}  o ...
%                         ... o [Df]|_{P(x)} o [d/dx P]
%

%Need innermost terms for Chain Rule.
P_x = [horner(x, A, N);
       horner(x, B, N);
       horner(x, C, N)];
    
DP_at_x = evaluate_differential_1D(x, A, B, C, N);
Df_at_Px = inv_henon3D_differential(P_x, alpha, tau, a, b, c);

%Chain Rule for D[f o P](s,t):
D_of_f_circ_P_at_x = Df_at_Px*DP_at_x;

%Initialize Loop variable:
Differential = D_of_f_circ_P_at_x;

%Apply the chain rule iteratively to 
%compute D[f^k o P](s,t):
for n = 2:k
   %Evaluate z = [f^{n-1} o P](s,t):
   fn_minusOne_circP = ...
       inverse_iterate_point_k(P_x, n-1, alpha, tau, a, b, c);
   %evaluate Df at z:
   Df_at_fn_minusOne_circP = ...
       inv_henon3D_differential(fn_minusOne_circP, alpha, tau, a, b, c);
   %Chain Rule: compose with previous stuff:
   Differential = Df_at_fn_minusOne_circP*Differential;  
end

D = Differential;





