function D = Dfk_circ_P(k, s,t, A, B, C, N, alpha, tau, a, b, c);

%Note that by the chain rule:
%
%  D[f^n o P](s,t) =  [Df]|_{f^(n-1) o P (s,t)}  o ...
%                         ... o [Df]|_{P(s,t)} o [DP]|_(s,t)
%

%Need innermost terms for Chain Rule.
P_st = evaluate_complexCase(s, t, A, B, C, N);
DP_at_st = evaluate_jacob_complexCase(s, t, A, B, C, N);
Df_at_Pst = henon3D_differential(P_st, alpha, tau, a, b, c);

%Chain Rule for D[f o P](s,t):
D_of_f_circ_P_at_st = Df_at_Pst*DP_at_st;

Differential = D_of_f_circ_P_at_st;

%Apply the chain rule iteratively to 
%compute D[f^k o P](s,t):
for n = 2:k
   %Evaluate z = [f^{n-1} o P](s,t):
   fn_minusOne_circP = iterate_point_k(P_st, n-1, alpha, tau, a, b, c);
   %evaluate Df at z:
   Df_at_fn_minusOne_circP = ...
       henon3D_differential(fn_minusOne_circP, alpha, tau, a, b, c);
   %Chain Rule: compose with previous stuff:
   Differential = Df_at_fn_minusOne_circP*Differential;  
end    

D = Differential;