function f = Error_intval_4D6D(A, B, C, D, E, F, ...
                               alpha1, tau1, a1, b1, c1, ...
                               alpha2, tau2, a2, b2, c2, ...
                               epsilon, ...
                               lambda_1, ...
                               lambda_2, ...
                               lambda_3, ...
                               lambda_4, ...
                               N, ...
                               r);

                                                               
x1_plus =  (1/2)*(-tau1 + sqrt( tau1^2 - 4*alpha1));
x1_minus = (1/2)*(-tau1 - sqrt( tau1^2 - 4*alpha1));

x2_plus =  (1/2)*(-tau2 + sqrt( tau2^2 - 4*alpha2));
x2_minus = (1/2)*(-tau2 - sqrt( tau2^2 - 4*alpha2));
      


fA = alpha1 + tau1*A + C + a1*A*A + b1*A*B + c1*B*B + ...
              epsilon*(E - x2_plus)*(E - x2_minus);
fB = A;
fC = B;

fD = alpha2 + tau2*D + F + a2*D*D + b2*D*E + c2*E*E + ...
              epsilon*(B - x1_plus)*(B - x1_minus);
fE = D;
fF = E;


[A_lambda, B_lambda, C_lambda, ...
 D_lambda, E_lambda, F_lambda] = ...
           compose_P_lambda_intval_4D6D(N, A, B, C, D, E, F, ...
                                        lambda_1, lambda_2, ...
                                        lambda_3, lambda_4);


                                    
E1 = mag(fA - A_lambda);
E2 = mag(fB - B_lambda);
E3 = mag(fC - C_lambda);
E4 = mag(fD - D_lambda);
E5 = mag(fE - E_lambda);
E6 = mag(fF - F_lambda);


error1 = polyval(E1, r, r, r, r);
error2 = polyval(E2, r, r, r, r);
error3 = polyval(E3, r, r, r, r);
error4 = polyval(E4, r, r, r, r);
error5 = polyval(E5, r, r, r, r);
error6 = polyval(E6, r, r, r, r);



f = max([sup(error1), sup(error2), sup(error3), ...
         sup(error4), sup(error5), sup(error6)]);

