function F_out = F_prod_delayHenon(...
    theta_n, xn, tau_n, n_u, n_s, ...
    p, A, Pu, N, a, b, conjDataVect, dimNum)



K = n_u + n_s;
Kmid = ceil(K/2);

coDim = dimNum - 1;

Pu_zn = zeros(dimNum, 1);
for j = 1:dimNum
    Pu_zn(j) = horner(theta_n, Pu(j, :), N); 
end


%complexify variables:
complexTau = zeros(dimNum-1,1);
k = 1;
while k <= dimNum-1
    thisConj = conjDataVect(k);
    if thisConj == 1
       complexTau(k) = tau_n(k); 
       k = k+1;
    else
      complexTau(k) = tau_n(k) + i*tau_n(k+1);
      complexTau(k+1) = tau_n(k) - i*tau_n(k+1);
      k = k+2;
    end
end

Ps_xn = real(p + A*complexTau);

 
 
%==============Evaluate F ================================================
Fx(1:dimNum) = henonLikeMap_inv(xn(1:dimNum), a, b, dimNum) - Pu_zn;
 

 
 for j = 2:Kmid
    Fx(dimNum*j - coDim:dimNum*j) = ...
        henonLikeMap_inv(xn(dimNum*j - coDim:dimNum*j), a, b, dimNum) ...
        - xn(dimNum*(j-1)-coDim:dimNum*(j-1));    
 end
 for j = (Kmid+1):(K-1)
    Fx(dimNum*j - coDim:dimNum*j) = ...
        henonLikeMap(xn(dimNum*(j-1) - coDim:dimNum*(j-1)), a, b, dimNum)...
        - xn(dimNum*j - coDim:dimNum*j);
 end
 
 Fx((dimNum*K - coDim):(dimNum*K)) = ...
     henonLikeMap(xn((dimNum*(K-1) - coDim):(dimNum*(K-1))), a, b, dimNum) ...
     -  Ps_xn;
  
F_out = Fx; 

