function varargout = F_prod_intval(theta_n, xn, tau_n, n_u, n_s, ...
    Pu1, Pu2, Pu3, Ps1, Ps2, Ps3, alpha, tau, a, b, c)


K = n_u + n_s;
Kmid = ceil(K/2);
 
 %Image of theta_n under Ps:
 %Ps_xn = [horner(tau_n, A0s, order_1);
 %         horner(tau_n, B0s, order_1);
 %         horner(tau_n, C0s, order_1)];
 Ps_xn = [polyval(Ps1, tau_n);
          polyval(Ps2, tau_n);
          polyval(Ps3, tau_n)];
 
 
 %Image of z_n = (s_n, t_n) Pu:
 %Pu_zn = evaluate_complexCase(theta_n(1), theta_n(2), A0u, B0u, C0u, N);
 Pu_zn = [real(polyval(Pu1, theta_n(1)+i*theta_n(2), theta_n(1)-i*theta_n(2)));
          real(polyval(Pu2, theta_n(1)+i*theta_n(2), theta_n(1)-i*theta_n(2)));
          real(polyval(Pu3, theta_n(1)+i*theta_n(2), theta_n(1)-i*theta_n(2)))];
 
 
      
 Fx(1:3) = inv_henon3D_intval(xn(1:3), alpha, tau, a, b, c) - Pu_zn;
 
 for j = 2:Kmid
    Fx((3*j - 2):(3*j)) = ...
          inv_henon3D_intval(xn((3*j-2):(3*j)), alpha, tau, a, b, c) - xn((3*j-5):(3*j-3)); 
 end
 for j = (Kmid+1):(K-1)
    Fx((3*j - 2):(3*j)) = ...
        henon3D_intval(xn((3*(j-1)-2):(3*(j-1))), alpha, tau, a, b, c) - xn((3*j - 2):(3*j)); 
 end
 

Fx((3*K - 2):(3*K)) = henon3D_intval(xn((3*(K-1) - 2):(3*(K-1))), alpha, tau, a, b, c) -  Ps_xn;
 
       
varargout(1,1)={[Fx(1:2)]};
varargout(2,1)= {Fx(3:(3*K-1))};
varargout(3,1)={Fx(3*K)};








