function varargout = F_prod_intval_6D(...
            theta_n, ...
            xn, ...
            tau_n, ...
            n_u, n_s, ...
            Pu1, Pu2, Pu3, Pu4, Pu5, Pu6, ...
            Ps1, Ps2, Ps3, Ps4, Ps5, Ps6, ...
            alpha1, tau1, a1, b1, c1, ...
            alpha2, tau2, a2, b2, c2, ...
            epsilon)


K = n_u + n_s;
Kmid = ceil(K/2);
 
 %Image of theta_n under Ps:
 %Ps_xn = [horner(tau_n, A0s, order_1);
 %         horner(tau_n, B0s, order_1);
 %         horner(tau_n, C0s, order_1)];
 Ps_xn = [polyval(Ps1, tau_n(1), tau_n(2));
          polyval(Ps2, tau_n(1), tau_n(2));
          polyval(Ps3, tau_n(1), tau_n(2));
          polyval(Ps4, tau_n(1), tau_n(2));
          polyval(Ps5, tau_n(1), tau_n(2));
          polyval(Ps6, tau_n(1), tau_n(2))];
 
 
 %Image of z_n = (s_n, t_n) Pu:
 %Pu_zn = evaluate_complexCase(theta_n(1), theta_n(2), A0u, B0u, C0u, N);
 Pu_zn = [real(polyval(Pu1, theta_n(1)+i*theta_n(2), ...
                            theta_n(1)-i*theta_n(2), ...
                            theta_n(3)+i*theta_n(4), ...
                            theta_n(3)-i*theta_n(4)));
          real(polyval(Pu2, theta_n(1)+i*theta_n(2), ...
                            theta_n(1)-i*theta_n(2), ...
                            theta_n(3)+i*theta_n(4), ...
                            theta_n(3)-i*theta_n(4)));
          real(polyval(Pu3, theta_n(1)+i*theta_n(2), ...
                            theta_n(1)-i*theta_n(2), ...
                            theta_n(3)+i*theta_n(4), ...
                            theta_n(3)-i*theta_n(4)));
          real(polyval(Pu4, theta_n(1)+i*theta_n(2), ...
                            theta_n(1)-i*theta_n(2), ...
                            theta_n(3)+i*theta_n(4), ...
                            theta_n(3)-i*theta_n(4)));
          real(polyval(Pu5, theta_n(1)+i*theta_n(2), ...
                            theta_n(1)-i*theta_n(2), ...
                            theta_n(3)+i*theta_n(4), ...
                            theta_n(3)-i*theta_n(4)));
          real(polyval(Pu6, theta_n(1)+i*theta_n(2), ...
                            theta_n(1)-i*theta_n(2), ...
                            theta_n(3)+i*theta_n(4), ...
                            theta_n(3)-i*theta_n(4)))];
 
 
 
 Fx(1:6) = inv_henon6D_intval(xn(1:6), ...
                              alpha1, tau1, a1, b1, c1, ...
                              alpha2, tau2, a2, b2, c2, ...
                              epsilon) ...
                              - Pu_zn;
 
 
 Id = intval(eye(6));
 
 for j = 2:Kmid
    Fx((6*j - 5):(6*j)) = ...
          inv_henon6D_intval(xn((6*j-5):(6*j)), ...
                             alpha1, tau1, a1, b1, c1, ...
                             alpha2, tau2, a2, b2, c1, ...
                             epsilon)' ...
                             - xn((6*j-11):(6*j-6));
 end
 for j = (Kmid+1):(K-1)
    Fx((6*j - 5):(6*j)) = ...
        henon6D_intval(xn((6*(j-1)-5):(6*(j-1))), ...
                       alpha1, tau1, a1, b1, c1, ...
                       alpha2, tau2, a2, b2, c2, ...
                       epsilon)' ...
                       - xn((6*j - 5):(6*j));            
 end
 
 
 Fx((6*K - 5):(6*K)) = henon6D_intval(xn((6*(K-1) - 5):(6*(K-1))), ...
                                      alpha1, tau1, a1, b1, c1, ...
                                      alpha2, tau2, a2, b2, c2, ...
                                      epsilon) ...
                                      -  Ps_xn;
                       
  
                                  
varargout(1,1)={[Fx(1:4)]};
varargout(2,1)= {Fx(5:(6*K-2))};
varargout(3,1)={Fx((6*K-1):(6*K))};

