function varargout=P_composition_gamma(N, K, A, B, C, alpha, beta);


[a, b] = complexSeriesPowers(N, K, alpha, beta);
[c, d] = complexSeriesPowers(N, K, alpha, -beta);

x_P1 = real(A);
y_P1 = imag(A);

x_P2 = real(B);
y_P2 = imag(B);

x_P3 = real(C);
y_P3 = imag(C);


sum1_P1 = 0;
sum2_P1 = 0;
sum3_P1 = 0;

sum1_P2 = 0;
sum2_P2 = 0;
sum3_P2 = 0;

sum1_P3 = 0;
sum2_P3 = 0;
sum3_P3 = 0;

for (m = 2:N) 
    sum1_P1 = sum1_P1 + x_P1(m+1, 1)*a(1, m+1) - y_P1(m+1, 1)*b(1, m+1) + ...
                        x_P1(m+1, 2)*(a(1, m+1)*alpha(1) + b(1, m+1)*beta(1)) - ...
                        y_P1(m+1, 2)*(b(1, m+1)*alpha(1) - a(1, m+1)*beta(1));
    
    sum1_P2 = sum1_P2 + x_P2(m+1, 1)*a(1, m+1) - y_P2(m+1, 1)*b(1, m+1) + ...
                        x_P2(m+1, 2)*(a(1, m+1)*alpha(1) + b(1, m+1)*beta(1)) - ...
                        y_P2(m+1, 2)*(b(1, m+1)*alpha(1) - a(1, m+1)*beta(1));
    
    sum1_P3 = sum1_P3 + x_P3(m+1, 1)*a(1, m+1) - y_P3(m+1, 1)*b(1, m+1) + ...
                        x_P3(m+1, 2)*(a(1, m+1)*alpha(1) + b(1, m+1)*beta(1)) - ...
                        y_P3(m+1, 2)*(b(1, m+1)*alpha(1) - a(1, m+1)*beta(1));
end 

for (n = 2:N) 
    sum2_P1 = sum2_P1 + x_P1(1, n+1)*c(1, n+1) - y_P1(1, n+1)*d(1, n+1) + ...
                        x_P1(2, n+1)*(c(1, n+1)*alpha(1) - d(1, n+1)*beta(1)) - ...
                        y_P1(2, n+1)*(c(1, n+1)*beta(1) + d(1, n+1)*alpha(1));
    
    sum2_P2 = sum2_P2 + x_P2(1, n+1)*c(1, n+1) - y_P2(1, n+1)*d(1, n+1) + ...
                        x_P2(2, n+1)*(c(1, n+1)*alpha(1) - d(1, n+1)*beta(1)) - ...
                        y_P2(2, n+1)*(c(1, n+1)*beta(1) + d(1, n+1)*alpha(1));
    
    sum2_P3 = sum2_P3 + x_P3(1, n+1)*c(1, n+1) - y_P3(1, n+1)*d(1, n+1) + ...
                        x_P3(2, n+1)*(c(1, n+1)*alpha(1) - d(1, n+1)*beta(1)) - ...
                        y_P3(2, n+1)*(c(1, n+1)*beta(1) + d(1, n+1)*alpha(1));
end   


for (n = 2:N) 
     for (m = 2:N) 
        sum3_P1 = sum3_P1 + x_P1(m+1, n+1)*(a(1, m+1)*c(1, n+1) - b(1, m+1)*d(1, n+1)) - ...
                            y_P1(m+1, n+1)*(a(1, m+1)*d(1, n+1) + b(1, m+1)*c(1, n+1));
        
        sum3_P2 = sum3_P2 + x_P2(m+1, n+1)*(a(1, m+1)*c(1, n+1) - b(1, m+1)*d(1, n+1)) - ...
                            y_P2(m+1, n+1)*(a(1, m+1)*d(1, n+1) + b(1, m+1)*c(1, n+1));
        
        sum3_P3 = sum3_P3 + x_P3(m+1, n+1)*(a(1, m+1)*c(1, n+1) - b(1, m+1)*d(1, n+1)) - ...
                            y_P3(m+1, n+1)*(a(1, m+1)*d(1, n+1) + b(1, m+1)*c(1, n+1));
                        
    end
end   

c_P1 = x_P1(1,1) + 2*x_P1(2,1)*alpha(1) + 2*y_P1(1,2)*beta(1) + x_P1(2,2)*(alpha(1)^2 + beta(1)^2);
c_P2 = x_P2(1,1) + 2*x_P2(2,1)*alpha(1) + 2*y_P2(1,2)*beta(1) + x_P2(2,2)*(alpha(1)^2 + beta(1)^2);
c_P3 = x_P3(1,1) + 2*x_P3(2,1)*alpha(1) + 2*y_P3(1,2)*beta(1) + x_P3(2,2)*(alpha(1)^2 + beta(1)^2);

P1(1) = c_P1 + sum1_P1 + sum2_P1 + sum3_P1;
P2(1) = c_P2 + sum1_P2 + sum2_P2 + sum3_P2;
P3(1) = c_P3 + sum1_P3 + sum2_P3 + sum3_P3;


for (j = 1:K) 
    
    c_P1 = 2*x_P1(1,2)*alpha(j+1) + 2*y_P1(1,2)*beta(j+1);
    c_P2 = 2*x_P2(1,2)*alpha(j+1) + 2*y_P2(1,2)*beta(j+1);
    c_P3 = 2*x_P3(1,2)*alpha(j+1) + 2*y_P3(1,2)*beta(j+1);
    
    sum1_P1 = 0;
    sum2_P1 = 0;
    sum3_P1 = 0;

    sum1_P2 = 0;
    sum2_P2 = 0;
    sum3_P2 = 0;

    sum1_P3 = 0;
    sum2_P3 = 0;
    sum3_P3 = 0;
    
    sum_kP1 = 0;
    sum_kP2 = 0;
    sum_kP3 = 0;
    
    for (k = 0:j)
        sum_kP1 = sum_kP1 + x_P1(2, 2)*(alpha(k+1)*alpha(j-k+1) + beta(k+1)*beta(j-k+1)) - ...
                            y_P1(2, 2)*(beta(k+1)*alpha(j-k+1) - alpha(k+1)*beta(j-k+1));
                        
        sum_kP2 = sum_kP2 + x_P2(2, 2)*(alpha(k+1)*alpha(j-k+1) + beta(k+1)*beta(j-k+1)) - ...
                            y_P2(2, 2)*(beta(k+1)*alpha(j-k+1) - alpha(k+1)*beta(j-k+1));
                        
        sum_kP3 = sum_kP3 + x_P3(2, 2)*(alpha(k+1)*alpha(j-k+1) + beta(k+1)*beta(j-k+1)) - ...
                            y_P3(2, 2)*(beta(k+1)*alpha(j-k+1) - alpha(k+1)*beta(j-k+1));
    end    
    
    for (m = 2:N) 
        sum1_P1 = sum1_P1 + x_P1(m+1, 1)*a(j+1, m+1) - y_P1(m+1, 1)*b(j+1, m+1);
        sum1_P2 = sum1_P2 + x_P2(m+1, 1)*a(j+1, m+1) - y_P2(m+1, 1)*b(j+1, m+1);
        sum1_P3 = sum1_P3 + x_P3(m+1, 1)*a(j+1, m+1) - y_P3(m+1, 1)*b(j+1, m+1);
        
        for (k = 0:j)
            sum1_P1 = sum1_P1 + x_P1(m+1, 2)*(a(k+1, m+1)*alpha(j-k+1) + b(k+1, m+1)*beta(j-k+1)) - ...
                                y_P1(m+1, 2)*(b(k+1, m+1)*alpha(j-k+1) - a(k+1, m+1)*beta(j-k+1));
                            
            sum1_P2 = sum1_P2 + x_P2(m+1, 2)*(a(k+1, m+1)*alpha(j-k+1) + b(k+1, m+1)*beta(j-k+1)) - ...
                                y_P2(m+1, 2)*(b(k+1, m+1)*alpha(j-k+1) - a(k+1, m+1)*beta(j-k+1));
            
            sum1_P3 = sum1_P3 + x_P3(m+1, 2)*(a(k+1, m+1)*alpha(j-k+1) + b(k+1, m+1)*beta(j-k+1)) - ...
                                y_P3(m+1, 2)*(b(k+1, m+1)*alpha(j-k+1) - a(k+1, m+1)*beta(j-k+1));
        end
        
    end


    for (n = 2:N)
        sum2_P1 = sum2_P1 + x_P1(1, n+1)*c(j+1, n+1) - y_P1(1, n+1)*d(j+1, n+1);
        sum2_P2 = sum2_P2 + x_P2(1, n+1)*c(j+1, n+1) - y_P2(1, n+1)*d(j+1, n+1);
        sum2_P3 = sum2_P3 + x_P3(1, n+1)*c(j+1, n+1) - y_P3(1, n+1)*d(j+1, n+1);
        
        for (k = 0:j)
            sum2_P1 = sum2_P1 + x_P1(2, n+1)*(c(k+1, n+1)*alpha(j-k+1) - d(k+1, n+1)*beta(j-k+1)) - ...
                                y_P1(2, n+1)*(c(k+1, n+1)*beta(j-k+1) + d(k+1, n+1)*alpha(j-k+1));
                            
            sum2_P2 = sum2_P2 + x_P2(2, n+1)*(c(k+1, n+1)*alpha(j-k+1) - d(k+1, n+1)*beta(j-k+1)) - ...
                                y_P2(2, n+1)*(c(k+1, n+1)*beta(j-k+1) + d(k+1, n+1)*alpha(j-k+1));
            
            sum2_P3 = sum2_P3 + x_P3(2, n+1)*(c(k+1, n+1)*alpha(j-k+1) - d(k+1, n+1)*beta(j-k+1)) - ...
                                y_P3(2, n+1)*(c(k+1, n+1)*beta(j-k+1) + d(k+1, n+1)*alpha(j-k+1));
        end
        
    end   

    
    for (n = 2:N) 
        for (m = 2:N)            
            for (k = 0:j) 
                sum3_P1 = sum3_P1 + x_P1(m+1, n+1)*(a(k+1, m+1)*c(j-k+1, n+1) - b(k+1, m+1)*d(j-k+1, n+1)) - ...
                                    y_P1(m+1, n+1)*(a(k+1, m+1)*d(j-k+1, n+1) + b(k+1, m+1)*c(j-k+1, n+1));
                                
                sum3_P2 = sum3_P2 + x_P2(m+1, n+1)*(a(k+1, m+1)*c(j-k+1, n+1) - b(k+1, m+1)*d(j-k+1, n+1)) - ...
                                    y_P2(m+1, n+1)*(a(k+1, m+1)*d(j-k+1, n+1) + b(k+1, m+1)*c(j-k+1, n+1));
                
                sum3_P3 = sum3_P3 + x_P3(m+1, n+1)*(a(k+1, m+1)*c(j-k+1, n+1) - b(k+1, m+1)*d(j-k+1, n+1)) - ...
                                    y_P3(m+1, n+1)*(a(k+1, m+1)*d(j-k+1, n+1) + b(k+1, m+1)*c(j-k+1, n+1));
            end
        end   
    end

    P1(j+1) = c_P1 + sum_kP1 + sum1_P1 + sum2_P1 + sum3_P1;
    P2(j+1) = c_P2 + sum_kP2 + sum1_P2 + sum2_P2 + sum3_P2;
    P3(j+1) = c_P3 + sum_kP3 + sum1_P3 + sum2_P3 + sum3_P3;
end


%Return:
varargout(1,1)={P1};
varargout(2,1)={P2};
varargout(3,1)={P3};



