clear
format long

%startintlab


a = intval('1.6')
b = intval('0.1')

numDim = 6


[p_p, Dfp_p, lambda_p_u, Lambda, xi_p_u, Q, Q_inv, conjVectData] = ...
delayHenon_linearData_p(a, b, numDim);


%Stable eigenspace:                 
A = Q(:, 2:numDim);


%l_s and m_s count
l_s = 0;
m_s = 0;
k = 1;


while k <= numDim-1
    thisConj = conjVectData(k);
    if thisConj == 1
       l_s = l_s + 1; 
       k = k+1;
    else
      m_s = m_s + 1;
      k = k+2;
    end
end



%Plot Eigenvalues:
figure
hold on
plot(mid(real(lambda_p_u)), mid(imag(lambda_p_u)), 'bo')
for k = 1:numDim-1
    plot(mid(real(Lambda(k,k))), imag(mid(Lambda(k,k))), 'ro')
end

Radius = 1;
[circ_1, circ_2, circ_3] = cylinder(Radius,200);
plot(circ_1(1,:), circ_2(1,:), 'g')
plot(0, 0, 'k*')







orbitLength = 25000;
orbit = zeros(orbitLength, numDim);
thisPoint = rand(1, numDim);

orbit(1, 1:numDim) = thisPoint;

for k = 2:orbitLength
    thisPoint = henonLikeMap(thisPoint, mid(a), mid(b), numDim);
    orbit(k, 1:numDim) = thisPoint;
end



%figure
%hold on
%plot3(orbit(1000:orbitLength, 1), orbit(1000:orbitLength, 2), orbit(1000:orbitLength, 3), 'b.')


figure
hold on
plot(orbit(1000:orbitLength, 1), orbit(1000:orbitLength, 2), 'b.')



figure
hold on
plot(orbit(:, 1), 'g')








