clear
format long

%startintlab


a = intval('1.6')
b = intval('0.1')
numDim = 10

numIterates = 20
numPoints = 2000



N = 25

%==========================================================================
%  Linear Data Computation and Variable Assignment   
%==========================================================================



[p_p, Dfp_p, lambda_p_u, Lambda, xi_p_u, Q, Q_inv, conjVectData] = ...
delayHenon_linearData_p(a, b, numDim);


figure
hold on

plot(real(diag(mid(Lambda))), imag(diag(mid(Lambda))), 'ob')
plot(0, 0, '*k')



%Attractor Dynamics:


orbitLength = 25000;
orbit = zeros(orbitLength, numDim);
thisPoint = zeros(1, numDim);

orbit(1, 1:numDim) = thisPoint;

for k = 2:orbitLength
    thisPoint = henonLikeMap(thisPoint, mid(a), mid(b), numDim);
    orbit(k, 1:numDim) = thisPoint;
end



figure
hold on
plot3(orbit(1000:orbitLength, 1), orbit(1000:orbitLength, 2), orbit(1000:orbitLength, 3), 'b.')



%Stable eigenspace:
A = Q(:, 2:numDim);

%l_s and m_s count
l_s = 0;
m_s = 0;
k = 1;
while k <= numDim-1
    thisConj = conjVectData(k);
    if thisConj == 1
       l_s = l_s + 1; 
       k = k+1;
    else
      m_s = m_s + 1;
      k = k+2;
    end
end


%======== Validation of the low order (linear) approximation ============== 
%======= of the high dimensional (co-dimension one) stable manifold =======

s = intval(10^(-2));
epsilon_tol = intval(10^(-13));





[delta_s, nu_s, C_tilde, C_n, K_n, goodComputation] = ...
    validate_coDimOne_stable_henonLike(...
      Lambda, A, Q, Q_inv, s, epsilon_tol, a, b, numDim);
  

  
 delta_s
 nu_s
  

 
%Need to beat 10^11 
C_P2_test = ((intval('pi')^2*(2*l_s + 8*m_s)^2)/((nu_s^2)*(0.2^2)))*delta_s

C_P2_test2 = ((intval('pi')^2*(2*l_s + 8*m_s)^2)/((0.2^2)))



