clear
format long

%startintlab


a = intval('1.6')
b = intval('0.1')
numDim = 20

numIterates = 15
numPoints = 2000


N = 25


%=========================================================================
%
%=========================================================================


x_p = (b-1 + sqrt((1-b)^2 + 4*a))/(2*a);
x_m = (b-1 - sqrt((1-b)^2 + 4*a))/(2*a);

p_p = intval(zeros(numDim, 1));
p_m = intval(zeros(numDim, 1));

for i = 1:numDim
   p_p(i) = x_p;
   p_m(i) = x_m;
end


fp_test1 = sup(norm(p_p - henonLikeMap_intval(p_p, a, b, numDim)))
fp_test2 = sup(norm(p_m - henonLikeMap_intval(p_m, a, b, numDim)))


Dfp_p = henonLikeDifferential_intval(p_p, a, b, numDim);


[Q_float, Sigma] = eig(full(Dfp_p.mid));

Q = intval(zeros(numDim, numDim));
theEigs = intval(zeros(numDim, numDim-1));
Lambda = intval(zeros(numDim-1, numDim-1));

[lambda_temp, xi_temp] = ...
     verifyeig(Dfp_p, Sigma(1,1), Q_float(:,1));
Q(:,1) = real(xi_temp);
lambda_u = lambda_temp;


inLoop = 1
tic
for i = 2:numDim
    [lambda_temp, xi_temp] = verifyeig(Dfp_p, Sigma(i,i), Q_float(:,i));
    Lambda(i-1,i-1) = lambda_temp;
    theEigs(:,i-1) = xi_temp;
	Q(:,i) = xi_temp;      
end
compTime = toc

Q_inv = inv(Q);

eigsError = max(max(rad(theEigs)))
eigVectError = max(max(rad(Q)))
invQError = max(max(rad(Q_inv)))

numDim



lambda_p_u = lambda_u;
xi_p_u = real(Q(:, 1));
scale = 1;

[Pu] = oneDimManifold_intval_delayHenon(a, b, ...
    numDim, N, p_p, lambda_p_u, xi_p_u, scale);


theta = -1.2;
P_theta = intval(zeros(numDim, 1));
for k = 0:N;
        P_theta = P_theta + Pu(:, k+1)*theta^k; 
end

theta = lambda_p_u*theta;
P_theta_lambda = intval(zeros(numDim, 1));
for k = 0:N;
        P_theta_lambda = P_theta_lambda + Pu(:, k+1)*theta^k; 
end

error = norm(henonLikeMap(mid(P_theta), mid(a), mid(b), numDim) - mid(P_theta_lambda))


%stopNow = stopHere


%BRANCH 1
theThetas_right = linspace(0.25, mid(abs(lambda_p_u))*0.25, numPoints);
Wu_fd_right = zeros(numPoints, numDim);

for l = 1:numPoints
    P_theta = intval(zeros(numDim, 1));
    theta = theThetas_right(l);
    for k = 0:N
        P_theta = P_theta + Pu(:, k+1)*theta^k; 
        Wu_fd_right(l, :) = mid(P_theta');
    end
end


%BRANCH 2

theThetas_left = linspace(-0.25, -mid(abs(lambda_p_u))*0.25, numPoints);
Wu_fd_left = zeros(numPoints, numDim);

for l = 1:numPoints
    P_theta = intval(zeros(numDim, 1));
    theta = theThetas_left(l);
    for k = 0:N
        P_theta = P_theta + Pu(:, k+1)*theta^k; 
        Wu_fd_left(l, :) = mid(P_theta');
    end
end


minDist = 100

for k = 1:numPoints
   thisIterate_left = iterate_point_k_highDim(Wu_fd_left(k, :), ...
       numIterates, mid(a), mid(b), numDim);
   thisIterate_right = iterate_point_k_highDim(Wu_fd_right(k, :), ...
       numIterates, mid(a), mid(b), numDim);
    
   leftDist = norm(mid(p_p) - thisIterate_left, inf);
   rightDist = norm(mid(p_p) - thisIterate_right, inf);
   if (leftDist < minDist) & (leftDist < rightDist)
       bestParm = theThetas_left(k);
       bestFD_point = Wu_fd_left(k,:);
       bestSide = 0;
       bestDist = leftDist;
       minDist = leftDist;
       closestPoint = thisIterate_left;
   end
   if (rightDist < minDist) & (rightDist <= leftDist)
       bestParm = theThetas_right(k);
       bestFD_point = Wu_fd_right(k,:);
       bestSide = 1;
       bestDist = rightDist;
       minDist = rightDist;
       closestPoint = thisIterate_right;
   end
end


thisOrbit = [bestFD_point];
for k = 1:numIterates
    thisOrbitPoint = iterate_point_k_highDim(bestFD_point, ...
       k, mid(a), mid(b), numDim);
    thisOrbit = [thisOrbit; thisOrbitPoint'];
end

backIterates = 15
thisOribt2 = zeros(backIterates, numDim);



for k = 1:backIterates
    thisOrbitPoint = inverse_iterate_point_k_highDim(bestFD_point, ...
       k, mid(a), mid(b), numDim);
    thisOrbit2(backIterates - k + 1, :) = thisOrbitPoint';
end

thisOrbit = [thisOrbit2; thisOrbit];



%Project end-point onto stable manifold p + Q*tau
B = pinv(mid(Q(:, 2:numDim)));
tauBar_0 = B*(closestPoint - mid(p_p))



figure 
hold on
plot(thisOrbit(:, 1))
    

%figure 
%hold on 
%plot3(mid(p_p(1)), mid(p_p(2)), mid(p_p(numDim)), 'k*')
%plot3(Wu_fd_right(:, 1), Wu_fd_right(:,2), Wu_fd_right(:,numDim), 'g.')
%plot3(Wu_fd_left(:, 1), Wu_fd_left(:,2), Wu_fd_left(:,numDim), 'c.')
%plot3(thisOrbit(:, 1), thisOrbit(:,2), thisOrbit(:,numDim), 'b.')



[theta, tauBar, error] = homoclinicPoint_highDim(...
    bestParm, tauBar_0, numIterates - 1, 1, ...
    mid(Pu), mid(p_p), mid(Q), ...
    N, mid(a), mid(b), numDim);


bestFD_point'
pestPoint_proj = real(mid(p_p) + mid(Q(:, 2:numDim))*tauBar_0)
closestPoint


linearDist = norm(mid(p_p) - closestPoint, inf)
error













