


clear
format long

%-------------------- Step 1 ----------------------------------------------
%========= Classical Numerical Approximation ==============================
%--------------------------------------------------------------------------

x_now = 2
thisError = abs(x_now*x_now - 2)
k = 0

while thisError > 10^(-15) 
   x_now =  x_now - (1/(2*x_now))*(x_now*x_now - 2)
   thisError = abs(x_now*x_now - 2)
   k = k+1
end








%------------------- Step 2 -----------------------------------------------
%Validation:      Is there a true solution?  How right/wrong are we?
%--------------------------------------------------------------------------



x_0 = intval(x_now)     %Guess

int_1 = intval('1');
int_2 = intval('2');




epsilon = x_0*x_0 - int_2  %A-Posteriori Error/Defect



a = 1/(2*x_now)   %Approximate Inverse of differential



delta = abs(int_1 - a*int_2*x_0)  %Defect of approximate inverse



kappa = int_2  %Bound on second derivative of f.


%Quadratic Equaiton constants:
a_r = abs(a)*kappa
b_r = -(1-delta)
c_r = abs(a)*epsilon


%Solution of quadratic equation:
r_high = (-b_r + sqrt(b_r^2 - 4*a_r*c_r))/(2*a_r)
r_low = (-b_r - sqrt(b_r^2 - 4*a_r*c_r))/(2*a_r)



if sup(delta + abs(a)*kappa*r_low) < 1
    r = sup(r_low)
else
    computationFailed = 1
end

solutionInterval = midrad(x_now, r)

inf(solutionInterval)
sup(solutionInterval)


if inf(delta + abs(a)*kappa*r_high) < 1
    R = inf(r_high)
else
    upperIntervalTooLarge = 1
end

isolationInterval = midrad(x_now, R)







