    
clear
format long 


%intvalinit('FastIVmult')
intvalinit('SharpIVmult')


%=================================================================
%   
%
%
%
%================================================================



%==========================================================================
%Non-Rigorous Computation of Approximate Solution:
%==========================================================================



%==============================================================
%Computation Controls:
%==============================================================



%Map Parameter Set: Dullin to Lomeli Meiss.
   %Dullin Meiss Parms:
      a_dm = 1
      b_dm = 0.5
      c_dm = 0.5
            
      
      eps_dm = 5.5    %boundary near 6.182001
     %eps_dm = 0.32      %worked at 0.4
      mu_dm = -2.4
    
      
   %Convert to Lomeli:   
      a = c_dm
      b = b_dm - 2*c_dm
      c = c_dm + a_dm - b_dm
      
      tau =    2*a_dm*(3+mu_dm)/(2*a_dm - b_dm)
      alpha =  ((9+6*mu_dm+mu_dm^2)*a_dm - 4*eps_dm*a_dm^2 + ...
               4*eps_dm*a_dm*b_dm - eps_dm*b_dm^2)/(2*a_dm - b_dm)^2



%---for epsilon > 3.5-ish guess_tol ~ 10^(-1) is good.
%---for epsilon ~ 0.2 - 2 neew  guess_tol ~ 2.5 X 10^(-2)
%---what to do close to eps ~ 0.1?
guess_tol = 2.5*10^(-2) 



%Order of manifold computation:
  %Order of 2D manifolds:
  N = 25;
  %Order of 1D manifold computations 
  order_1 = 50;
   
   
%==========================================================================
%Generate zeroth and first order problem data:
%==========================================================================

[p0, p1, lambda0_s, lambda0_u1, lambda0_u2, ...
         lambda1_u, lambda1_s1, lambda1_s2, ...
         xi0_s, xi0_u1, xi0_u2, ...
         xi1_u, xi1_s1, xi1_s2] ...
     = firstOrderData_3DHenon(a, b, c, alpha, tau) 
  
 
 
%=====================================================================
%One-D Manifolds 
%=====================================================================

%Step 1: Compute 1D Coefficients:

scale_0s = 2;

[A0s, B0s, C0s] = oneDimManifold_3DHenon(a, b, c, alpha, tau, ...
     order_1, p0, lambda0_s, xi0_s, scale_0s);



domRad0s = 0.9
                      

%Step 3: Compute fundamental domain point clouds


%==========================================================================
%Two-D Manifolds:
%==========================================================================

%Step 1: Compute Coefficients:
scale_0u = 1.5;

[A0u, B0u, C0u] = twoDimManifold_3DHenon(a, b, c, alpha, tau, ...
    N, p0, lambda0_u1, lambda0_u2, xi0_u1, xi0_u2, scale_0u, scale_0u);

 
domRad0u = 0.4
                                                                                                
  
%----------------Homoclinic Parameters From Memory:------------------------

  %LOAD GUESSES:
  
  %Proof 1:
       n_s = 3
       n_u = 3  
       load homData_eps5p5_ns_3_nu_3
  

  %Proof 2:
  %      n_s = 5
  %      n_u = 3
  %      load homData_eps5p5_ns_5_nu_3
  
  %Proof 3:
  %      n_s = 6
  %      n_u = 3
  %      load homData_eps5p5_ns_6_nu_3

  %Proof 4:
  %      n_s = 8
  %      n_u = 3
  %      load homData_eps5p5_ns_8_nu_3
  
  %Proof 5: 
  %     n_s = 9
  %     n_u = 3
  %     load homData_eps5p5_ns_9_nu_3
  
  %Proof 6:
  %     n_s = 10
  %     n_u = 3
  %     load homData_eps5p5_ns_10_nu_3
   
  
  %Proof 7:
  %    n_s = 11
  %    n_u = 3
  %    load homData_eps5p5_ns_11_nu_3
  
  
  %Proof 8:
  %  n_s = 12
  %  n_u = 3
  %  load homData_eps5p5_ns_12_nu_3
  
  
  %Proof 9:
  %  n_s = 13
  %  n_u = 3
  %  load homData_eps5p5_ns_13_nu_3
  
  %Proof 10:
  %  n_s = 14
  %  n_u = 3
  %  load homData_eps5p5_ns_14_nu_3
  
 
  %Proof 11:
  %  n_s = 15
  %  n_u = 3
  %  load homData_eps5p5_ns_15_nu_3
  
  %Proof 12:
  %  n_s = 16
  %  n_u = 3
  %  load homData_eps5p5_ns_16_nu_3 
    
    
  %Proof :
  %      n_s = 17
  %      n_u = 3
  %      load homData_eps5p5_ns_17_nu_3
  
  
  %Proof:
  %  n_s = 18
  %  n_u = 3
  %  load homData_eps5p5_ns_18_nu_3     
  
        
%[orbitsValidated, chaosValidations, validatedRadii] = ...
%      validateChaosProof(intersectionParameters, ...
%            n_s, n_u, N, order_1, scale_0s, scale_0u, ...
%            domRad0s, domRad0u, a, b, c, alpha, tau);
   
        


        
  %validateChaosProof(validationParameters, ...
  %  n_s, n_u, N, order_1, scale_0s, scale_0u, ...
  %  domRad0s, domRad0u, a, b, c, alpha, tau);


validationParameters = intersectionParameters;


      
   %Convert to Lomeli:   
      a = intval(a)      %c_dm
      b = intval(b)      %b_dm - 2*c_dm
      c = intval(c)      %c_dm + a_dm - b_dm
      
      tau =  intval(tau)  %2*a_dm*(3+mu_dm)/(2*a_dm - b_dm)
      alpha =  intval(alpha) %((9+6*mu_dm+mu_dm^2)*a_dm - 4*eps_dm*a_dm^2 + ...
                           %4*eps_dm*a_dm*b_dm - eps_dm*b_dm^2)/(2*a_dm - b_dm)^2
                    
           
[p0, p1, lambda0_s, lambda0_u1, lambda0_u2, ...
         lambda1_u, lambda1_s1, lambda1_s2, ...
         xi0_s, xi0_u1, xi0_u2, ...
         xi1_u, xi1_s1, xi1_s2] ...
       = firstOrderData_intval_3DHenon(a, b, c, alpha, tau);
     
   
  
           
%=====================================================================
%One-D Manifolds 
%=====================================================================

%Step 1: Compute 1D Coefficients:


scale = intval(scale_0s);


tic

[A0s, B0s, C0s] = oneDimManifold_intval_3DHenon(a, b, c, alpha, tau, ...
     order_1, p0, lambda0_s, xi0_s, scale);


oneDimCoefTime = toc
 
firstOrder = 1

           
%==========================================================================
%Two-D Manifolds:
%==========================================================================

%Step 1: Compute Coefficients:
 scale_0u_intval = intval(scale_0u);
 
 
 tic
 
 [A0u, B0u, C0u] = twoDimManifold_intval_3DHenon(a, b, c, alpha, tau, ...
      N, p0, lambda0_u1, lambda0_u2, xi0_u1, xi0_u2, scale_0u, scale_0u_intval);
   
 twoDimCoeffTime = toc


%----------------------Put in Polynomial Data Structure--------------------



[P0u1, P0u2, P0u3] = convertToPoly_2D(A0u, B0u, C0u, N);


[P0s1, P0s2, P0s3] = convertToPoly_1D(A0s, B0s, C0s, order_1);                                                 

                         
%Step 2: Validate the Manifolds                                               
                                               



%domRad0s = intval('0.02')
%domRad1u = intval('0.01')
%domRad1s = intval('0.01');              
%domRad0u = intval('0.01');
 

domRad0s = intval(domRad0s)
domRad0u = intval(domRad0u)


N_f = 4
N_dim = 3

tic

[delta_0s, delta_max_0s, P0s_norm, s0_delta_good, OrderTest]...
        = validateStableManifold_1D_3DHenon(...
    P0s1, P0s2, P0s3, p0, xi0_u1, xi0_u2, xi0_s, lambda0_s, ...
    N_f, N_dim, domRad0s, order_1, a, b, c, alpha, tau);

validate1DManTime = toc


P0s_norm

delta_0s




                                                                                  
%Phase Space Bounds: 2D


                     
%A-Posteriori Errors: 2D                           

tic

[delta_0u, delta_max_0u, P0u_norm, u0_delta_good, orderTest] ...
      = validateUnstableManifold_2D_3DHenon(...
    P0u1, P0u2, P0u3, p0, xi0_u1, xi0_u2, xi0_s, ...
    lambda0_u1, lambda0_u2, N_f, N_dim, ...
    domRad0u, N, a, b, c, alpha, tau);

twoDimValidateTime = toc


P0s_norm

delta_0s

P0u_norm

delta_0u

%stopNow = stopHere

temp_1 = size(validationParameters);
numOrbits = temp_1(1,1);


proofCount = 2

tic


theta_hat = validationParameters(proofCount, 1:2)
xn_hat = validationParameters(proofCount, 3:(3*(n_s + n_u)-1))';
tau_hat = validationParameters(proofCount, 3*(n_s + n_u));

N_dim = 3;
N_f = 4;

  

%Interval version of approximate orbit:  (It is not necessary that the 
%                                        interval guess include the
%                                        floating point guess.  We only
%                                        need some guess.  So we opt for a
%                                        guess with zero raduis i.e. a
%                                        degenerate interval.

thetaBar_intval = intval(theta_hat);
xn_bar_intval = intval(xn_hat);
tauBar_intval = intval(tau_hat);



%check parmeter domain conditions:
theta_norm = sqrt(thetaBar_intval(1)^2 + thetaBar_intval(2)^2);
thetaTest = sup(theta_norm)
testDom = inf(domRad0u)
if ( thetaTest >= inf(testDom))
   crashNow = crashHere 
end

tauTest = sup(abs(tauBar_intval))
testDom = domRad0s
if (tauTest >= inf(testDom))
   crashNow = crashHere 
end


sigma_s_hat = -log((sup(abs(tauBar_intval)))/(domRad0s))
sigma_u_hat = -log((sup(theta_norm))/(domRad0u))

if (sup(sigma_s_hat) > 1)
    sigma_s_hat = intval(1)
end

if (sup(sigma_u_hat) > 1)
    sigma_u_hat = intval(1)
end


%The Newton Vector:
[Fx1_intval, Fx2_intval, Fx3_intval] = ...
    F_prod_intval(thetaBar_intval, xn_bar_intval, tauBar_intval, n_u, n_s, ...                          
    P0u1, P0u2, P0u3, P0s1, P0s2, P0s3, alpha, tau, a, b, c);

Fx_intval = [Fx1_intval, Fx2_intval, Fx3_intval];


%Interval evaluation of Df(x_0):
A = DF_prod_intval(thetaBar_intval, xn_bar_intval, tauBar_intval, n_u, n_s, ...
    P0u1, P0u2, P0u3, P0s1, P0s2, P0s3, alpha, tau, a, b, c);



Ainv = inv(A);
Ainv_norm = norm(Ainv, inf)
Ainv_1 = Ainv(:, 1);
Ainv_2 = Ainv(:, 2);
Ainv_nk = Ainv(:, N_dim*(n_s + n_u));

%Step 3: Validate the Newton Computation.                           

M_N = intval('pi')*N_dim*...
      (norm(Ainv_1 + Ainv_2, inf)*(4*delta_0u/(domRad0u*sigma_u_hat)) + ...
      norm(Ainv_nk, inf)*(2*delta_0s/(domRad0s*sigma_s_hat)))

  
if (sup(M_N) >=1)  
  crashNow = crashHere
  M_N
end
 


epsilon_hat = norm( Ainv*Fx_intval', inf)


delta_hat = norm(Ainv_1 + Ainv_2, inf)*delta_0u + ...
            norm(Ainv_nk, inf)*delta_0s
epsilon_NK = (1/(1 - M_N))*(epsilon_hat + delta_hat)
r_NewtonKantorivich = 2*epsilon_NK


theta_ball = midrad(mid(thetaBar_intval), sup(r_NewtonKantorivich));
xn_ball = midrad(mid(xn_bar_intval), sup(r_NewtonKantorivich));
tau_ball = midrad(mid(tauBar_intval), sup(r_NewtonKantorivich));


theta_ballTest = sup(norm(theta_ball))
if ( theta_ballTest >= inf(testDom))
   crashNow = crashHere 
end

tau_ballTest = sup(abs(tau_ball))
if (tau_ballTest >= inf(testDom))
   crashNow = crashHere 
end

sigma_s_r = -log((sup(abs(tau_ball)))/(domRad0s))
sigma_u_r = -log((sup(norm(theta_ball)))/(domRad0u))

if (sup(sigma_s_r) > 1)
   sigma_s_r = intval(1) 
end

if (sup(sigma_u_r) > 1)
    sigma_u_r = intval(1)
end

C_Beta = max([sup(2*abs(a)), sup(2*abs(c)), sup(abs(b))])

CP_1 = parm_2ndDiff_1Dbound(tau, P0s1, P0s2, P0s3) + ...
      4*intval('pi')^2*N_dim^2*sigma_s_r^(-2)*domRad0s^(-2)*delta_0s

  
CP_2 = parm_2ndDiff_2Dbound(theta_ball, P0u1, P0u2, P0u3) + ...
      16*intval('pi')^2*N_dim^2*sigma_u_r^(-2)*domRad0u^(-2)*delta_0u

CP_maxes = [CP_1, CP_2];
[maxCP_float, maxCPIndex] = max([sup(CP_1), sup(CP_2)]);
CP = CP_maxes(maxCPIndex)
  
kappa_NK = N_f*C_Beta + CP
NK_Test = sup((4*kappa_NK*Ainv_norm*epsilon_NK)/(1-M_N)^2)

if (NK_Test <= 1)
   orbitValidated = 1
else
    orbitValidated = 0
end

%Transversallity Test:

 chaosValidation = 0;
%If zero is not in the determinant interval then
%the matrix is non-singular and the intersection is 
%transverse.
if (NK_Test <1)
    chaosValidation = 1;
end
chaosValidation
    

proofTime = toc    
    


    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
  
  
  
  
  
