clear 
format long

%==========================================================================
%---------------Rigorous Parameterization Computations---------------------
%
%This program uses the MatLab package ``IntLab''.
%Before using run from the command prompt:
%
%>> startintlab
%
%
%
%
%
%
%
%--------------------------------------------------------------------------
%==========================================================================

%parm controls:
order_1 = 50


%Map Parameter Set: Dullin to Lomeli Meiss.
   %Dullin Meiss Parms:
      a_dm = 1
      b_dm = 0.5
      c_dm = 0.5
            
      
      
      eps_dm = 2.11    %boundary near 6.182001
      mu_dm = -2.4
      
      
   %Convert to Lomeli:   
      a = c_dm
      b = b_dm - 2*c_dm
      c = c_dm + a_dm - b_dm
      
      tau =    2*a_dm*(3+mu_dm)/(2*a_dm - b_dm)
      alpha =  ((9+6*mu_dm+mu_dm^2)*a_dm - 4*eps_dm*a_dm^2 + ...
               4*eps_dm*a_dm*b_dm - eps_dm*b_dm^2)/(2*a_dm - b_dm)^2

                      
           
[p0, p1, lambda0_s, lambda0_u1, lambda0_u2, ...
         lambda1_u, lambda1_s1, lambda1_s2, ...
         xi0_s, xi0_u1, xi0_u2, ...
         xi1_u, xi1_s1, xi1_s2] ...
       = firstOrderData_3DHenon(a, b, c, alpha, tau);
     
   
   

   
           
%=====================================================================
%One-D Manifolds 
%=====================================================================

%Step 1: Compute 1D Coefficients:


%scale = 50;


%[A0s, B0s, C0s] = oneDimManifold_3DHenon(a, b, c, alpha, tau, ...
%     order_1, p0, lambda0_s, xi0_s, scale);
 
 
 
%[A1u, B1u, C1u] = oneDimManifold_3DHenon(a, b, c, alpha, tau, ...
%    order_1, p1, lambda1_u, xi1_u, scale);           
           
 

%magA1u = mag(A1u);
%magB1u = mag(B1u);
%magC1u = mag(C1u);
 

%figure 
%hold on
%axis1 = linspace(0, order_1, order_1+1);
%plot(axis1, log(magA1u)/log(10), '.b')
%plot(axis1, log(magB1u)/log(10), '.g')
%plot(axis1, log(magC1u)/log(10), '.r')





%firstOrder = 1

           

%stopNow = stopHere

%==========================================================================
%Two-D Manifolds:
%==========================================================================

%Step 1: Compute Coefficients:
scale1 = 25;
scale2 = 25;

N = 35;


%tic

%[A0u, B0u, C0u] = twoDimManifold_3DHenon(a, b, c, alpha, tau, ...
%    N, p0, lambda0_u1, lambda0_u2, xi0_u1, xi0_u2, scale1, scale2);


[A1s, B1s, C1s] = twoDimManifold_3DHenon(a, b, c, alpha, tau, ...
    N, p1, lambda1_s1, lambda1_s2, xi1_s1, xi1_s2, scale1, scale2);           
           
  
%time_1 = toc/60

A1s_bar = zeros(N+1, 1);
B1s_bar = zeros(N+1, 1);
C1s_bar = zeros(N+1, 1);

for k = 1:(N+1)
   A1s_bar(k) = A1s(k, k);
   B1s_bar(k) = B1s(k, k);
   C1s_bar(k) = C1s(k, k);
end


magA1s = mag(A1s_bar);
magB1s = mag(B1s_bar);
magC1s = mag(C1s_bar);
 

figure 
hold on
axis1 = linspace(0, N, N+1);
plot(axis1, log(magA1s)/log(10), '.b')
plot(axis1, log(magB1s)/log(10), '.g')
plot(axis1, log(magC1s)/log(10), '.r')





