function f = call_Q_j0n(j, N, A, alpha, beta, a, b, c, d);

Q_j0n = 0;
denom = alpha(1)^2 + beta(1)^2;

for (n = 2:N)
    x0n = real(A(1,n+1));
    y0n = imag(A(1,n+1));
    
     Rbar_jn = 0;
     Sbar_jn = 0;
     for (k = 0:(j-2))
         Rbar_jn = Rbar_jn + (k+1)*(c(k+2, n+1)*alpha(j-k) + d(k+2, n+1)*beta(j-k) - n*(c(j-k, n+1)*alpha(k+2) + d(j-k,n+1)*beta(k+2)));
         Sbar_jn = Sbar_jn + (k+1)*(d(k+2, n+1)*alpha(j-k) - c(k+2, n+1)*beta(j-k) - n*(d(j-k, n+1)*alpha(k+2) - c(j-k,n+1)*beta(k+2)));
     end    
     C = -1/j;
     Rbar_jn = C*Rbar_jn;
     Sbar_jn = C*Sbar_jn;
    
    R3jn = (alpha(1)*Rbar_jn - beta(1)*Sbar_jn)/denom;
    R4jn = (beta(1)*Rbar_jn + alpha(1)*Sbar_jn)/denom;
    
    Q_j0n = Q_j0n + x0n*R3jn - y0n*R4jn;
end    



%Return:
f = Q_j0n;