function f = call_Q_jm0(j, N, A, alpha, beta, a, b, c, d);

Q_jm0 = 0;
denom = alpha(1)^2 + beta(1)^2;

for (m = 2:N)
   xm0 = real(A(m+1,1));
   ym0 = imag(A(m+1, 1));
   
   R_jm = 0;
   S_jm = 0;           
   for (k = 0:(j-2))
       R_jm = R_jm + (k+1)*(a(k+2, m+1)*alpha(j-k) - b(k+2, m+1)*beta(j-k) - m*(a(j-k, m+1)*alpha(k+2) - b(j-k,m+1)*beta(k+2)));
       S_jm = S_jm + (k+1)*(a(k+2, m+1)*beta(j-k) + b(k+2, m+1)*alpha(j-k) - m*(a(j-k, m+1)*beta(k+2) + b(j-k,m+1)*alpha(k+2)));
   end    
   C = -1/j;
   R_jm = C*R_jm;
   S_jm = C*S_jm;
        
   R1jm = (alpha(1)*R_jm + beta(1)*S_jm)/denom;
   R2jm = (alpha(1)*S_jm - beta(1)*R_jm)/denom;
   
   Q_jm0 = Q_jm0 + xm0*R1jm - ym0*R2jm; 
end    


%Return:
f = Q_jm0;