function f = call_Q_jm1(j, N, A, alpha, beta, a, b, c, d);

Q_jm1 = 0;
denom = alpha(1)^2 + beta(1)^2;

for (m = 2:N)
    
    xm1 = real(A(m+1, 2));
    ym1 = imag(A(m+1, 2));
    
    R_jm = 0;
    S_jm = 0;
    for (k = 0:(j-2))
        R_jm = R_jm + (k+1)*(a(k+2, m+1)*alpha(j-k) - b(k+2, m+1)*beta(j-k) - m*(a(j-k, m+1)*alpha(k+2) - b(j-k,m+1)*beta(k+2)));
        S_jm = S_jm + (k+1)*(a(k+2, m+1)*beta(j-k) + b(k+2, m+1)*alpha(j-k) - m*(a(j-k, m+1)*beta(k+2) + b(j-k,m+1)*alpha(k+2)));
    end    
    C = -1/j;
    R_jm = C*R_jm;
    S_jm = C*S_jm;
    
    R1jm = (alpha(1)*R_jm + beta(1)*S_jm)/denom;
    R2jm = (alpha(1)*S_jm - beta(1)*R_jm)/denom;
    
    sum = 0;
    for (k = 1:(j-1))
        sum = sum + xm1*(alpha(k+1)*a(j-k+1,m+1) + beta(k+1)*b(j-k+1,m+1)) - ym1*(alpha(k+1)*b(j-k+1,m+1) - beta(k+1)*a(j-k+1,m+1));
    end   
    
    Q_jm1 = Q_jm1 + (xm1*alpha(1) + ym1*beta(1))*R1jm + (xm1*beta(1) - ym1*alpha(1))*R2jm +sum; 
end    


%Return:
f = Q_jm1;









