function f = call_Q_jmn(j, N, A, alpha, beta, a, b, c, d);


Q_jmn = 0;
denom = alpha(1)^2 + beta(1)^2;

for (n = 2:N)
   for (m = 2:N)
       x_mn = real(A(m+1, n+1));
       y_mn = imag(A(m+1, n+1));
       
       G1mn = x_mn*c(1, n+1) - y_mn*d(1, n+1);
       G2mn = -x_mn*d(1, n+1) - y_mn*c(1, n+1);
       G3mn = x_mn*a(1, m+1) - y_mn*b(1, m+1);
       G4mn = -x_mn*b(1, m+1) - y_mn*a(1, m+1);
       
       R_jm = 0;
       S_jm = 0;
       Rbar_jn = 0;
       Sbar_jn = 0;
       for (k = 0:(j-2))
           R_jm = R_jm + (k+1)*(a(k+2, m+1)*alpha(j-k) - b(k+2, m+1)*beta(j-k) - m*(a(j-k, m+1)*alpha(k+2) - b(j-k,m+1)*beta(k+2)));
           S_jm = S_jm + (k+1)*(a(k+2, m+1)*beta(j-k) + b(k+2, m+1)*alpha(j-k) - m*(a(j-k, m+1)*beta(k+2) + b(j-k,m+1)*alpha(k+2)));
           Rbar_jn = Rbar_jn + (k+1)*(c(k+2, n+1)*alpha(j-k) + d(k+2, n+1)*beta(j-k) - n*(c(j-k, n+1)*alpha(k+2) + d(j-k,n+1)*beta(k+2)));
           Sbar_jn = Sbar_jn + (k+1)*(d(k+2, n+1)*alpha(j-k) - c(k+2, n+1)*beta(j-k) - n*(d(j-k, n+1)*alpha(k+2) - c(j-k,n+1)*beta(k+2)));
       end    
       C = -1/j;
       R_jm = C*R_jm;
       S_jm = C*S_jm;
       Rbar_jn = C*Rbar_jn;
       Sbar_jn = C*Sbar_jn;
       
       R1jm = (alpha(1)*R_jm + beta(1)*S_jm)/denom;
       R2jm = (alpha(1)*S_jm - beta(1)*R_jm)/denom;
       R3jn = (alpha(1)*Rbar_jn - beta(1)*Sbar_jn)/denom;
       R4jn = (beta(1)*Rbar_jn + alpha(1)*Sbar_jn)/denom;
       
       Tau_jmn = 0;
       for (k = 1:(j-1))
          Tau_jmn = Tau_jmn + x_mn*(a(k+1,m+1)*c(j-k+1, n+1) - b(k+1,m+1)*d(j-k+1,n+1)) - y_mn*(a(k+1,m+1)*d(j-k+1,n+1) + b(k+1,m+1)*c(j-k+1,n+1)); 
       end    
       
       Q_jmn = Q_jmn + G1mn*R1jm + G2mn*R2jm + G3mn*R3jn + G4mn*R4jn + Tau_jmn;
   end    
end    


%Return:
f = Q_jmn;



