function varargout=coefficients_0n(N, A, alpha, beta, a, b, c, d);


A0n = 0;
B0n = 0;

denom = alpha(1)^2 + beta(1)^2;

for (n = 2:N)
  x0n = real(A(1,n+1));
  y0n = imag(A(1,n+1));
  
  C5n = (n/denom)*(alpha(1)*c(1,n+1) - beta(1)*d(1, n+1));
  C6n = (n/denom)*(alpha(1)*d(1,n+1) + beta(1)*c(1, n+1));
  C7n = (n/denom)*(beta(1)*c(1,n+1) + alpha(1)*d(1, n+1));
  C8n = (n/denom)*(beta(1)*d(1,n+1) - alpha(1)*c(1, n+1));
     
  A0n = A0n + x0n*C5n - y0n*C7n;
  B0n = B0n + x0n*C6n - y0n*C8n;
end


%Return:
varargout(1,1)={A0n};
varargout(2,1)={B0n};