function varargout=coefficients_1n(N, A, alpha, beta, a, b, c, d);



A1n = 0;
B1n = 0;

denom = alpha(1)^2 + beta(1)^2;

for (n = 2:N)
    x1n = real(A(2, n+1));
    y1n = imag(A(2, n+1));
    
    C5n = (n/denom)*(alpha(1)*c(1,n+1) - beta(1)*d(1, n+1));
    C6n = (n/denom)*(alpha(1)*d(1,n+1) + beta(1)*c(1, n+1));
    C7n = (n/denom)*(beta(1)*c(1,n+1) + alpha(1)*d(1, n+1));
    C8n = (n/denom)*(beta(1)*d(1,n+1) - alpha(1)*c(1, n+1));
    
    A1n = A1n + x1n*c(1,n+1) - y1n*d(1,n+1) + C5n*(x1n*alpha(1) - y1n*beta(1)) - C7n*(x1n*beta(1) + y1n*alpha(1));
    B1n = B1n - (x1n*d(1,n+1) + y1n*c(1,n+1)) + C6n*(x1n*alpha(1) - y1n*beta(1)) - C8n*(x1n*beta(1) + y1n*alpha(1));
end    


%Return:
varargout(1,1)={A1n};
varargout(2,1)={B1n};