function varargout=coefficients_m0(N, A, alpha, beta, a, b, c, d);


Am0 = 0;
Bm0 = 0;

denom = alpha(1)^2 + beta(1)^2;

for (m = 2:N)
    xm0 = real(A(m+1, 1));
    ym0 = imag(A(m+1, 1));
    
    C1m = (m/denom)*(alpha(1)*a(1,m+1) + beta(1)*b(1, m+1));
    C2m = (m/denom)*(beta(1)*a(1,m+1) - alpha(1)*b(1, m+1));
    C3m = (m/denom)*(alpha(1)*b(1,m+1) - beta(1)*a(1, m+1));
    C4m = (m/denom)*(beta(1)*b(1,m+1) + alpha(1)*a(1, m+1));
    
    Am0 = Am0 + xm0*C1m - ym0*C3m;
    Bm0 = Bm0 + xm0*C2m - ym0*C4m;
    
end    


%Return:
varargout(1,1)={Am0};
varargout(2,1)={Bm0};