function varargout=coefficients_m1(N, A, alpha, beta, a, b, c, d);


Am1 = 0;
Bm1 = 0;

denom = alpha(1)^2 + beta(1)^2;

for (m = 2:N)
   xm1 = real(A(m+1, 2));
   ym1 = imag(A(m+1, 2));
   
   C1m = (m/denom)*(alpha(1)*a(1,m+1) + beta(1)*b(1, m+1));
   C2m = (m/denom)*(beta(1)*a(1,m+1) - alpha(1)*b(1, m+1));
   C3m = (m/denom)*(alpha(1)*b(1,m+1) - beta(1)*a(1, m+1));
   C4m = (m/denom)*(beta(1)*b(1,m+1) + alpha(1)*a(1, m+1));
   
   Am1 = Am1 + xm1*a(1,m+1) - ym1*b(1,m+1) + C1m*(xm1*alpha(1) + ym1*beta(1)) + C3m*(xm1*beta(1) - ym1*alpha(1)); 
   Bm1 = Bm1 + xm1*b(1,m+1) + ym1*a(1,m+1) + C2m*(xm1*alpha(1) + ym1*beta(1)) + C4m*(xm1*beta(1) - ym1*alpha(1));
end    

%Return:
varargout(1,1)={Am1};
varargout(2,1)={Bm1};