function varargout=coefficients_mn(N, A, alpha, beta, a, b, c, d);


Amn = 0;
Bmn = 0;

denom = alpha(1)^2 + beta(1)^2;

for (n = 2:N)
   for (m = 2:N)
       x_mn = real(A(m+1, n+1));
       y_mn = imag(A(m+1, n+1));
       
       G1mn = x_mn*c(1, n+1) - y_mn*d(1, n+1);
       G2mn = -x_mn*d(1, n+1) - y_mn*c(1, n+1);
       G3mn = x_mn*a(1, m+1) - y_mn*b(1, m+1);
       G4mn = -x_mn*b(1, m+1) - y_mn*a(1, m+1);
       
       
       C1m = (m/denom)*(alpha(1)*a(1,m+1) + beta(1)*b(1, m+1));
       C2m = (m/denom)*(beta(1)*a(1,m+1) - alpha(1)*b(1, m+1));
       C3m = (m/denom)*(alpha(1)*b(1,m+1) - beta(1)*a(1, m+1));
       C4m = (m/denom)*(beta(1)*b(1,m+1) + alpha(1)*a(1, m+1));
       C5n = (n/denom)*(alpha(1)*c(1,n+1) - beta(1)*d(1, n+1));
       C6n = (n/denom)*(alpha(1)*d(1,n+1) + beta(1)*c(1, n+1));
       C7n = (n/denom)*(beta(1)*c(1,n+1) + alpha(1)*d(1, n+1));
       C8n = (n/denom)*(beta(1)*d(1,n+1) - alpha(1)*c(1, n+1));
       
       Amn = Amn + G1mn*C1m + G2mn*C3m + G3mn*C5n + G4mn*C7n;
       Bmn = Bmn + G1mn*C2m + G2mn*C4m + G3mn*C6n + G4mn*C8n;
   end    
end    


%Return:
varargout(1,1)={Amn};
varargout(2,1)={Bmn};



