function varargout=complexSeries_to_the_nth_power(n, K, alpha, beta);


a = zeros(K+1, 1);
b = zeros(K+1, 1);

if (n == 0)
    a(1) = 1;
    
elseif (n == 1)
  a = alpha;
  b = beta;
        
else        
  r = sqrt(alpha(1)^2 + beta(1)^2);
  theta = atan2(beta(1), alpha(1));
  
  a(1) = (r^n)*cos(n*theta);
  b(1) = (r^n)*sin(n*theta);
  
  a(2) = n*(r^(n-1))*(alpha(2)*cos((n-1)*theta) - beta(2)*sin((n-1)*theta));
  b(2) = n*(r^(n-1))*(alpha(2)*sin((n-1)*theta) + beta(2)*cos((n-1)*theta));

  A = [alpha(1), -beta(1);
       beta(1), alpha(1)];
   
  for (j = 2:K)
     
     sum1 = 0;
     sum2 = 0;
     for (k = 0:(j-2))
         sum1 = sum1 + (k+1)*((a(k+2)*alpha(j-k) - b(k+2)*beta(j-k)) - n*(a(j-k)*alpha(k+2) - b(j-k)*beta(k+2)));
         sum2 = sum2 + (k+1)*((a(k+2)*beta(j-k) + b(k+2)*alpha(j-k)) - n*(a(j-k)*beta(k+2) + b(j-k)*alpha(k+2)));
     end
     
     s_j1 = n*(a(1)*alpha(j+1) - b(1)*beta(j+1)) + (-1/j)*sum1;
     s_j2 = n*(a(1)*beta(j+1) + b(1)*alpha(j+1)) + (-1/j)*sum2;
     
     s_j = [s_j1;
            s_j2];
        
     x_j = A\s_j;
     
     a(j+1) = x_j(1);
     b(j+1) = x_j(2);
     
  end
  
end

a_coefficients = a;
b_coefficients = b;



%Return:
varargout(1,1)={a_coefficients};
varargout(2,1)={b_coefficients};

