function varargout=compose_P_lambda_intval_1D(N, A, B, C, lambda);



A_bar = intval(zeros(1, N+1));
B_bar = intval(zeros(1, N+1));
C_bar = intval(zeros(1, N+1));

for k = 1:(N+1)
    thisLambda = lambda^(k-1);
    A_bar(k) = thisLambda*A(k-1);
    B_bar(k) = thisLambda*B(k-1);
    C_bar(k) = thisLambda*C(k-1);
end


oneDexp = linspace(0, N, N + 1);

A_lambda = polynom(A_bar, oneDexp, {'s'});
B_lambda = polynom(B_bar, oneDexp, {'s'});
C_lambda = polynom(C_bar, oneDexp, {'s'});


%Return:
varargout(1,1)={A_lambda};
varargout(2,1)={B_lambda};
varargout(3,1)={C_lambda};