function varargout=compose_P_lambda_intval_2D(N, A, B, C, lambda_1, lambda_2);


numTwoDcoeff = (N+1)*(N+2)/2;
twoDexp = zeros(numTwoDcoeff, 2);
A_bar = intval(zeros(numTwoDcoeff, 1));
B_bar = intval(zeros(numTwoDcoeff, 1));
C_bar = intval(zeros(numTwoDcoeff, 1));


thisExp = 0;
for k = 1:(N+1)
    for l = 1:(N-k+2)
        thisExp = thisExp+1;
        twoDexp(thisExp, 1:2) = [l-1, k-1];
        thisLambda = (lambda_1^(l-1))*(lambda_2^(k-1));
        A_bar(thisExp) = thisLambda*A(l-1, k-1);
        B_bar(thisExp) = thisLambda*B(l-1, k-1);
        C_bar(thisExp) = thisLambda*C(l-1, k-1);
    end
end


A_lambda = polynom(A_bar, twoDexp, {'x' 'y'});
B_lambda = polynom(B_bar, twoDexp, {'x' 'y'});
C_lambda = polynom(C_bar, twoDexp, {'x' 'y'});


%Return:
varargout(1,1)={A_lambda};
varargout(2,1)={B_lambda};
varargout(3,1)={C_lambda};



