function varargout=compose_P_lambda_intval_2D6D(N, A, B, C, D, E, F, ...
                                                lambda_1, lambda_2);


numTwoDcoeff = (N+1)*(N+2)/2;
twoDexp = zeros(numTwoDcoeff, 2);
A_bar = intval(zeros(numTwoDcoeff, 1));
B_bar = intval(zeros(numTwoDcoeff, 1));
C_bar = intval(zeros(numTwoDcoeff, 1));
D_bar = intval(zeros(numTwoDcoeff, 1));
E_bar = intval(zeros(numTwoDcoeff, 1));
F_bar = intval(zeros(numTwoDcoeff, 1));


thisExp = 0;
for k = 1:(N+1)
    for l = 1:(N-k+2)
        thisExp = thisExp+1;
        twoDexp(thisExp, 1:2) = [l-1, k-1];
        thisLambda = (lambda_1^(l-1))*(lambda_2^(k-1));
        A_bar(thisExp) = thisLambda*A(l-1, k-1);
        B_bar(thisExp) = thisLambda*B(l-1, k-1);
        C_bar(thisExp) = thisLambda*C(l-1, k-1);
        D_bar(thisExp) = thisLambda*D(l-1, k-1);
        E_bar(thisExp) = thisLambda*E(l-1, k-1);
        F_bar(thisExp) = thisLambda*F(l-1, k-1);
    end
end


A_lambda = polynom(A_bar, twoDexp, {'x' 'y'});
B_lambda = polynom(B_bar, twoDexp, {'x' 'y'});
C_lambda = polynom(C_bar, twoDexp, {'x' 'y'});
D_lambda = polynom(D_bar, twoDexp, {'x' 'y'});
E_lambda = polynom(E_bar, twoDexp, {'x' 'y'});
F_lambda = polynom(F_bar, twoDexp, {'x' 'y'});


%Return:
varargout(1,1)={A_lambda};
varargout(2,1)={B_lambda};
varargout(3,1)={C_lambda};
varargout(4,1)={D_lambda};
varargout(5,1)={E_lambda};
varargout(6,1)={F_lambda};




