function varargout=compose_P_lambda_intval_4D6D(N, A, B, C, D, E, F, ...
                                                lambda_1, lambda_2, ...
                                                lambda_3, lambda_4);


                                            
num = 0;
for K = 1:(N+1)
    thisNum = K*(K+1)*(K+2)/6;
    num = thisNum + num;
end


numFourDcoeff = num
fourDexp = zeros(numFourDcoeff, 4);

A_bar = intval(zeros(numFourDcoeff, 1));
B_bar = intval(zeros(numFourDcoeff, 1));
C_bar = intval(zeros(numFourDcoeff, 1));
D_bar = intval(zeros(numFourDcoeff, 1));
E_bar = intval(zeros(numFourDcoeff, 1));
F_bar = intval(zeros(numFourDcoeff, 1));                                            
     

thisExp = 0;
for k = 0:N
    for l = 0:N
        for m = 0:N
            for n = 0:N
                if (k + l + m + n <= N)
                    thisExp = thisExp+1;
                    fourDexp(thisExp, 1:4) = [k, l, m, n];
                    thisLambda = ...
                        (lambda_1^k)*(lambda_2^l)*...
                        (lambda_3^m)*(lambda_4^n);
                    A_bar(thisExp) = thisLambda*A(k, l, m, n);
                    B_bar(thisExp) = thisLambda*B(k, l, m, n);
                    C_bar(thisExp) = thisLambda*C(k, l, m, n);
                    D_bar(thisExp) = thisLambda*D(k, l, m, n);
                    E_bar(thisExp) = thisLambda*E(k, l, m, n);
                    F_bar(thisExp) = thisLambda*F(k, l, m, n);
                end
            end
        end
    end
end


A_lambda = polynom(A_bar, fourDexp, {'w' 'x' 'y' 'z'});
B_lambda = polynom(B_bar, fourDexp, {'w' 'x' 'y' 'z'});
C_lambda = polynom(C_bar, fourDexp, {'w' 'x' 'y' 'z'});
D_lambda = polynom(D_bar, fourDexp, {'w' 'x' 'y' 'z'});
E_lambda = polynom(E_bar, fourDexp, {'w' 'x' 'y' 'z'});
F_lambda = polynom(F_bar, fourDexp, {'w' 'x' 'y' 'z'});


%Return:
varargout(1,1)={A_lambda};
varargout(2,1)={B_lambda};
varargout(3,1)={C_lambda};
varargout(4,1)={D_lambda};
varargout(5,1)={E_lambda};
varargout(6,1)={F_lambda};

