function [Ps] = computeHenonLikeUnstabCoeff_11(p, Lambda, Q, scale, a, b, order, Ps);



Dfp = henonLikeDifferential(p, a, b, 11);
Id = eye(11);
lambda_1 = Lambda(1,1);
lambda_2 = Lambda(2,2);
lambda_3 = Lambda(3,3);
lambda_4 = Lambda(4,4);
lambda_5 = Lambda(5,5);
lambda_6 = Lambda(6,6);
lambda_7 = Lambda(7,7);
lambda_8 = Lambda(8,8);
lambda_9 = Lambda(9,9);
lambda_10 = Lambda(10,10);

N = order;


for n = 1:11
    Ps(1,1,1,1,1,1,1,1,1,1,n) = p(n);
    
    Ps(2,1,1,1,1,1,1,1,1,1,n) = scale*Q(n,1);
    Ps(1,2,1,1,1,1,1,1,1,1,n) = scale*Q(n,2);
    Ps(1,1,2,1,1,1,1,1,1,1,n) = scale*Q(n,3);
    Ps(1,1,1,2,1,1,1,1,1,1,n) = scale*Q(n,4);
    Ps(1,1,1,1,2,1,1,1,1,1,n) = scale*Q(n,5);
    Ps(1,1,1,1,1,2,1,1,1,1,n) = scale*Q(n,6);
    Ps(1,1,1,1,1,1,2,1,1,1,n) = scale*Q(n,7);
    Ps(1,1,1,1,1,1,1,2,1,1,n) = scale*Q(n,8);
    Ps(1,1,1,1,1,1,1,1,2,1,n) = scale*Q(n,9);
    Ps(1,1,1,1,1,1,1,1,1,2,n) = scale*Q(n,10);
end


for n = 0:N
    for m = 0:N
        for k = 0:N
            for l = 0:N
                for h = 0:N
                    for i = 0:N
                        for j = 0:N
                            for e = 0:N
                                for f = 0:N
                                    for g = 0:N
                    if ((m+n+k+l+h+i+j+e+f+g >= 2)&(m+n+k+l+h+i+j+e+f+g <= N))

                        A = Dfp - ...
                            (lambda_1^m * lambda_2^n * lambda_3^k * ...
                             lambda_4^l * lambda_5^h * lambda_6^i * ...
                             lambda_7^j * lambda_8^e * lambda_9^f * ...
                             lambda_9^g)*Id;            

                        s = a*compute_s11_henonLike(...
                                  m, n, k, l, h, i, j, e, f, g, Ps, N);
    
                        v = A\s;

                        Ps(m+1, n+1, k+1, l+1, h+1, i+1, j+1, e+1, f+1, g+1, 1) = v(1);
                        Ps(m+1, n+1, k+1, l+1, h+1, i+1, j+1, e+1, f+1, g+1, 2) = v(2);
                        Ps(m+1, n+1, k+1, l+1, h+1, i+1, j+1, e+1, f+1, g+1, 3) = v(3);
                        Ps(m+1, n+1, k+1, l+1, h+1, i+1, j+1, e+1, f+1, g+1, 4) = v(4);
                        Ps(m+1, n+1, k+1, l+1, h+1, i+1, j+1, e+1, f+1, g+1, 5) = v(5);
                        Ps(m+1, n+1, k+1, l+1, h+1, i+1, j+1, e+1, f+1, g+1, 6) = v(6);
                        Ps(m+1, n+1, k+1, l+1, h+1, i+1, j+1, e+1, f+1, g+1, 7) = v(7);
                        Ps(m+1, n+1, k+1, l+1, h+1, i+1, j+1, e+1, f+1, g+1, 8) = v(8);
                        Ps(m+1, n+1, k+1, l+1, h+1, i+1, j+1, e+1, f+1, g+1, 9) = v(9);
                        Ps(m+1, n+1, k+1, l+1, h+1, i+1, j+1, e+1, f+1, g+1, 10) = v(10);
                        Ps(m+1, n+1, k+1, l+1, h+1, i+1, j+1, e+1, f+1, g+1, 11) = v(11);
                    end
                                    end
                                end
                            end
                        end
                    end
                end
            end
        end
    end
end

end