function [Ps] = computeHenonLikeUnstabCoeff_3(p, Lambda, Q, scale, a, b, order, Ps);


Dfp = henonLikeDifferential(p, a, b, 3);
Id = eye(3);
lambda_1 = Lambda(1,1);
lambda_2 = Lambda(2,2);
N = order

Ps(1,1,1) = p(1);
Ps(1,1,2) = p(2);
Ps(1,1,3) = p(3);


Ps(2,1,1) = scale*Q(1,1);
Ps(1,2,1) = scale*Q(1,2);

Ps(2,1,2) = scale*Q(2,1);
Ps(1,2,2) = scale*Q(2,2);

Ps(2,1,3) = scale*Q(3,1);
Ps(1,2,3) = scale*Q(3,2);

for n = 0:N
    for m = 0:N
        if ((m+n >= 2)&(m+n <= N))

            Amn = Dfp - (lambda_1^m * lambda_2^n)*Id;            

            smn = a*compute_s3_henonLike(m, n, Ps, N);

            vmn = Amn\smn;

            Ps(m+1, n+1, 1) = vmn(1);
            Ps(m+1, n+1, 2) = vmn(2);
            Ps(m+1, n+1, 3) = vmn(3);
            
        end
    end
end







end

