function [Ps] = computeHenonLikeUnstabCoeff_4(p, Lambda, Q, scale, a, b, order, Ps);



Dfp = henonLikeDifferential(p, a, b, 4);
Id = eye(4);
lambda_1 = Lambda(1,1)
lambda_2 = Lambda(2,2)
lambda_3 = Lambda(3,3)


N = order;

Ps(1,1,1,1) = p(1);
Ps(1,1,1,2) = p(2);
Ps(1,1,1,3) = p(3);
Ps(1,1,1,4) = p(4);

Ps(2,1,1,1) = scale*Q(1,1);
Ps(1,2,1,1) = scale*Q(1,2);
Ps(1,1,2,1) = scale*Q(1,3);

Ps(2,1,1,2) = scale*Q(2,1);
Ps(1,2,1,2) = scale*Q(2,2);
Ps(1,1,2,2) = scale*Q(2,3);

Ps(2,1,1,3) = scale*Q(3,1);
Ps(1,2,1,3) = scale*Q(3,2);
Ps(1,1,2,3) = scale*Q(3,3);

Ps(2,1,1,4) = scale*Q(4,1);
Ps(1,2,1,4) = scale*Q(4,2);
Ps(1,1,2,4) = scale*Q(4,3);

for n = 0:N
    for m = 0:N
        for k = 0:N
            if ((m+n+k >= 2)&(m+n+k <= N))

                Amnk = Dfp - (lambda_1^m * lambda_2^n * lambda_3^k)*Id;            

                smnk = a*compute_s4_henonLike(m, n, k, Ps, N);

                %a
                %m
                %n
                %k
                %smnk
                %stopNow = stopHere
                
                vmnk = Amnk\smnk;

                Ps(m+1, n+1, k+1, 1) = vmnk(1);
                Ps(m+1, n+1, k+1, 2) = vmnk(2);
                Ps(m+1, n+1, k+1, 3) = vmnk(3);
                Ps(m+1, n+1, k+1, 4) = vmnk(4);
            end
        end
    end
end





end

