function [Ps] = computeHenonLikeUnstabCoeff_5_intval(...
    p, Lambda, Q, scale, a, b, order, Ps);



Dfp = henonLikeDifferential_intval(p, a, b, 5);
Id = intval(eye(5));
lambda_1 = Lambda(1,1);
lambda_2 = Lambda(2,2);
lambda_3 = Lambda(3,3);
lambda_4 = Lambda(4,4);

N = order;

Ps(1,1,1,1,1) = p(1);
Ps(1,1,1,1,2) = p(2);
Ps(1,1,1,1,3) = p(3);
Ps(1,1,1,1,4) = p(4);
Ps(1,1,1,1,5) = p(5);

Ps(2,1,1,1,1) = scale*Q(1,1);
Ps(1,2,1,1,1) = scale*Q(1,2);
Ps(1,1,2,1,1) = scale*Q(1,3);
Ps(1,1,1,2,1) = scale*Q(1,4);



Ps(2,1,1,1,2) = scale*Q(2,1);
Ps(1,2,1,1,2) = scale*Q(2,2);
Ps(1,1,2,1,2) = scale*Q(2,3);
Ps(1,1,1,2,2) = scale*Q(2,4);



Ps(2,1,1,1,3) = scale*Q(3,1);
Ps(1,2,1,1,3) = scale*Q(3,2);
Ps(1,1,2,1,3) = scale*Q(3,3);
Ps(1,1,1,2,3) = scale*Q(3,4);


Ps(2,1,1,1,4) = scale*Q(4,1);
Ps(1,2,1,1,4) = scale*Q(4,2);
Ps(1,1,2,1,4) = scale*Q(4,3);
Ps(1,1,1,2,4) = scale*Q(4,4);

Ps(2,1,1,1,5) = scale*Q(5,1);
Ps(1,2,1,1,5) = scale*Q(5,2);
Ps(1,1,2,1,5) = scale*Q(5,3);
Ps(1,1,1,2,5) = scale*Q(5,4);



for n1 = 2:N
    n1
    N
    for n2 = 0:n1
        for n3 = 0:n2
            for n4 = 0:n3
       
            m = n1 - n2;
            n = n2 - n3;
            k = n3 - n4;
            l = n4;
                
            P1 = Ps(:, :, :, :, 1);
                
            Amnkl = Dfp - ...
              (lambda_1^m * lambda_2^n * lambda_3^k * lambda_4^l)*Id;            

              
            A = reshape(P1(1:m+1, 1:n+1, 1:k+1, 1:l+1), ...
                        (n+1)*(m+1)*(k+1)*(l+1), 1);
            A = A(2:((n+1)*(m+1)*(k+1)*(l+1)-1));

            B = reshape(P1(1:m+1, 1:n+1, 1:k+1, 1:l+1), ...
                       (n+1)*(m+1)*(k+1)*(l+1), 1);
            B = B(2:((n+1)*(m+1)*(k+1)*(l+1)-1));
            B = flipud(B);
               
            smnkl = a*[transpose(A)*B;
                       0;
                       0;
                       0;
                       0];
                            
                %smnkl_test = ...
                %    a*compute_s5_henonLike_intval(m, n, k, l, Ps, N)

            vmnkl = Amnkl\smnkl;

            Ps(m+1, n+1, k+1, l+1, 1) = vmnkl(1);
            Ps(m+1, n+1, k+1, l+1, 2) = vmnkl(2);
            Ps(m+1, n+1, k+1, l+1, 3) = vmnkl(3);
            Ps(m+1, n+1, k+1, l+1, 4) = vmnkl(4);
            Ps(m+1, n+1, k+1, l+1, 5) = vmnkl(5);
        end
    end
end

end

