function [Ps] = computeHenonLikeUnstabCoeff_6(p, Lambda, Q, scale, a, b, order, Ps);




Dfp = henonLikeDifferential(p, a, b, 6);
Id = eye(6);
lambda_1 = Lambda(1,1);
lambda_2 = Lambda(2,2);
lambda_3 = Lambda(3,3);
lambda_4 = Lambda(4,4);
lambda_5 = Lambda(5,5);

N = order;

Ps(1,1,1,1,1,1) = p(1);
Ps(1,1,1,1,1,2) = p(2);
Ps(1,1,1,1,1,3) = p(3);
Ps(1,1,1,1,1,4) = p(4);
Ps(1,1,1,1,1,5) = p(5);
Ps(1,1,1,1,1,6) = p(6);

Ps(2,1,1,1,1,1) = scale*Q(1,1);
Ps(1,2,1,1,1,1) = scale*Q(1,2);
Ps(1,1,2,1,1,1) = scale*Q(1,3);
Ps(1,1,1,2,1,1) = scale*Q(1,4);
Ps(1,1,1,1,2,1) = scale*Q(1,5);

Ps(2,1,1,1,1,2) = scale*Q(2,1);
Ps(1,2,1,1,1,2) = scale*Q(2,2);
Ps(1,1,2,1,1,2) = scale*Q(2,3);
Ps(1,1,1,2,1,2) = scale*Q(2,4);
Ps(1,1,1,1,2,2) = scale*Q(2,5);

Ps(2,1,1,1,1,3) = scale*Q(3,1);
Ps(1,2,1,1,1,3) = scale*Q(3,2);
Ps(1,1,2,1,1,3) = scale*Q(3,3);
Ps(1,1,1,2,1,3) = scale*Q(3,4);
Ps(1,1,1,1,2,3) = scale*Q(3,5);

Ps(2,1,1,1,1,4) = scale*Q(4,1);
Ps(1,2,1,1,1,4) = scale*Q(4,2);
Ps(1,1,2,1,1,4) = scale*Q(4,3);
Ps(1,1,1,2,1,4) = scale*Q(4,4);
Ps(1,1,1,1,2,4) = scale*Q(4,5);

Ps(2,1,1,1,1,5) = scale*Q(5,1);
Ps(1,2,1,1,1,5) = scale*Q(5,2);
Ps(1,1,2,1,1,5) = scale*Q(5,3);
Ps(1,1,1,2,1,5) = scale*Q(5,4);
Ps(1,1,1,1,2,5) = scale*Q(5,5);

Ps(2,1,1,1,1,6) = scale*Q(6,1);
Ps(1,2,1,1,1,6) = scale*Q(6,2);
Ps(1,1,2,1,1,6) = scale*Q(6,3);
Ps(1,1,1,2,1,6) = scale*Q(6,4);
Ps(1,1,1,1,2,6) = scale*Q(6,5);





for n = 0:N
    for m = 0:N
        for k = 0:N
            for l = 0:N
                for h = 0:N
                    if ((m+n+k+l+h >= 2)&(m+n+k+l+h <= N))

                    Amnklh = Dfp - ...
                    (lambda_1^m * lambda_2^n * lambda_3^k * lambda_4^l * lambda_5^h)*Id;            

                    smnklh = a*compute_s6_henonLike(m, n, k, l, h, Ps, N);
    
                    vmnklh = Amnklh\smnklh;

                    Ps(m+1, n+1, k+1, l+1, h+1, 1) = vmnklh(1);
                    Ps(m+1, n+1, k+1, l+1, h+1, 2) = vmnklh(2);
                    Ps(m+1, n+1, k+1, l+1, h+1, 3) = vmnklh(3);
                    Ps(m+1, n+1, k+1, l+1, h+1, 4) = vmnklh(4);
                    Ps(m+1, n+1, k+1, l+1, h+1, 5) = vmnklh(5);
                    Ps(m+1, n+1, k+1, l+1, h+1, 6) = vmnklh(6);
                    end
                end
            end
        end
    end
end

end










