function [Ps] = computeHenonLikeUnstabCoeff_7_intval(p, Lambda, Q, scale, a, b, order, Ps);




Dfp = henonLikeDifferential_intval(p, a, b, 7);
Id = intval(eye(7));
lambda_1 = Lambda(1,1);
lambda_2 = Lambda(2,2);
lambda_3 = Lambda(3,3);
lambda_4 = Lambda(4,4);
lambda_5 = Lambda(5,5);
lambda_6 = Lambda(6,6);

N = order;

Ps(1,1,1,1,1,1,1) = p(1);
Ps(1,1,1,1,1,1,2) = p(2);
Ps(1,1,1,1,1,1,3) = p(3);
Ps(1,1,1,1,1,1,4) = p(4);
Ps(1,1,1,1,1,1,5) = p(5);
Ps(1,1,1,1,1,1,6) = p(6);
Ps(1,1,1,1,1,1,7) = p(7);

Ps(2,1,1,1,1,1,1) = scale*Q(1,1);
Ps(1,2,1,1,1,1,1) = scale*Q(1,2);
Ps(1,1,2,1,1,1,1) = scale*Q(1,3);
Ps(1,1,1,2,1,1,1) = scale*Q(1,4);
Ps(1,1,1,1,2,1,1) = scale*Q(1,5);
Ps(1,1,1,1,1,2,1) = scale*Q(1,6);

Ps(2,1,1,1,1,1,2) = scale*Q(2,1);
Ps(1,2,1,1,1,1,2) = scale*Q(2,2);
Ps(1,1,2,1,1,1,2) = scale*Q(2,3);
Ps(1,1,1,2,1,1,2) = scale*Q(2,4);
Ps(1,1,1,1,2,1,2) = scale*Q(2,5);
Ps(1,1,1,1,1,2,2) = scale*Q(2,6);

Ps(2,1,1,1,1,1,3) = scale*Q(3,1);
Ps(1,2,1,1,1,1,3) = scale*Q(3,2);
Ps(1,1,2,1,1,1,3) = scale*Q(3,3);
Ps(1,1,1,2,1,1,3) = scale*Q(3,4);
Ps(1,1,1,1,2,1,3) = scale*Q(3,5);
Ps(1,1,1,1,1,2,3) = scale*Q(3,6);

Ps(2,1,1,1,1,1,4) = scale*Q(4,1);
Ps(1,2,1,1,1,1,4) = scale*Q(4,2);
Ps(1,1,2,1,1,1,4) = scale*Q(4,3);
Ps(1,1,1,2,1,1,4) = scale*Q(4,4);
Ps(1,1,1,1,2,1,4) = scale*Q(4,5);
Ps(1,1,1,1,1,2,4) = scale*Q(4,6);

Ps(2,1,1,1,1,1,5) = scale*Q(5,1);
Ps(1,2,1,1,1,1,5) = scale*Q(5,2);
Ps(1,1,2,1,1,1,5) = scale*Q(5,3);
Ps(1,1,1,2,1,1,5) = scale*Q(5,4);
Ps(1,1,1,1,2,1,5) = scale*Q(5,5);
Ps(1,1,1,1,1,2,5) = scale*Q(5,6);

Ps(2,1,1,1,1,1,6) = scale*Q(6,1);
Ps(1,2,1,1,1,1,6) = scale*Q(6,2);
Ps(1,1,2,1,1,1,6) = scale*Q(6,3);
Ps(1,1,1,2,1,1,6) = scale*Q(6,4);
Ps(1,1,1,1,2,1,6) = scale*Q(6,5);
Ps(1,1,1,1,1,2,6) = scale*Q(6,6);

Ps(2,1,1,1,1,1,7) = scale*Q(7,1);
Ps(1,2,1,1,1,1,7) = scale*Q(7,2);
Ps(1,1,2,1,1,1,7) = scale*Q(7,3);
Ps(1,1,1,2,1,1,7) = scale*Q(7,4);
Ps(1,1,1,1,2,1,7) = scale*Q(7,5);
Ps(1,1,1,1,1,2,7) = scale*Q(7,6);


for n1 = 2:N
    n1
    N
    for n2 = 0:n1
        for n3 = 0:n2
            for n4 = 0:n3
                for n5 = 0:n4
                    for n6 = 0:n5

m = n1 - n2;
n = n2 - n3;
k = n3 - n4;
l = n4 - n5;
h = n5 - n6;
i = n6;
                        

A_homMat = Dfp - ...
    (lambda_1^m * lambda_2^n * lambda_3^k * ...
     lambda_4^l * lambda_5^h * lambda_6^i)*Id;            

 
 
index_num = (n+1)*(m+1)*(k+1)*(l+1)*(h+1)*(i+1);
i_1 = m+1;
i_2 = n+1;
i_3 = k+1;
i_4 = l+1;
i_5 = h+1;
i_6 = i+1;  
         

P1 = Ps(1:i_1, 1:i_2, 1:i_3, 1:i_4, 1:i_5, 1:i_6, 1);    
                  
A = reshape(P1(1:i_1, 1:i_2, 1:i_3, 1:i_4, 1:i_5, 1:i_6), ...
              index_num, 1);
A = A(2:(index_num - 1));

B = reshape(P1(1:i_1, 1:i_2, 1:i_3, 1:i_4, 1:i_5, 1:i_6), ...
              index_num, 1);
B = B(2:(index_num - 1));
B = flipud(B);

this_coef = a*transpose(A)*B;

s = [this_coef;
     0;
     0;
     0;
     0;
     0;
     0];
                     
%s_test = a*compute_s7_henonLike_intval(...
%            m, n, k, l, h, i, Ps, N)
    
v = A_homMat\s;

Ps(m+1, n+1, k+1, l+1, h+1, i+1, 1) = v(1);
Ps(m+1, n+1, k+1, l+1, h+1, i+1, 2) = v(2);
Ps(m+1, n+1, k+1, l+1, h+1, i+1, 3) = v(3);
Ps(m+1, n+1, k+1, l+1, h+1, i+1, 4) = v(4);
Ps(m+1, n+1, k+1, l+1, h+1, i+1, 5) = v(5);
Ps(m+1, n+1, k+1, l+1, h+1, i+1, 6) = v(6);
Ps(m+1, n+1, k+1, l+1, h+1, i+1, 7) = v(7);

                       
                    end
                end
            end
        end
    end
end

end



