function [Ps] = computeHenonLikeUnstabCoeff_8(p, Lambda, Q, scale, a, b, order, Ps);



Dfp = henonLikeDifferential(p, a, b, 8);
Id = eye(8);
lambda_1 = Lambda(1,1);
lambda_2 = Lambda(2,2);
lambda_3 = Lambda(3,3);
lambda_4 = Lambda(4,4);
lambda_5 = Lambda(5,5);
lambda_6 = Lambda(6,6);
lambda_7 = Lambda(7,7);

N = order;


for n = 1:8
    Ps(1,1,1,1,1,1,1,n) = p(n);
    
    Ps(2,1,1,1,1,1,1,n) = scale*Q(n,1);
    Ps(1,2,1,1,1,1,1,n) = scale*Q(n,2);
    Ps(1,1,2,1,1,1,1,n) = scale*Q(n,3);
    Ps(1,1,1,2,1,1,1,n) = scale*Q(n,4);
    Ps(1,1,1,1,2,1,1,n) = scale*Q(n,5);
    Ps(1,1,1,1,1,2,1,n) = scale*Q(n,6);
    Ps(1,1,1,1,1,1,2,n) = scale*Q(n,7);
end





for n = 0:N
    for m = 0:N
        for k = 0:N
            for l = 0:N
                for h = 0:N
                    for i = 0:N
                        for j = 0:N
                            if ((m+n+k+l+h+i+j >= 2)&(m+n+k+l+h+i+j <= N))

                            A = Dfp - ...
                            (lambda_1^m * lambda_2^n * lambda_3^k * ...
                             lambda_4^l * lambda_5^h * lambda_6^i * ...
                             lambda_7^j)*Id;            

                            s = a*compute_s8_henonLike(...
                                m, n, k, l, h, i, j, Ps, N);
    
                            v = A\s;

                            Ps(m+1, n+1, k+1, l+1, h+1, i+1, j+1, 1) = v(1);
                            Ps(m+1, n+1, k+1, l+1, h+1, i+1, j+1, 2) = v(2);
                            Ps(m+1, n+1, k+1, l+1, h+1, i+1, j+1, 3) = v(3);
                            Ps(m+1, n+1, k+1, l+1, h+1, i+1, j+1, 4) = v(4);
                            Ps(m+1, n+1, k+1, l+1, h+1, i+1, j+1, 5) = v(5);
                            Ps(m+1, n+1, k+1, l+1, h+1, i+1, j+1, 6) = v(6);
                            Ps(m+1, n+1, k+1, l+1, h+1, i+1, j+1, 7) = v(7);
                            Ps(m+1, n+1, k+1, l+1, h+1, i+1, j+1, 8) = v(8);
                            end
                        end
                    end
                end
            end
        end
    end
end

end

