clear
format long

%startintlab


a = intval('1.6')
b = intval('0.1')
numDim = 10




Ns = 4


%=========================================================================================================
%
%========================================================================================================


x_p = (b-1 + sqrt((1-b)^2 + 4*a))/(2*a);
x_m = (b-1 - sqrt((1-b)^2 + 4*a))/(2*a);

p_p = intval(zeros(numDim, 1));
p_m = intval(zeros(numDim, 1));

for i = 1:numDim
   p_p(i) = x_p;
   p_m(i) = x_m;
end


fp_test1 = sup(norm(p_p - henonLikeMap_intval(p_p, a, b, numDim)))
fp_test2 = sup(norm(p_m - henonLikeMap_intval(p_m, a, b, numDim)))


Dfp_p = henonLikeDifferential_intval(p_p, a, b, numDim);


[Q_float, Sigma] = eig(full(Dfp_p.mid));

Q = intval(zeros(numDim, numDim));
theEigs = intval(zeros(numDim, numDim-1));
Lambda = intval(zeros(numDim-1, numDim-1));

[lambda_temp, xi_temp] = ...
     verifyeig(Dfp_p, Sigma(1,1), Q_float(:,1));
Q(:,1) = real(xi_temp);
lambda_u = lambda_temp;


inLoop = 1
tic
for i = 2:numDim
    [lambda_temp, xi_temp] = verifyeig(Dfp_p, Sigma(i,i), Q_float(:,i));
    Lambda(i-1,i-1) = lambda_temp;
    theEigs(:,i-1) = xi_temp;
	Q(:,i) = xi_temp;      
end
compTime = toc

Q_inv = inv(Q);

eigsError = max(max(rad(theEigs)))
eigVectError = max(max(rad(Q)))
invQError = max(max(rad(Q_inv)))

numDim


N = 25
lambda_p_u = lambda_u;
xi_p_u = real(Q(:, 1));
scale = 1;

[Pu] = oneDimManifold_intval_delayHenon(a, b, ...
    numDim, N, p_p, lambda_p_u, xi_p_u, scale);




theta = -1.2;
P_theta = intval(zeros(numDim, 1));
for k = 0:N;
        P_theta = P_theta + Pu(:, k+1)*theta^k; 
end

theta = lambda_p_u*theta;
P_theta_lambda = intval(zeros(numDim, 1));
for k = 0:N;
        P_theta_lambda = P_theta_lambda + Pu(:, k+1)*theta^k; 
end

error = norm(henonLikeMap(mid(P_theta), mid(a), mid(b), numDim) - mid(P_theta_lambda))





%stopNow = stopHere
numIterates = 12
numPoints = 2000

%BRANCH 1
theThetas = linspace(0.25, mid(abs(lambda_p_u))*0.25, numPoints);
Wu_fd_right = zeros(numPoints, numDim);

for l = 1:numPoints
    P_theta = intval(zeros(numDim, 1));
    theta = theThetas(l);
    for k = 0:N
        P_theta = P_theta + Pu(:, k+1)*theta^k; 
        Wu_fd_right(l, :) = mid(P_theta');
    end
end

P_theta
orbit_P_theta = P_theta'

Wu = zeros(numPoints*numIterates, numDim);

for l = 1:numPoints
    thisIterate = Wu_fd_right(l, :);
    Wu((l - 1)*numIterates + 1, :) = thisIterate;
    for m = 1:numIterates-1
        thisIterate =  henonLikeMap(thisIterate, mid(a), mid(b), numDim)';
        Wu((l-1)*numIterates + m+1, :) = thisIterate;
    end
end



%BRANCH 2

theThetas = linspace(-0.25, -mid(abs(lambda_p_u))*0.25, numPoints);
Wu_fd_left = zeros(numPoints, numDim);

for l = 1:numPoints
    P_theta = intval(zeros());
    theta = theThetas(l);
    for k = 0:N
        P_theta = P_theta + Pu(:, k+1)*theta^k; 
        Wu_fd_left(l, :) = mid(P_theta');
    end
end


P_theta
orbit_P_theta = P_theta'

Wu2 = zeros(numPoints*numIterates, numDim);

for l = 1:numPoints
    thisIterate = Wu_fd_left(l, :);
    Wu2((l - 1)*numIterates + 1, :) = thisIterate;
    for m = 1:numIterates-1
        thisIterate =  henonLikeMap(thisIterate, mid(a), mid(b), numDim)';
        Wu2((l-1)*numIterates + m+1, :) = thisIterate;
    end
end





temp = size(Wu2)
numPoints = temp(1,1)
infDist = 1000;


for k = 1:numPoints
   thisDist1 = norm(Wu(k, :) - p_p');
   thisDist2 = norm(Wu2(k,:) - p_p');
   if (thisDist1 < thisDist2) & (thisDist1 < infDist)
      infDist = thisDist1; 
      infPoint = Wu(k, :);
      infIndex = k;
   end
   if (thisDist2 < thisDist1) & (thisDist2 < infDist)
      infDist = thisDist2; 
      infPoint = Wu2(k, :);
      infIndex = k;
   end
end


infDist

infPoint
error = norm(infPoint - p_p', inf)


figure 
hold on 

plot3(mid(p_p(1)), mid(p_p(2)), mid(p_p(3)), 'k*')
plot3(Wu_fd_right(:, 1), Wu_fd_right(:,2), Wu_fd_right(:,3), 'g.')
plot3(Wu_fd_left(:, 1), Wu_fd_left(:,2), Wu_fd_left(:,3), 'c.')
plot3(Wu(:, 1), Wu(:,2), Wu(:,3), 'b.')
plot3(Wu2(:, 1), Wu2(:,2), Wu2(:,3), 'r.')

























