function varargout = cullSet(N, r, p)

temp = size(N);
numPoints = temp(1,1);
goodPoints = zeros(numPoints, 3);
points_found = 0;

for n = 1:numPoints
   x = N(n, 1:3);
   if (norm(x - p', inf) <= r)
      points_found = points_found + 1;
      goodPoints(points_found, 1:3) = x;
   end
end

if (points_found == 0)
    goodPoints = [nan, nan, nan];
else
    goodPoints = goodPoints(1:points_found, :);
end

f = goodPoints;