function varargout = cullSetII(N, r, p)

temp = size(N);
numPoints = temp(1,1);
goodPoints = zeros(numPoints, 3);
goodIndices = zeros(numPoints, 1);
points_found = 0;

for n = 1:numPoints
   n 
   x = N(n, 1:3);
   if (norm(x - p', inf) <= r)
      points_found = points_found + 1;
      goodPoints(points_found, 1:3) = x;
      goodIndices(points_found) = n;
   end
end

if (points_found == 0)
    goodPoints = [nan, nan, nan];
    goodIndices = nan;
else
    goodPoints = goodPoints(1:points_found, :);
    goodIndices = goodIndices(1:points_found);
end

varargout(1,1) = {goodPoints};
varargout(2,1) = {goodIndices};