function varargout = delayHenon_linearData_p(a, b, numDim)




%=============== Compute First Order Data =================================

x_p = (b-1 + sqrt((1-b)^2 + 4*a))/(2*a);
x_m = (b-1 - sqrt((1-b)^2 + 4*a))/(2*a);

p_p = intval(zeros(numDim, 1));
p_m = intval(zeros(numDim, 1));

for i = 1:numDim
   p_p(i) = x_p;
   p_m(i) = x_m;
end

Dfp_p = henonLikeDifferential_intval(p_p, a, b, numDim);

[Q_float, Sigma] = eig(full(Dfp_p.mid));

Q = intval(zeros(numDim, numDim));
theEigs = intval(zeros(numDim, numDim-1));
Lambda = intval(zeros(numDim-1, numDim-1));

[lambda_temp, xi_temp] = ...
     verifyeig(Dfp_p, Sigma(1,1), Q_float(:,1));
Q(:,1) = real(xi_temp);
lambda_u = lambda_temp;


inLoop = 1
tic
for i = 2:numDim
    [lambda_temp, xi_temp] = verifyeig(Dfp_p, Sigma(i,i), Q_float(:,i));
    Lambda(i-1,i-1) = lambda_temp;
    theEigs(:,i-1) = xi_temp;
	Q(:,i) = xi_temp;      
end
compTime = toc

Q_inv = inv(Q);

eigsError = max(max(rad(theEigs)))
eigVectError = max(max(rad(Q)))
invQError = max(max(rad(Q_inv)))

numDim



lambda_p_u = lambda_u;
xi_p_u = real(Q(:, 1));
scale = 1;


conjVectData = zeros(numDim- 1, 1);
k = 1

while k <= numDim-1
   if  abs(imag(mid(Lambda(k,k)))) < 10^(-6)
      conjVectData(k) = 1;
      k = k+1;
   else
       conjVectData(k) = 0;
       conjVectData(k+1) = 0;
       k = k+2;
   end
end





varargout(1,1)={p_p};
varargout(2,1)={Dfp_p};
varargout(3,1)= {lambda_p_u};
varargout(4,1)={Lambda};
varargout(5,1)={xi_p_u};    
varargout(6,1)={Q};
varargout(7,1)={Q_inv};
varargout(8,1)={conjVectData};
    
    
    