function f=evaluate_differential_2D(w, A, B, C, D, E, F, N)


s = w(1);
t = w(2);


A_partial_s = zeros(N, N);
B_partial_s = zeros(N, N);
C_partial_s = zeros(N, N);
D_partial_s = zeros(N, N);
E_partial_s = zeros(N, N);
F_partial_s = zeros(N, N);

A_partial_t = zeros(N, N);
B_partial_t = zeros(N, N);
C_partial_t = zeros(N, N);
D_partial_t = zeros(N, N);
E_partial_t = zeros(N, N);
F_partial_t = zeros(N, N);


for m = 0:(N-1)
  for n = 0:(N-1)
    A_partial_s(m+1, n+1) = (m+1)*A(m+2, n+1); 
    B_partial_s(m+1, n+1) = (m+1)*B(m+2, n+1); 
    C_partial_s(m+1, n+1) = (m+1)*C(m+2, n+1);
    D_partial_s(m+1, n+1) = (m+1)*D(m+2, n+1); 
    E_partial_s(m+1, n+1) = (m+1)*E(m+2, n+1); 
    F_partial_s(m+1, n+1) = (m+1)*F(m+2, n+1);
    
    
    A_partial_t(m+1, n+1) = (n+1)*A(m+1, n+2); 
    B_partial_t(m+1, n+1) = (n+1)*B(m+1, n+2); 
    C_partial_t(m+1, n+1) = (n+1)*C(m+1, n+2);
    D_partial_t(m+1, n+1) = (n+1)*D(m+1, n+2); 
    E_partial_t(m+1, n+1) = (n+1)*E(m+1, n+2); 
    F_partial_t(m+1, n+1) = (n+1)*F(m+1, n+2);
  end
end
  

P_s = evaluate_2D(s, t, ...
                  A_partial_s, B_partial_s, C_partial_s, ...
                  D_partial_s, E_partial_s, F_partial_s, N-1);
              
P_t = evaluate_2D(s, t, ...
                  A_partial_t, B_partial_t, C_partial_t, ...
                  D_partial_t, E_partial_t, F_partial_t, N-1);


f = [P_s(1), P_t(1);
     P_s(2), P_t(2);
     P_s(3), P_t(3);
     P_s(4), P_t(4);
     P_s(5), P_t(5);
     P_s(6), P_t(6)];
