function varargout = findGuess_prodSpaceHighDim(...
    numIterates, numPoints, ...
    p_p, lambda_p_u,  Lambda, A, ...
    conjVectData, Pu, nu_u, sigma_u, ...
    N, a, b, numDim)




%BRANCH 1
%theThetas_right = linspace(0.25, mid(abs(lambda_p_u))*0.25, numPoints);

theThetas_right = ...
    linspace(mid(abs(lambda_p_u^(-1))*exp(-sigma_u)*nu_u), mid((exp(-sigma_u))*nu_u), numPoints);

Wu_fd_right = zeros(numPoints, numDim);


for l = 1:numPoints
    P_theta = intval(zeros(numDim, 1));
    theta = theThetas_right(l);
    for k = 0:N
        P_theta = P_theta + Pu(:, k+1)*theta^k; 
        Wu_fd_right(l, :) = mid(P_theta');
    end
end



%BRANCH 2

theThetas_left = ...
    linspace(-mid(0.75*nu_u), -mid(abs(lambda_p_u^(-1))*0.75*nu_u), numPoints);
Wu_fd_left = zeros(numPoints, numDim);

for l = 1:numPoints
    P_theta = intval(zeros(numDim, 1));
    theta = theThetas_left(l);
    for k = 0:N
        P_theta = P_theta + Pu(:, k+1)*theta^k; 
        Wu_fd_left(l, :) = mid(P_theta');
    end
end


minDist = 100

for k = 1:numPoints
   thisIterate_left = iterate_point_k_highDim(Wu_fd_left(k, :), ...
       numIterates, mid(a), mid(b), numDim);
   thisIterate_right = iterate_point_k_highDim(Wu_fd_right(k, :), ...
       numIterates, mid(a), mid(b), numDim);
    
   leftDist = norm(mid(p_p) - thisIterate_left, inf);
   rightDist = norm(mid(p_p) - thisIterate_right, inf);
   if (leftDist < minDist) & (leftDist < rightDist)
       bestParm = theThetas_left(k);
       bestFD_point = Wu_fd_left(k,:);
       bestSide = 0;
       bestDist = leftDist;
       minDist = leftDist;
       closestPoint = thisIterate_left;
   end
   if (rightDist < minDist) & (rightDist <= leftDist)
       bestParm = theThetas_right(k);
       bestFD_point = Wu_fd_right(k,:);
       bestSide = 1;
       bestDist = rightDist;
       minDist = rightDist;
       closestPoint = thisIterate_right;
   end
end


thisOrbit = [bestFD_point];
for k = 1:numIterates
    thisOrbitPoint = iterate_point_k_highDim(bestFD_point, ...
       k, mid(a), mid(b), numDim);
    thisOrbit = [thisOrbit; thisOrbitPoint'];
end

backIterates = 15
thisOribt2 = zeros(backIterates, numDim);



for k = 1:backIterates
    thisOrbitPoint = inverse_iterate_point_k_highDim(bestFD_point, ...
       k, mid(a), mid(b), numDim);
    thisOrbit2(backIterates - k + 1, :) = thisOrbitPoint';
end

thisOrbit_total = [thisOrbit2; thisOrbit];


figure 
hold on
plot(thisOrbit_total(:,1), 'r')




%Project end-point onto stable manifold p + Q*tau
B = pinv(mid(A));
tauBar_0 = B*(closestPoint - mid(p_p))


[theta, tauBar, error] = homoclinicPoint_highDim(...
    bestParm, tauBar_0, numIterates-1, 1, ...
    mid(Pu), mid(p_p), mid(A), ...
    N, mid(a), mid(b), numDim);


theta = real(theta)
tau = zeros(numDim-1, 1);


k = 1
while k <= numDim-1
    thisTauBar = tauBar(k);
    if abs(imag(thisTauBar)) < 10^(-8)
       tau(k) = real(thisTauBar); 
       k = k+1;
    else
      tau(k) = real(thisTauBar);
      tau(k+1) = imag(thisTauBar);
      k = k+2;
    end
end



[theta_n, xn, tau_n, error_n] = homoclinicNewton_prodSpaceHighDim(...
        theta, tau, numIterates-1, 1, mid(Pu), N, ...
        mid(p_p), mid(A), mid(a), mid(b), conjVectData, numDim);
    
    
    
    
varargout(1,1)={theta_n};
varargout(2,1)= {xn};
varargout(3,1)={tau_n};
varargout(4,1) = {error_n};    

    
    
    
    
    
    
  
