function varargout = fourDimManifold_6DHenon_intval(a1, b1, c1, alpha1, tau1, ...
                                             a2, b2, c2, alpha2, tau2, ...
                              epsilon, N, p, ...
                              lambda_1, lambda_2, lambda_3, lambda_4, ...
                              xi_1, xi_2, xi_3, xi_4, ...
                              scale_1, scale_2, scale_3, scale_4);


                          
                          
Dfp = henon6D_differential_intval(p, alpha1, tau1, a1, b1, c1, ...
                              alpha2, tau2, a2, b2, c2, epsilon);
                          
                                                                          
Id = intval(eye(6));
      
%Initialize Coefficient Containers:      


A = intval(zeros(N+1, N+1, N+1, N+1));
B = intval(zeros(N+1, N+1, N+1, N+1));
C = intval(zeros(N+1, N+1, N+1, N+1));
D = intval(zeros(N+1, N+1, N+1, N+1));
E = intval(zeros(N+1, N+1, N+1, N+1));
F = intval(zeros(N+1, N+1, N+1, N+1));

%Assign first order data:
A(1,1,1,1) = p(1);
B(1,1,1,1) = p(2);
C(1,1,1,1) = p(3);
D(1,1,1,1) = p(4);
E(1,1,1,1) = p(5);
F(1,1,1,1) = p(6);


A(2,1,1,1) = scale_1*xi_1(1);
A(1,2,1,1) = scale_2*xi_2(1);
A(1,1,2,1) = scale_3*xi_3(1);
A(1,1,1,2) = scale_4*xi_4(1);

B(2,1,1,1) = scale_1*xi_1(2);
B(1,2,1,1) = scale_2*xi_2(2);
B(1,1,2,1) = scale_3*xi_3(2);
B(1,1,1,2) = scale_4*xi_4(2);

C(2,1,1,1) = scale_1*xi_1(3);
C(1,2,1,1) = scale_2*xi_2(3);
C(1,1,2,1) = scale_3*xi_3(3);
C(1,1,1,2) = scale_4*xi_4(3);

D(2,1,1,1) = scale_1*xi_1(4);
D(1,2,1,1) = scale_2*xi_2(4);
D(1,1,2,1) = scale_3*xi_3(4);
D(1,1,1,2) = scale_4*xi_4(4);

E(2,1,1,1) = scale_1*xi_1(5);
E(1,2,1,1) = scale_2*xi_2(5);
E(1,1,2,1) = scale_3*xi_3(5);
E(1,1,1,2) = scale_4*xi_4(5);

F(2,1,1,1) = scale_1*xi_1(6);
F(1,2,1,1) = scale_2*xi_2(6);
F(1,1,2,1) = scale_3*xi_3(6);
F(1,1,1,2) = scale_4*xi_4(6);


%--------------------------------------------------------------------------
%Solve the Homological Equations and Determine the coefficients
%--------------------------------------------------------------------------


for n1 = 2:N
    n1
    N
    for n2 = 0:n1
        for n3 = 0:n2
            for n4 = 0:n3

m = n1 - n2;
n = n2 - n3;
l = n3 - n4;
k = n4;

               Amn = Dfp - ...
		 (lambda_1^m * lambda_2^n * ...
		  lambda_3^l * lambda_4^k)*Id;


thisIndex = (m+1)*(n+1)*(l+1)*(k+1);


Q1 = reshape(A(1:m+1, 1:n+1, 1:l+1, 1:k+1), thisIndex, 1);
Q1 = Q1(2:thisIndex-1);
Q1_flip = flipud(Q1);
Q1_T = transpose(Q1);

Q2 = reshape(B(1:m+1, 1:n+1, 1:l+1, 1:k+1), thisIndex, 1);
Q2 = Q2(2:thisIndex-1);
Q2_flip= flipud(Q2);
Q2_T = transpose(Q2);

Q4 = reshape(D(1:m+1, 1:n+1, 1:l+1, 1:k+1), thisIndex, 1);
Q4 = Q4(2:thisIndex-1);
Q4_flip= flipud(Q4);
Q4_T = transpose(Q4);

Q5 = reshape(E(1:m+1, 1:n+1, 1:l+1, 1:k+1), thisIndex, 1);
Q5 = Q5(2:thisIndex-1);
Q5_flip= flipud(Q5);
Q5_T = transpose(Q5);



Y2_term = Q2_T*Q2_flip;
Y5_term = Q5_T*Q5_flip;

term1 = a1*Q1_T*Q1_flip + b1*Q1_T*Q2_flip + c1*Y2_term + epsilon*Y5_term;
term2 = a2*Q4_T*Q4_flip + b2*Q4_T*Q5_flip + c2*Y5_term + epsilon*Y2_term;



smn = -[term1;
	     0;
	     0;
	     term2;
	     0;
	     0];


%smn_test = -compute_smnlk_6D(m, n, l, k, ...
			      %             A, B, C, D, E, F, ...
			      %             alpha1, tau1, a1, b1, c1, ...
			      %             alpha2, tau2, a2, b2, c2, ...
			      %            epsilon, N);
%s_error = sup(norm(smn - smn_test))
%if abs(s_error) > 10^(-6)
%    stopNow = errorCrash
%end

  vmn = Amn\smn;

A(m+1, n+1, l+1, k+1) = vmn(1);
B(m+1, n+1, l+1, k+1) = vmn(2);
C(m+1, n+1, l+1, k+1) = vmn(3);
D(m+1, n+1, l+1, k+1) = vmn(4);
E(m+1, n+1, l+1, k+1) = vmn(5);
F(m+1, n+1, l+1, k+1) = vmn(6);

            end
        end
    end
end
















%for n = 0:N
%    n
%    N
%    for m = 0:N
%        for k = 0:N
%            for l = 0:N
%                if (m+n+l+k >= 2) & (n+m+l+k <= N)
%
%                    %format short
%                    %m
%                    %n
%                    %l
%                    %k
%                    
%                    Amn = Dfp - ...
%                        (lambda_1^m * lambda_2^n * ...
%                         lambda_3^l * lambda_4^k)*Id;          
%
%                    smn = -compute_smnlk_6D_intval(m, n, l, k, ...
%                                  A, B, C, D, E, F, ...
%                                  alpha1, tau1, a1, b1, c1, ...
%                                  alpha2, tau2, a2, b2, c2, ...
%                                  epsilon, N);
%
%                    %vmn = Amn\smn;
%                    vmn = verifylss(Amn, smn);    
%                    
%                    A(m+1, n+1, l+1, k+1) = vmn(1);
%                    B(m+1, n+1, l+1, k+1) = vmn(2);
%                    C(m+1, n+1, l+1, k+1) = vmn(3);
%                    D(m+1, n+1, l+1, k+1) = vmn(4);
%                    E(m+1, n+1, l+1, k+1) = vmn(5);
%                    F(m+1, n+1, l+1, k+1) = vmn(6);
%                    
%                    
%                    
%                    %stopNow = stopHere
%                end
%                
%            end
%        end
%    end
%end


varargout(1,1)={A};
varargout(2,1)={B};
varargout(3,1)={C};
varargout(4,1)={D};
varargout(5,1)={E};
varargout(6,1)={F};
