function varargout=henon3D_data(alpha, tau, a, b, c);


%Fixed Points, Eigenvalues, Eigenvectors, ect:  ================

x0 = (1/2)*(-tau + sqrt( tau^2 - 4*alpha));
x1 = (1/2)*(-tau - sqrt( tau^2 - 4*alpha));

p0 = [x0; x0; x0];
p1 = [x1; x1; x1];

fp0 = henon3D(p0, alpha, tau, a, b, c);
fp1 = henon3D(p1, alpha, tau, a, b, c);

%Differential at p0;

A_0 = (2*a + b)*x0 + tau;
B_0 = (2*c + b)*x0;

Df0 = [ A_0, B_0, 1;
          1,   0, 0;
          0,   1, 0];
    
%Differential of p1;

A_1 = (2*a + b)*x1 + tau;
B_1 = (2*c + b)*x1;

Df1 = [ A_1, B_1, 1;
          1,   0, 0;
          0,   1, 0];
    
%Eigenvalues and vectors of Df0:

[E0, eigenvalues_0] = eigs(Df0);

E0
eigenvalues_0

%Eigenvalues and vectors of Df1:

[E1, eigenvalues_1] = eigs(Df1);

E1
eigenvalues_1

%Check linear stablilty of the fixed points

stability_0 = norm(eigenvalues_0(2,2))
stability_1 = norm(eigenvalues_1(1,1))



%Return:
varargout(1,1)={x0};
varargout(2,1)={x1};
varargout(3,1)={p0};
varargout(4,1)={p1};
varargout(5,1)={fp0};
varargout(6,1)={fp1};
varargout(7,1)={A_0};
varargout(8,1)={B_0};
varargout(9,1)={Df0};
varargout(10,1)={A_1};
varargout(11,1)={B_1};
varargout(12,1)={Df1};
varargout(13,1)={E0};
varargout(14,1)={eigenvalues_0};
varargout(15,1)={E1};
varargout(16,1)={eigenvalues_1};
varargout(17,1)={stability_0};
varargout(18,1)={stability_1};