function f=henon6D_differential(w, alpha1, tau1, a1, b1, c1, ...
                                   alpha2, tau2, a2, b2, c2, epsilon);

                               

x1_plus =  (1/2)*(-tau1 + sqrt( tau1^2 - 4*alpha1));
x1_minus = (1/2)*(-tau1 - sqrt( tau1^2 - 4*alpha1));

x2_plus =  (1/2)*(-tau2 + sqrt( tau2^2 - 4*alpha2));
x2_minus = (1/2)*(-tau2 - sqrt( tau2^2 - 4*alpha2));
                               
                               
                                                      
w1 = w(1:3);
w2 = w(4:6);

y1 = w(2);
y2 = w(5);


p1_prime = epsilon*(2*y1 - (x1_plus + x1_minus));
p2_prime = epsilon*(2*y2 - (x2_plus + x2_minus));

                               
Df1 = henon3D_differential(w1, alpha1, tau1, a1, b1, c1);
Df2 = henon3D_differential(w2, alpha2, tau2, a2, b2, c2);


DP1 = [0, p2_prime,  0;
       0,        0,  0;
       0,        0,  0];
            
DP2 = [0, p1_prime,  0;
       0,        0,  0;
       0,        0,  0];


f=[ Df1, DP1;
    DP2, Df2];




