clear
format long

%startintlab


a = intval('1.6')
b = intval('0.1')
numDim = 9



Ns = 4




%=========================================================================================================
%
%========================================================================================================


x_p = (b-1 + sqrt((1-b)^2 + 4*a))/(2*a);
x_m = (b-1 - sqrt((1-b)^2 + 4*a))/(2*a);

p_p = intval(zeros(numDim, 1));
p_m = intval(zeros(numDim, 1));

for i = 1:numDim
   p_p(i) = x_p;
   p_m(i) = x_m;
end


fp_test1 = sup(norm(p_p - henonLikeMap_intval(p_p, a, b, numDim)))
fp_test2 = sup(norm(p_m - henonLikeMap_intval(p_m, a, b, numDim)))


Dfp_p = henonLikeDifferential_intval(p_p, a, b, numDim)


[Q_float, Sigma] = eig(full(Dfp_p.mid))

Q = intval(zeros(numDim, numDim));
theEigs = intval(zeros(numDim, numDim-1));
Lambda = intval(zeros(numDim-1, numDim-1));

[lambda_temp, xi_temp] = ...
     verifyeig(Dfp_p, Sigma(1,1), Q_float(:,1));
Q(:,1) = xi_temp;
lambda_u = lambda_temp;

for i = 2:numDim
    
    [lambda_temp, xi_temp] = ...
     verifyeig(Dfp_p, Sigma(i,i), Q_float(:,i));
    Lambda(i-1,i-1) = lambda_temp;
    theEigs(:,i-1) = xi_temp
	Q(:,i) = xi_temp      
end


mu_star = abs(Lambda(numDim-1, numDim-1))
mu_plus = abs(Lambda(1,1))
C_1 = norm(Q, inf)*norm(inv(Q), inf)
approxCond = (log(mu_star) - log(C_1))/log(mu_plus)
CondNum = Ns + 1 
goodCond = CondNum - approxCond




scale = 1

tic

Ps = henonLikeStableComp_intval(p_p, Lambda, Q(:,2:numDim), scale, a, b, ...
                                        Ns, numDim);

compTime = toc                                    
                                    
size(Ps)


numNonZero = nnz(Ps.mid)
pascalNum = numNonZero/numDim
compTime



Pvect = reshape(abs(Ps), ((Ns+1)^(numDim-1))*numDim, 1);
Pvect = Pvect(Pvect >= 10^(-50));
Errors = sup(rad(Pvect)./abs(Pvect));
biggestRelError = max(Errors)




