function varargout = homoclinicInitialGuess(...
      D0u, I_left, I_right, ...
      W0u_global, W0s_fd_left, W0s_fd_right, ...
      alpha, tau, a, b, c, p, tol, lowerBoundGuess);

maxTries = 200; 
numTries = 0;
bestDist = 1;
 
while ((bestDist > tol) & (numTries <= maxTries)) 
  
    numTries
    this_fd_left = k_preImage_set(W0s_fd_left, ...
                     lowerBoundGuess + numTries, ...
                     alpha, tau, a, b, c); 
    this_fd_right = k_preImage_set(W0s_fd_right, ...
                     lowerBoundGuess + numTries, ...
                     alpha, tau, a, b, c);
    
    this_fd_left = cullSet(this_fd_left, 8, p);
    this_fd_right = cullSet(this_fd_right, 8, p);
    
    
    figure
    hold on
    plot3(this_fd_left(:, 1), this_fd_left(:, 2), this_fd_left(:, 3), '.r')
    plot3(this_fd_right(:, 1), this_fd_right(:, 2), this_fd_right(:, 3), '.g')
    plot3(W0u_global(:, 1), W0u_global(:, 2), W0u_global(:, 3), '.b')
    
    %stopHere = stopNow
    
    thisDist_left = 1;
    thisDist_right = 1;
    if (isnan(this_fd_left(1,1)) == 0)
        [thisDist_left, pointIndex_theta1, pointIndex_left] = ...
            setDist(W0u_global, this_fd_left, p)
    end
    if (isnan(this_fd_right(1,1)) == 0)
        [thisDist_right, pointIndex_theta2, pointIndex_right ] = ...
            setDist(W0u_global, this_fd_right, p)
    end

    
    bestDist
    
    if ((thisDist_left < bestDist) & (thisDist_left < thisDist_right))
          bestDist = thisDist_left
          theta = D0u(pointIndex_theta1, :)
          tau_parm = I_left(pointIndex_left)
          k_s = lowerBoundGuess + numTries
    elseif ((thisDist_right < bestDist) & (thisDist_right < thisDist_left))
          bestDist = thisDist_right
          theta = D0u(pointIndex_theta2, :)
          tau_parm = I_right(pointIndex_right)
          k_s = lowerBoundGuess + numTries
    end
    
    %stopHere = stopNow
    numTries = numTries + 1;
end

varargout(1,1)={theta};
varargout(2,1)={tau_parm};
varargout(3,1)={k_s};









