function varargout = homoclinicNewton_prodSpaceHighDim(...
    theta_0, tau_0, n_u, n_s, Pu, N, p, A, a, b, conjDataVect, dimNum)



K = n_u + n_s
Kmid = ceil(K/2)


xn = zeros(dimNum*(K-1), 1);



for j = 2:N+1
    DPu(:, j-1) = (j-1)*Pu(:, j);
end


%This x is the image under the unstable parameterization of
%   theta, where theta is the one dimensional real unstable parameter.

this_x = zeros(dimNum, 1);
for j = 1:dimNum
    this_x(j) = horner(theta_0, Pu(j, :), N); 
end


%This y is the image under the stable parameterization of tau.  Since
%tau is real, and Q is in complex conjugate variables care must be
%taken.


complexTau = zeros(dimNum-1,1);
k = 1
while k <= dimNum-1
    thisConj = conjDataVect(k);
    if thisConj == 1
       complexTau(k) = tau_0(k); 
       k = k+1;
    else
      complexTau(k) = tau_0(k) + i*tau_0(k+1);
      complexTau(k+1) = tau_0(k) - i*tau_0(k+1);
      k = k+2;
    end
end


complexTau

this_y = real(p + A*complexTau)


coDim = dimNum - 1;
for j = 1:Kmid 
   this_orbit = henonLikeMap(this_x, a, b, dimNum);
   xn((dimNum*j-coDim):(dimNum*j)) = this_orbit;
   this_x = this_orbit;
end




thisIndex = 0;
for j = (Kmid+1):(K-1)
   this_orbit = henonLikeMap_inv(this_y, a, b, dimNum);
   xn((dimNum*(K-1) - dimNum*thisIndex - coDim):(dimNum*(K-1) - dimNum*thisIndex)) = this_orbit;
   this_y = this_orbit;
   thisIndex = thisIndex + 1;
end


theta_n = theta_0;
tau_n = tau_0;


x = zeros(dimNum*K, 1);
Fx = x;
DFx = zeros(dimNum*K, dimNum*K);

thisError = inf;
numLoops = 0;   


%============= The Newton Loop ============================================



while ((thisError > 10^(-13)) & numLoops < 25)

    
numLoops = numLoops + 1
 


Pu_zn = zeros(dimNum, 1);
for j = 1:dimNum
    Pu_zn(j) = horner(theta_n, Pu(j, :), N); 
end


%complexify variables:
complexTau = zeros(dimNum-1,1);
k = 1
while k <= dimNum-1
    thisConj = conjDataVect(k);
    if thisConj == 1
       complexTau(k) = tau_n(k); 
       k = k+1;
    else
      complexTau(k) = tau_n(k) + i*tau_n(k+1);
      complexTau(k+1) = tau_n(k) - i*tau_n(k+1);
      k = k+2;
    end
end

Ps_xn = real(p + A*complexTau);


%Differential of Pu(z_n):
DPu_theta = zeros(dimNum, 1);
for j = 1:dimNum
DPu_theta(j) = horner(theta_n, DPu(j,:), N-1);
end


 
 %Differential of Ps(theta_n):
 DPs_tauComplex = A;
 
%Real Differential:
DPs_tau = zeros(dimNum, dimNum-1);
k = 1;
while k <= dimNum-1
    thisConj = conjDataVect(k);
    if thisConj == 1
       DPs_tau(:, k) = A(:, k); 
       k = k+1;
    else
      DPs_tau(:, k) = 2*real(A(:,k));
      DPs_tau(:, k+1) = -2*imag(A(:, k));
      k = k+2;
    end
end
 
 
 %xn_size = size(xn)
 %dim_x_Km1 = dimNum*(K-1)
 %size_tau_n = size(tau_n)
 %dimNum*K - dimNum + 2
 %dimNum*K
 
 x(1) = theta_n;
 x(2:size(xn, 1)+1) = xn;
 x(dimNum*K - dimNum+2:dimNum*K) = tau_n; 
 
 %==============Evaluate F ================================================
 Fx(1:dimNum) = henonLikeMap_inv(xn(1:dimNum), a, b, dimNum) - Pu_zn;
 
 
 for j = 2:Kmid
    Fx(dimNum*j - coDim:dimNum*j) = ...
        henonLikeMap_inv(xn(dimNum*j - coDim:dimNum*j), a, b, dimNum) ...
        - xn(dimNum*(j-1)-coDim:dimNum*(j-1));    
 end
 for j = (Kmid+1):(K-1)
    Fx(dimNum*j - coDim:dimNum*j) = ...
        henonLikeMap(xn(dimNum*(j-1) - coDim:dimNum*(j-1)), a, b, dimNum)...
        - xn(dimNum*j - coDim:dimNum*j);
 end
 
 Fx((dimNum*K - coDim):(dimNum*K)) = ...
     henonLikeMap(xn((dimNum*(K-1) - coDim):(dimNum*(K-1))), a, b, dimNum) ...
     -  Ps_xn;

 
errorTest = norm(Fx, inf) 
  

%=========== Construct the Differential ===================================

DFx = zeros(dimNum*K, dimNum*(K-1));


DFx(1:dimNum, 1:dimNum) = ...
    henonLikeDifferential_inv(xn(1:dimNum), a, b, dimNum); 
 
 
 Id = eye(dimNum);
 for j = 2:Kmid
     
    DFx(dimNum*j - coDim:dimNum*j,dimNum*(j-1) -coDim:dimNum*(j-1)) = -Id;
    DFx(dimNum*j - coDim:dimNum*j, dimNum*j -coDim:dimNum*j) = ...
        henonLikeDifferential_inv(xn(dimNum*j-coDim:dimNum*j), a, b, dimNum); 
 end
 for j = (Kmid+1):(K-1)
     
    DFx((dimNum*j-coDim):(dimNum*j), dimNum*(j-1) -coDim:dimNum*(j-1)) = ...
        henonLikeDifferential(xn(dimNum*(j-1)-coDim:dimNum*(j-1)), a, b, dimNum);
    DFx(dimNum*j-coDim:dimNum*j, dimNum*j - coDim:dimNum*j) = -Id;
 end
  
DFx(dimNum*K-coDim:dimNum*K, dimNum*(K-1) - coDim: dimNum*(K-1)) =  ...
  henonLikeDifferential(xn(dimNum*(K-1)-coDim:dimNum*(K-1)), a, b, dimNum);

 
DPu_theta_col = zeros(dimNum*K, 1);
DPs_tau_col = zeros(dimNum*K, 1:coDim);

DPu_theta_col(1:dimNum, 1) = DPu_theta;
DPs_tau_col(dimNum*K - coDim:dimNum*K, 1:coDim) = DPs_tau;


DFx = [DPu_theta_col, DFx, DPs_tau_col];


%Compute the Newton Step:
xnew = x - inv(DFx)*Fx;
 
theta_n = xnew(1);
xn = xnew(2:dimNum*(K-1) + 1);
tau_n = xnew(dimNum*(K-1) + 2: dimNum*K);
 

Pu_zn = zeros(dimNum, 1);
for j = 1:dimNum
    Pu_zn(j) = horner(theta_n, Pu(j, :), N); 
end


%complexify variables:
complexTau = zeros(dimNum-1,1);
k = 1
while k <= dimNum-1
    thisConj = conjDataVect(k);
    if thisConj == 1
       complexTau(k) = tau_n(k); 
       k = k+1;
    else
      complexTau(k) = tau_n(k) + i*tau_n(k+1);
      complexTau(k+1) = tau_n(k) - i*tau_n(k+1);
      k = k+2;
    end
end

Ps_xn = real(p + A*complexTau);

 
 %==============Evaluate F ================================================
 Fx_new(1:dimNum) = henonLikeMap_inv(xn(1:dimNum), a, b, dimNum) - Pu_zn;
 
 
 for j = 2:Kmid
    Fx_new(dimNum*j - coDim:dimNum*j) = ...
        henonLikeMap_inv(xn(dimNum*j - coDim:dimNum*j), a, b, dimNum) ...
        - xn(dimNum*(j-1)-coDim:dimNum*(j-1));    
 end
 for j = (Kmid+1):(K-1)
    Fx_new(dimNum*j - coDim:dimNum*j) = ...
        henonLikeMap(xn(dimNum*(j-1) - coDim:dimNum*(j-1)), a, b, dimNum)...
        - xn(dimNum*j - coDim:dimNum*j);
 end
 
 Fx_new((dimNum*K - coDim):(dimNum*K)) = ...
     henonLikeMap(xn((dimNum*(K-1) - coDim):(dimNum*(K-1))), a, b, dimNum) ...
     -  Ps_xn;


%lastError = thisError
thisError = norm(Fx_new, inf)


end
 

varargout(1,1)={theta_n};
varargout(2,1)= {xn};
varargout(3,1)={tau_n};
varargout(4,1) = {thisError};

