function f=inv_henon6D_intval(w, alpha1, tau1, a1, b1, c1, ...
                                 alpha2, tau2, a2, b2, c2, ...
                                 epsilon);

                    

x1_plus =  (1/2)*(-tau1 + sqrt( tau1^2 - 4*alpha1));
x1_minus = (1/2)*(-tau1 - sqrt( tau1^2 - 4*alpha1));


x2_plus =  (1/2)*(-tau2 + sqrt( tau2^2 - 4*alpha2));
x2_minus = (1/2)*(-tau2 - sqrt( tau2^2 - 4*alpha2));
                               
                                                                              
w1 = w(1:3);
w2 = w(4:6);

z1 = w(3);
z2 = w(6);
    

p1 = [epsilon*(z1*(z1 - (x1_plus + x1_minus)) + x1_plus*x1_minus);
                                                                0;
                                                                0];

p2 = [epsilon*(z2*(z2 - (x2_plus + x2_minus)) + x2_plus*x2_minus);
                                                                 0;
                                                                 0];
                      
                      
f1_inv = inv_henon3D_intval(w1, alpha1, tau1, a1, b1, c1);
f2_inv = inv_henon3D_intval(w2, alpha2, tau2, a2, b2, c2);


F1 = f1_inv - p2;
F2 = f2_inv - p1;


f=[F1;
   F2];


