function varargout=makeBestDomain(R, bound, num_angle_divisions, num_radial_divisions,  Au, Bu, Cu, As, Bs, Cs, N)

m = num_radial_divisions;
n = num_angle_divisions;

r_step = R/m;
theta_step = 2*pi/n;

u_pointNum = 1;
s_pointNum = 1;

for i = 1:m
   this_r = i*r_step;
    for j = 1:n
       thisRay = this_r*[cos((j-1)*theta_step), sin((j-1)*theta_step)]; 
       test_u = evaluate_complexCase(thisRay(1), thisRay(2), Au, Bu, Cu, N);
       test_s = evaluate_complexCase(thisRay(1), thisRay(2), As, Bs, Cs, N);
       if (norm(test_u) <= bound)
          Du(u_pointNum, :) = thisRay;
          Wu(u_pointNum, :) = test_u;
          u_pointNum = u_pointNum+1;
       end
       if (norm(test_s) <=bound)
          Ds(s_pointNum, :) = thisRay;
          Ws(s_pointNum, :) = test_s;
          s_pointNum = s_pointNum+1;
       end    
    end
end    

Ws = real(Ws);
Wu = real(Wu);

varargout(1,1) = {Du};
varargout(2,1) = {Ds};
varargout(3,1) = {Wu};
varargout(4,1) = {Ws};

