function varargout=makeBestErrorDomain(R, error_tol, ...
    num_angle_divisions, num_radial_divisions, ...
    lambda_u, lambda_s, Au, Bu, Cu, ...
    As, Bs, Cs, N, alpha, tau, a, b, c)


m = num_radial_divisions;
n = num_angle_divisions;

totalPossiblePoints = m*n;
Wu = zeros(totalPossiblePoints, 3);
Ws = Wu;
Du = zeros(totalPossiblePoints, 2);
Ds = Du;

r_step = R/m;
theta_step = 2*pi/n;

u_pointNum = 1;
s_pointNum = 1;



for i = 1:m
   rad_number = i
   this_r = i*r_step;
    for j = 1:n
       thisRay = this_r*[cos((j-1)*theta_step), sin((j-1)*theta_step)]; 
       test_u = evaluate_complexCase(thisRay(1), thisRay(2), ...
           Au, Bu, Cu, N);
       test_s = evaluate_complexCase(thisRay(1), thisRay(2), ...
           As, Bs, Cs, N);
       test_u_error = u_errorNorm(thisRay(1), thisRay(2), ...
           Au, Bu, Cu, N, alpha, tau, a, b, c, lambda_u);
       test_s_error = s_errorNorm(thisRay(1), thisRay(2), ...
           As, Bs, Cs, N, alpha, tau, a, b, c, lambda_s);
       if (test_u_error <= error_tol)
          Du(u_pointNum, :) = thisRay;
          Wu(u_pointNum, :) = test_u;
          u_pointNum = u_pointNum+1;
       end
       if (test_s_error <= error_tol)
          Ds(s_pointNum, :) = thisRay;
          Ws(s_pointNum, :) = test_s;
          s_pointNum = s_pointNum+1; 
       end    
    end
end    

pointsFound_u = u_pointNum - 1
pointsFound_s = s_pointNum - 1
Ws = real(Ws);
Wu = real(Wu);

ret_Du = Du(1:pointsFound_u, :);
ret_Ds = Ds(1:pointsFound_s, :);
ret_Wu = Wu(1:pointsFound_u, :);
ret_Ws = Ws(1:pointsFound_s, :);

varargout(1,1) = {ret_Du};
varargout(2,1) = {ret_Ds};
varargout(3,1) = {ret_Wu};
varargout(4,1) = {ret_Ws};



