function varargout=makeBestErrorDomain_vectorized(R, error_tol, ...
    num_angle_divisions, num_radial_divisions, ...
    lambda_u, lambda_s, Au, Bu, Cu, ...
    As, Bs, Cs, N, alpha, tau, a, b, c)


m = num_radial_divisions;
n = num_angle_divisions;

totalPossiblePoints = m*n;
Wu = zeros(totalPossiblePoints, 3);
Ws = Wu;
Du = zeros(totalPossiblePoints, 2);
Ds = Du;

r_step = R/m;
theta_step = 2*pi/n;

u_pointNum = 1;
s_pointNum = 1;


the_rs = (0.0:r_step:R);
thetas = (0.0:theta_step:(2*pi));
%thisRay_x = the_rs .*cos(thetas);
%thisRay_y = the_rs .*sin(thetas);



test_u_error = zeros(m,n);
test_s_error = test_u_error;
thisRay_u_x = test_u_error;
thisRay_u_y = test_u_error;
thisRay_s_x = test_u_error;
thisRay_s_y = test_u_error;

test_u_x = test_u_error;
test_u_y = test_u_error;
test_u_z = test_u_error;
test_s_x = test_u_error;
test_s_y = test_u_error;
test_s_z = test_u_error;

for i = 1:m
   rad_number = i
   %this_r = i*r_step;
    for j = 1:n
       thisRay = the_rs(i)*[cos(thetas(j)), sin(thetas(j))]; 
       thisRay_u_x(i,j) = thisRay(1);
       thisRay_u_y(i,j) = thisRay(2);    
       test_u = evaluate_complexCase(thisRay(1), thisRay(2), ...
           Au, Bu, Cu, N);

       test_u_error(i,j) = u_errorNorm(thisRay(1), thisRay(2), ...
           Au, Bu, Cu, N, alpha, tau, a, b, c, lambda_u);
 
       test_u_x(i,j) = test_u(1);
       test_u_y(i,j) = test_u(2);
       test_u_z(i,j) = test_u(3);
    end
end    



for i = 1:m
   rad_number = i
   %this_r = i*r_step;
    for j = 1:n
       thisRay = the_rs(i)*[cos(thetas(j)), sin(thetas(j))]; 
       thisRay_s_x(i,j) = thisRay(1);
       thisRay_s_y(i,j) = thisRay(2);    
  
       test_s = evaluate_complexCase(thisRay(1), thisRay(2), ...
           As, Bs, Cs, N);
 
       test_s_error(i,j) = s_errorNorm(thisRay(1), thisRay(2), ...
           As, Bs, Cs, N, alpha, tau, a, b, c, lambda_s);
 
       test_s_x(i,j) = test_s(1);
       test_s_y(i,j) = test_s(2);
       test_s_z(i,j) = test_s(3);
    end
end    

for i = 1:m
    for j = 1:n
       if (test_u_error(i,j) <= error_tol)
          Du(u_pointNum, 1) = thisRay_u_x(i,j);
          Du(u_pointNum, 2) = thisRay_u_y(i,j);
          
          Wu(u_pointNum, 1) = test_u_x(i,j);
          Wu(u_pointNum, 2) = test_u_y(i,j);
          Wu(u_pointNum, 3) = test_u_z(i,j);
      
          u_pointNum = u_pointNum+1;
       end
       if (test_s_error(i,j) <= error_tol)
          Ds(s_pointNum, 1) = thisRay_s_x(i,j);
          Ds(s_pointNum, 2) = thisRay_s_y(i,j);
          
          Ws(s_pointNum, 1) = test_s_x(i,j);
          Ws(s_pointNum, 2) = test_s_y(i,j);
          Ws(s_pointNum, 3) = test_s_z(i,j);
          
          s_pointNum = s_pointNum+1; 
       end    
    end
end

pointsFound_u = u_pointNum - 1
pointsFound_s = s_pointNum - 1
Ws = real(Ws);
Wu = real(Wu);

ret_Du = Du(1:pointsFound_u, :);
ret_Ds = Ds(1:pointsFound_s, :);
ret_Wu = Wu(1:pointsFound_u, :);
ret_Ws = Ws(1:pointsFound_s, :);

varargout(1,1) = {ret_Du};
varargout(2,1) = {ret_Ds};
varargout(3,1) = {ret_Wu};
varargout(4,1) = {ret_Ws};