function varargout=newtonRingIterate_complexCase(N, q0, ...
    guess, A, B, C, tolerance, maxTry, eta1, eta2);


%Set up first Newton Iteration
%initialize loop variables:
Try = 0;
z_n = [guess(1); guess(2); guess(3); guess(4)];
F = 1;

while ((norm(F) > tolerance) & (Try <= maxTry))
    F = evaluate_complexCase(z_n(1), z_n(2), A, B, C, N)' - L(z_n(3), z_n(4), eta1, eta2, q0); 
    DP = evaluate_jacob_complexCase(z_n(1), z_n(2), A, B, C, N);
    DF(1:3, 1:2) = DP;
    DF(1:3, 3) = -eta1;
    DF(1:3, 4) = -eta2; 
    DF_inv = pinv(DF);    
    z_n = z_n - DF_inv*F; 
    Try = Try + 1;
end 

Pz_n = evaluate_complexCase(z_n(1), z_n(2), A, B, C, N)';
Lz_n = L(z_n(3), z_n(4), eta1, eta2, q0);

newtonFailed = 1;
pointsFount = 0;
new_W = [0, 0, 0];
new_Parm = [0, 0];
new_Plane = [0, 0];

if (norm(F) <= tolerance)
    new_W = Pz_n';
    new_Parm = z_n(1:2); 
    new_Plane = z_n(3:4);
    newtonFailed = 0;
    pointsFound = 1;
end

%Return:
varargout(1,1)={new_W};
varargout(2,1)={new_Parm};
varargout(3,1)={new_Plane};
