function varargout = oneDimManifold_intval_3DHenon(a, b, c, alpha, tau, ...
    N, p, lambda, xi, scale);


%Initialize first order data:
x0 = p(1);

A_0 = (2*a + b)*x0 + tau;
B_0 = (2*c + b)*x0;

Df0 = [ A_0, B_0, 1;
          1,   0, 0;
          0,   1, 0];
    
  
%Initialize Coefficient Containers:      
order_1 = N;

A = intval(zeros(1, order_1+1));
B = intval(zeros(1, order_1+1));
C = intval(zeros(1, order_1+1));

%Assign first order data:
A(1) = x0;
B(1) = x0;
C(1) = x0;


A(2) = scale*xi(1);
B(2) = scale*xi(2);
C(2) = scale*xi(3);


%--------------------------------------------------------------------------
%Solve the Homological Equations and Determine the coefficients
%--------------------------------------------------------------------------


for (n = 2:order_1)
    HomMatrix = [tau + 2*a*x0 + b*x0 - lambda^n,      b*x0 + 2*c*x0,             1;
                                              1,          -lambda^n,             0;
                                              0,                  1,     -lambda^n];
        
A_reshape = A(2:n);
A_flip = fliplr(A_reshape);
A_transpose = transpose(A_reshape);


B_reshape = B(2:n);
B_flip = fliplr(B_reshape);

Sn = a*A_flip*A_transpose + ...
     b*B_flip*A_transpose + ...
  c*B_flip*transpose(B_reshape);

    %Sn_test = intval(0);
    %for (k = 1:(n-1))
    %    %k
    %    %A'
    %    %Ak = A(k+1)
    %    %Ank = A(n-k+1)
    %    %Ak_error = rad(A(k+1))
    %    %Ank_error = rad(A(n-k+1))
    %    %termError = rad(a*A(k+1)*A(n-k+1))
    %    Sn_test = Sn_test + a*A(k+1)*A(n-k+1) + b*A(k+1)*B(n-k+1) + c*B(k+1)*B(n-k+1);
    %    %thisSn_error = rad(S_n)
    %end
    %Sn_test

    %n
    %rad(S_n)
    %Serror(n-1) = rad(S_n); 
        
    thisRHS = [-Sn;
               0;
               0];
     
    thisCoeff = verifylss(HomMatrix, thisRHS);       
    %thisCoeff = HomMatrix\thisRHS;
    A(n+1) = thisCoeff(1);
    B(n+1) = thisCoeff(2);
    C(n+1) = thisCoeff(3);

    %A'
    %Aerror(n-1) = norm(rad(A(n+1)));
    %Berror(n-1) = norm(rad(B(n+1)));
    %Cerror(n-1) = norm(rad(C(n+1)));

end    


%figure
%plot(Serror)

%figure 
%plot(Aerror)

%figure
%plot(Berror)

%figure
%plot(Cerror)

varargout(1,1)={A};
varargout(2,1)={B};
varargout(3,1)={C};



