function varargout = oneDimManifold_intval_delayHenon(a, b, ...
    dim, N, p, lambda, xi, scale);


%Initialize first order data:
P = intval(zeros(dim, N+1));

P(:, 1) = p;
P(:, 2) = scale*xi;


Dfp = henonLikeDifferential_intval(p, a, b, dim);
Id = intval(eye(dim));


    
  

%--------------------------------------------------------------------------
%Solve the Homological Equations and Determine the coefficients
%--------------------------------------------------------------------------


for (n = 2:N)
   HomMatrix = Dfp - lambda^n*Id;

A = P(1, :);   
   
A_reshape = A(2:n);
A_flip = fliplr(A_reshape);
A_transpose = transpose(A_reshape);

Sn = A_flip*A_transpose;
Sn = a*Sn;

    %Sn_test = intval(0);
    %for (k = 1:(n-1))
    %    %k
    %    %A'
    %    %Ak = A(k+1)
    %    %Ank = A(n-k+1)
    %    %Ak_error = rad(A(k+1))
    %    %Ank_error = rad(A(n-k+1))
    %    %termError = rad(a*A(k+1)*A(n-k+1))
    %    Sn_test = Sn_test + a*A(k+1)*A(n-k+1) + b*A(k+1)*B(n-k+1) + c*B(k+1)*B(n-k+1);
    %    %thisSn_error = rad(S_n)
    %end
    %Sn_test

    %n
    %rad(S_n)
    %Serror(n-1) = rad(S_n); 
      
    thisRHS = intval(zeros(dim, 1));
    
    thisRHS(1,1) = Sn;
     
    thisCoeff = verifylss(HomMatrix, thisRHS);       
    %thisCoeff = HomMatrix\thisRHS;
    P(:, n+1) = thisCoeff;

    %A'
    %Aerror(n-1) = norm(rad(A(n+1)));
    %Berror(n-1) = norm(rad(B(n+1)));
    %Cerror(n-1) = norm(rad(C(n+1)));

end    


%figure
%plot(Serror)

%figure 
%plot(Aerror)

%figure
%plot(Berror)

%figure
%plot(Cerror)

varargout(1,1)={P};




