function varargout = oneDim_sfd(A, B, C, N, lambda_s, r, numPoints);

scale_factor = abs(lambda_s);
r_outer = abs(r);
r_inner = scale_factor*abs(r);

I_right = linspace(r_inner, r_outer, numPoints);
I_left = linspace(-r_outer, -r_inner, numPoints);
Ws_fd_left = zeros(numPoints, 3);
Ws_fd_right = zeros(numPoints, 3);

 for k = 1:numPoints
     Ws_fd_right(k, 1:3) = [horner(I_right(k), A, N), ...
                            horner(I_right(k), B, N), ...
                            horner(I_right(k), C, N)];           
     Ws_fd_left(k, 1:3) = [horner(I_left(k), A, N), ...
                           horner(I_left(k), B, N), ...
                           horner(I_left(k), C, N)]; 
 end          

Is = linspace(-r_outer, r_outer, 2*numPoints);
Ws_loc = zeros(2*numPoints, 3);

 for k = 1:(2*numPoints)
     Ws_loc(k, 1:3) = [horner(Is(k), A, N), ...
                       horner(Is(k), B, N), ...
                       horner(Is(k), C, N)];                
 end          

 
 
 
 
 
varargout(1,1)={I_left};
varargout(2,1)={I_right};
varargout(3,1)={Ws_fd_left};
varargout(4,1)={Ws_fd_right};
varargout(5,1)={Is};
varargout(6,1)={Ws_loc};



