function varargout = oneDim_ufd(A, B, C, N, lambda_u, r, numPoints);

scale_factor = abs(lambda_u^(-1));
r_outer = abs(r);
r_inner = scale_factor*abs(r);

I_right = linspace(r_inner, r_outer, numPoints);
I_left = linspace(-r_outer, -r_inner, numPoints);
Wu_fd_left = zeros(numPoints, 3);
Wu_fd_right = zeros(numPoints, 3);


 for k = 1:numPoints
     Wu_fd_right(k, 1:3) = [horner(I_right(k), A, N), ...
                            horner(I_right(k), B, N), ...
                            horner(I_right(k), C, N)];           
     Wu_fd_left(k, 1:3) = [horner(I_left(k), A, N), ...
                           horner(I_left(k), B, N), ...
                           horner(I_left(k), C, N)]; 
 end          

Iu = linspace(-r_outer, r_outer, 2*numPoints);
Wu_loc = zeros(2*numPoints, 3);

 for k = 1:(2*numPoints)
     Wu_loc(k, 1:3) = [horner(Iu(k), A, N), ...
                       horner(Iu(k), B, N), ...
                       horner(Iu(k), C, N)];                
 end           
 
 
 
varargout(1,1)={I_left};
varargout(2,1)={I_right};
varargout(3,1)={Wu_fd_left};
varargout(4,1)={Wu_fd_right};
varargout(5,1)={Iu};
varargout(6,1)={Wu_loc};





