function varargout=parametrizationCoefficents_complexCase(N, p, nu, nu_bar, lambda, tau, a, b, c);

%initialize the coefficent matrices:
A = zeros(N+1, N+1);
B = A;
C = A;

%Constant Terms:
A(1,1) = p(1);
B(1,1) = p(2);
C(1,1) = p(3);

A(2,1) = nu(1);
A(1,2) = nu_bar(1);

B(2,1) = nu(2);
B(1,2) = nu_bar(2);

C(2,1) = nu(3); 
C(1,2) = nu_bar(3);


%Compute the i = 0 coefficents:
for j = 2:N
    A_0j = call_A(0, j, p, lambda, tau, a, b, c);
    s_0j = s(0,j, A, B, a, b, c);
    b_0j = [s_0j; 0 ; 0];
    coef_0j = linsolve(A_0j, b_0j);
    A(1,j+1) = coef_0j(1);
    B(1, j+1) = coef_0j(2);
    C(1, j+1) = coef_0j(3);
end    

%Compute the j = 0 coefficents:
for i = 2:N
    A_i0 = call_A(i, 0, p, lambda, tau, a, b, c);
    s_i0 = s(i, 0, A, B, a, b, c);
    b_i0 = [s_i0; 0 ; 0];
    coef_i0 = linsolve(A_i0, b_i0);
    A(i+1, 1) = coef_i0(1);
    B(i+1, 1) = coef_i0(2);
    C(i+1, 1) = coef_i0(3);
end    

for j = 1:N
    for i = 1:N
        A_ij = call_A(i, j, p, lambda, tau, a, b, c);
        s_ij = s(i, j, A, B, a, b, c);
        b_ij = [s_ij; 0 ; 0];
        coef_ij = linsolve(A_ij, b_ij);
        A(i+1, j+1) = coef_ij(1);
        B(i+1, j+1) = coef_ij(2);
        C(i+1, j+1) = coef_ij(3); 
    end
end    

varargout(1,1)={A};
varargout(2,1)={B};
varargout(3,1)={C};

%varargout(4,1)={[L4(1); L4(2); 0]};
%varargout(5,1)={[L5(1); L5(2); 0]};
