function A = parm_2ndDiff_2Dbound(theta, P1, P2, P3)



D_theta1_P1 = pderiv(P1, 'x') + pderiv(P1, 'y');
D_theta1_P2 = pderiv(P2, 'x') + pderiv(P2, 'y');
D_theta1_P3 = pderiv(P3, 'x') + pderiv(P3, 'y');


D_theta2_P1 = i*pderiv(P1, 'x') - i*pderiv(P1, 'y');
D_theta2_P2 = i*pderiv(P2, 'x') - i*pderiv(P2, 'y');
D_theta2_P3 = i*pderiv(P3, 'x') - i*pderiv(P3, 'y');


Dx_P1 = pderiv(P1, 'x');
Dy_P1 = pderiv(P1, 'y');

Dx_P2 = pderiv(P2, 'x');
Dy_P2 = pderiv(P2, 'y');

Dx_P3 = pderiv(P3, 'x');
Dy_P3 = pderiv(P3, 'y');



D_theta11_P1 = pderiv(Dx_P1, 'x') + ...
               2*pderiv(Dy_P1, 'x') +...
               pderiv(Dy_P1, 'y');
D_theta12_P1 = i*pderiv(Dx_P1, 'x') - i*pderiv(Dy_P1, 'y');
D_theta22_P1 = -pderiv(Dx_P1, 'x') + ...
               2*pderiv(Dy_P1, 'x') +...
               -pderiv(Dy_P1, 'y');

           
D_theta11_P2 = pderiv(Dx_P2, 'x') + ...
               2*pderiv(Dy_P2, 'x') +...
               pderiv(Dy_P2, 'y');
D_theta12_P2 = i*pderiv(Dx_P2, 'x') - i*pderiv(Dy_P2, 'y');
D_theta22_P2 = -pderiv(Dx_P2, 'x') + ...
               2*pderiv(Dy_P2, 'x') +...
               -pderiv(Dy_P2, 'y');           
      
           
           
D_theta11_P3 = pderiv(Dx_P3, 'x') + ...
               2*pderiv(Dy_P3, 'x') +...
               pderiv(Dy_P3, 'y');
D_theta12_P3 = i*pderiv(Dx_P3, 'x') - i*pderiv(Dy_P3, 'y');
D_theta22_P3 = -pderiv(Dx_P3, 'x') + ...
               2*pderiv(Dy_P3, 'x') +...
               -pderiv(Dy_P3, 'y');

           
           
z = theta(1) + i*theta(2);
zbar = theta(1) - i*theta(2);

max_11_P1 = abs(real(polyval(D_theta11_P1, z, zbar)));
max_12_P1 = abs(real(polyval(D_theta12_P1, z, zbar)));
max_22_P1 = abs(real(polyval(D_theta22_P1, z, zbar)));

max_11_P2 = abs(real(polyval(D_theta11_P2, z, zbar)));
max_12_P2 = abs(real(polyval(D_theta12_P2, z, zbar)));
max_22_P2 = abs(real(polyval(D_theta22_P2, z, zbar)));

max_11_P3 = abs(real(polyval(D_theta11_P3, z, zbar)));
max_12_P3 = abs(real(polyval(D_theta12_P3, z, zbar)));
max_22_P3 = abs(real(polyval(D_theta22_P3, z, zbar)));

P1_max = max_11_P1 + 2*max_12_P1 + max_22_P1;
P2_max = max_11_P2 + 2*max_12_P2 + max_22_P2;
P3_max = max_11_P3 + 2*max_12_P3 + max_22_P3;

theMaxes = [P1_max P2_max P3_max];
theMaxes_float = [sup(P1_max) sup(P2_max) sup(P3_max)];
[floatMax, maxIndex] = max(theMaxes_float);
theMax = theMaxes(maxIndex);
 
 A = theMax;
 
 
 
 
 
 
 
 
 

 