function varargout = twoDim_sfd(A, B, C, N, lambda_s, r, numRad, numTheta);

 %2D fundamental domain parameters:
 r2 = abs(r);
 r1 = abs(lambda_s)*r2;
 theta_step = 2*pi/numTheta;
 
 
 delta_rad = 0.005*(r2 - r1);
 %delta_rad = 0.05*r2;
 radi = linspace(r1 - delta_rad, r2 + delta_rad, numRad);
 
 Ds = zeros(numRad*numTheta, 2);
 Ws_fund = zeros(numRad*numTheta, 3);

 %Compute the 2D fundamental domain:
 for n = 1:numRad
   n  
   this_r = radi(n);
   for m = 1:numTheta
       thisTheta = theta_step*(m-1);
       thisParm = this_r*[cos(thisTheta), sin(thisTheta)];
       Ds(m+(n-1)*numTheta, 1:2) = thisParm;
              
       Ps_z = evaluate_complexCase(thisParm(1), thisParm(2), A, B, C, N);
       Ws_fd(m+(n-1)*numTheta, 1:3) = Ps_z;
   end
 end


varargout(1,1)={Ds};
varargout(2,1)={Ws_fd};

