function varargout = twoDim_ufd(A, B, C, N, lambda_u, r, numRad, numTheta);

 %2D fundamental domain parameters:
 r2 = abs(r);
 r1 = abs(lambda_u^(-1))*r2;
 theta_step = 2*pi/numTheta;
 
 
 delta_rad = 0.005*(r2 - r1);
 %delta_rad = 0.05*r2;
 radi = linspace(r1 - delta_rad, r2 + delta_rad, numRad);
 
 Du = zeros(numRad*numTheta, 2);
 Wu_fund = zeros(numRad*numTheta, 3);

 %Compute the 2D fundamental domain:
 for n = 1:numRad
   n
   this_r = radi(n);
   for m = 1:numTheta
       thisTheta = theta_step*(m-1);
       thisParm = this_r*[cos(thisTheta), sin(thisTheta)];
       Du(m+(n-1)*numTheta, 1:2) = thisParm;
              
       Pu_z = evaluate_complexCase(thisParm(1), thisParm(2), A, B, C, N);
       Wu_fd(m+(n-1)*numTheta, 1:3) = Pu_z;
   end
 end


varargout(1,1)={Du};
varargout(2,1)={Wu_fd};