function varargout = uError_delayHenon_intval(...
    Pu_poly, p, lambda, N, nu, a, b, dimNum);



fx = cell(dimNum, 1);
Pu_lambda = cell(dimNum, 1);
Error = cell(dimNum, 1);
error_vect = intval(zeros(dimNum, 1));

one_int = intval('1');

for k = 1:dimNum-1
   fx{k} = Pu_poly{k+1}; 
end

fx{dimNum} = (-one_int+Pu_poly{1}+a*Pu_poly{2}*Pu_poly{2})/b;

lambda_inv = lambda^(-1);

for k = 1:dimNum
   thisComp_lambda = intval(zeros(1, N+1));
   thisComp_lambda(1) = Pu_poly{k}(0);
   for n = 1:N
        thisComp_lambda(n+1) = (lambda_inv^n)*Pu_poly{k}(n); 
   end
   Pu_lambda{k} = convertToPoly_1D1D(thisComp_lambda, N);
end


%A-Posteriori Error Bound:

for k = 1:dimNum
   Error{k} = abs(fx{k} - Pu_lambda{k});  
   error_vect(k) = Error{k}{nu};
end

aPosError = norm(error_vect, inf);

%Differantial Bound:
fx_p = intval(zeros(dimNum, 1));
for k = 1:dimNum
    fx_p(k) = fx{k}{p(k)};
end

Df_term1 = henonLikeDifferential_intval(fx_p, a, b, N);
differentialBound = norm(Df_term1, inf)


order_fx_1 = fx{1}.e

for k = 1:order_fx_1
   differentialBound = differentialBound + 2*abs(a)*abs(fx{1}(k))*nu^k; 
end


varargout(1,1)={aPosError};
varargout(2,1)={differentialBound};









