function varargout = validateChaosProof6D(validationParameters, ...
    n_s, n_u, Nu, Ns, scale_0s1, scale_0s2, ...
    scale_0u1, scale_0u2, scale_0u3, scale_0u4, ...
    domRad0s, domRad0u, ...
    a1, b1, c1, alpha1, tau1, ...
    a2, b2, c2, alpha2, tau2, epsilon);




      
   %Convert to Lomeli:   
      a1 = intval(a1)      %c_dm
      b1 = intval(b1)      %b_dm - 2*c_dm
      c1 = intval(c1)      %c_dm + a_dm - b_dm
      
      tau1 =    intval(tau1)  %2*a_dm*(3+mu_dm)/(2*a_dm - b_dm)
      alpha1 =  intval(alpha1) %((9+6*mu_dm+mu_dm^2)*a_dm - 4*eps_dm*a_dm^2 + ...
                           %4*eps_dm*a_dm*b_dm - eps_dm*b_dm^2)/(2*a_dm - b_dm)^2
                    
      a2 = intval(a2)      %c_dm
      b2 = intval(b2)      %b_dm - 2*c_dm
      c2 = intval(c2)      %c_dm + a_dm - b_dm
      
      tau2 =    intval(tau2)  %2*a_dm*(3+mu_dm)/(2*a_dm - b_dm)
      alpha2 =  intval(alpha2) %((9+6*mu_dm+mu_dm^2)*a_dm - 4*eps_dm*a_dm^2 + ...
                           %4*eps_dm*a_dm*b_dm - eps_dm*b_dm^2)/(2*a_dm - b_dm)^2
                    
      epsilon = intval(epsilon)         
                           
                           
                           
  [p0, p1, lambda0_s1, lambda0_s2, ...
         lambda0_u1, lambda0_u2, lambda0_u3, lambda0_u4, ...
         lambda1_u1, lambda1_u2, ...
         lambda1_s1, lambda1_s2, lambda1_s3, lambda1_s4, ...
         xi0_s1, xi0_s2, xi0_u1, xi0_u2, xi0_u3, xi0_u4, ...
         xi1_u1, xi1_u2, xi1_s1, xi1_s2, xi1_s3, xi1_s4] ...
     = firstOrderData_intval_6DHenon(a1, b1, c1, alpha1, tau1, ...
                                     a2, b2, c2, alpha2, tau2, ...
                                     epsilon); 
  
          
                                 
 
                                 
           
%=====================================================================
%Manifolds 
%=====================================================================



scale0_s1 = intval(scale_0s1);
scale0_s2 = intval(scale_0s2);

tic

[A0s, B0s, C0s, D0s, E0s, F0s] = twoDimManifold_intval_6DHenon(...
      a1, b1, c1, alpha1, tau1, ...
      a2, b2, c2, alpha2, tau2, ...
      epsilon, Ns, p0, ...
      lambda0_s1, lambda0_s2, xi0_s1, xi0_s2, ...
      scale0_s1, scale0_s2);

twoDimTime = toc
  

domRad0s = intval(domRad0s);
 

 
%=====================================================================
%High-D Manifolds 
%=====================================================================

%Step 1: Compute 4D Coefficients:

scale0_u1 = intval(scale_0u1); 
scale0_u2 = intval(scale_0u2);
scale0_u3 = intval(scale_0u3);
scale0_u4 = intval(scale_0u4);


tic

[A0u, B0u, C0u, D0u, E0u, F0u] = fourDimManifold_6DHenon_intval(...
      a1, b1, c1, alpha1, tau1, ...
      a2, b2, c2, alpha2, tau2, ...
      epsilon, Nu, p0, ...
      lambda0_u1, lambda0_u2, lambda0_u3, lambda0_u4, ...
      xi0_u1, xi0_u2, xi0_u3, xi0_u4, ...
      scale0_u1, scale0_u2, scale0_u3, scale0_u4);

  
fourDim_intvalTime = toc  

  
domRad0u = intval(domRad0u)

testCoef = F0u(3,3,3,3)
testRad = rad(F0u(3,3,3,3))




%----------------------Put in Polynomial Data Structure--------------------


%[P0u1, P0u2, P0u3] = convertToPoly_2D(A0u, B0u, C0u, N);

[P0s1, P0s2, P0s3, P0s4, P0s5, P0s6] = ...
    convertToPoly_2D_6D(A0s, B0s, C0s, D0s, E0s, F0s, Ns)


[P0u1, P0u2, P0u3, P0u4, P0u5, P0u6] = ...
    convertToPoly_4D_6D(A0u, B0u, C0u, D0u, E0u, F0u, Nu)




%Step 2: Validate the Manifolds                                               
  
 

domRad0s = intval(domRad0s)
domRad0u = intval(domRad0u)




N_f = 10
N_dim = 6


tic

[delta_0s, delta_max_0s, P0s_norm, s0_delta_good, OrderTest_s]...
        = validateStableManifold_2D_6DHenon(...
                P0s1, P0s2, P0s3, P0s4, P0s5, P0s6, ...
                p0, xi0_s1, xi0_s2, xi0_u1, xi0_u2, xi0_u3, xi0_u4, ...
                lambda0_s1, lambda0_s2, N_f, N_dim, domRad0s, Ns, ...
                a1, b1, c1, alpha1, tau1, ...
                a2, b2, c2, alpha2, tau2, epsilon);


 toc
time_2D_proof = toc

s0_delta_good 

OrderTest_s
 
P0s_norm

delta_0s





tic


[delta_0u, delta_max_0u, P0u_norm, u0_delta_good, OrderTest_u]...
        = validateUnstableManifold_4D_6DHenon(...
                P0u1, P0u2, P0u3, P0u4, P0u5, P0u6, ...
                p0, xi0_s1, xi0_s2, xi0_u1, xi0_u2, xi0_u3, xi0_u4, ...
                lambda0_u1, lambda0_u2, lambda0_u3, lambda0_u4, ...
                N_f, N_dim, domRad0u, Nu, ...
                a1, b1, c1, alpha1, tau1, ...
                a2, b2, c2, alpha2, tau2, epsilon);



time_4D_proof = toc


OrderTest_u

u0_delta_good

P0u_norm

delta_0u




temp_1 = size(validationParameters);
numOrbits = temp_1(2);


tic

theta_hat = validationParameters(1:4);
xn_hat = validationParameters(5:(6*(n_s + n_u)-2))';
tau_hat = validationParameters(...
               (6*(n_s + n_u) - 1):(6*(n_s + n_u)));

                                                   
                          
[goodOrbit, goodChaos, r_NK] = ...
    validateOrbit_6D(...
        theta_hat, xn_hat, tau_hat, n_u, n_s, ...
        P0u1, P0u2, P0u3, P0u4, P0u5, P0u6, ...
        P0s1, P0s2, P0s3, P0s4, P0s5, P0s6, ...
        domRad0s, domRad0u, delta_0u, delta_0s, ...
        Nu, Ns, ...
        alpha1, tau1, a1, b1, c1, ...
        alpha2, tau2, a2, b2, c2, ...
        epsilon)

proofCount = 1;    
  
orbitsValidated(proofCount) = goodOrbit;
chaosValidation(proofCount) = goodChaos;
radii(proofCount) = r_NK;


toc
time_orbitsProof = toc/60






varargout(1,1)={orbitsValidated};
varargout(2,1)={chaosValidation};
varargout(3,1)={radii};





