function varargout = validateManifolds_1D_3DHenon(...
    P0s1, P0s2, P0s3, P1u1, P1u2, P1u3, ...
    p0, p1, xi0_u1, xi0_u2, xi0_s, xi1_u, xi1_s1, xi1_s2, ...
    lambda0_s, lambda1_u, N_f, N_dim, ...
    domRad0s, domRad0u, order_1, a, b, c, alpha, tau);



%Bounds.
max1 = polyval(mag(P0s1-p0(1)), domRad0s);
max2 = polyval(mag(P0s2-p0(2)), domRad0s);
max3 = polyval(mag(P0s3-p0(3)), domRad0s);
P0s_norm = max([sup(max1), sup(max2), sup(max3)])


max1 = polyval(mag(P1u1-p1(1)), domRad0u);
max2 = polyval(mag(P1u2-p1(2)), domRad0u);
max3 = polyval(mag(P1u3-p1(3)), domRad0u);
P1u_norm = max([sup(max1), sup(max2), sup(max3)])


%A Posteriori Errors: 1D                                               
                                               
                                                                                              
epsilon_s1D = sError_intval_1D(P0s1, P0s2, P0s3, alpha, tau, ...
                               a, b, c, lambda0_s, order_1, domRad0s)

                          
epsilon_u1D = uError_intval_1D(P1u1, P1u2, P1u3, alpha, tau, ...
                               a, b, c, lambda1_u, order_1, domRad0u)


%stopNow = stopHere



K_1_center = max([2*sup(abs(a)), 2*sup(abs(c)), sup(abs(b))])
K_1_rad = max([2*rad(a), 2*rad(c), 2*rad(b)])
K_1 = midrad(K_1_center, K_1_rad)

Q0_0s = [xi0_u1, xi0_u2, xi0_s];                           
Q0_0s_inv = inv(Q0_0s);

Q0_1u = [xi1_u, xi1_s1, xi1_s2];
Q0_1u_inv = inv(Q0_1u);

C1_0s = norm(Q0_0s, inf)*norm(Q0_0s_inv, inf)
C1_1u = norm(Q0_1u, inf)*norm(Q0_1u_inv, inf)
          

C2_0s = 4*K_1*P0s_norm
C2_1u = 4*K_1*P1u_norm

mu_up_0s = abs(lambda0_s)
mu_down_0s = abs(lambda0_s)

mu_up_1u = abs(lambda1_u^(-1))
mu_down_1u = abs(lambda1_u^(-1))


C_tilde_0s = C1_0s + mu_down_0s*C2_0s
C_tilde_1u = C1_1u + mu_down_1u*C2_1u
OrderTest_0s = sup((log(mu_down_0s) - log(C_tilde_0s))/log(mu_up_0s))
OrderTest_1u = sup((log(mu_down_1u) - log(C_tilde_1u))/log(mu_up_1u))

orderTest = 0;

if (((order_1 +1) >= OrderTest_0s) &&((order_1 + 1) >= OrderTest_1u))
    orderTest = 1
end


denom_0s = 2*N_dim*exp(1)*intval('pi')*N_f*C_tilde_0s*K_1
delta_max_0s = ...
    (mu_down_0s - C_tilde_0s*mu_up_0s^(order_1 + 1))/denom_0s



delta_0s = ...
    (2*C_tilde_0s/(mu_down_0s - C_tilde_0s*mu_up_0s^(order_1 + 1)))*epsilon_s1D


denom_1u = 2*N_dim*exp(1)*intval('pi')*N_f*C_tilde_1u*K_1
delta_max_1u = ...
    (mu_down_1u - C_tilde_1u*mu_up_1u^(order_1 + 1))/denom_1u



delta_1u = ...
    (2*C_tilde_1u/(mu_down_1u - C_tilde_1u*mu_up_1u^(order_1 + 1)))*epsilon_u1D


u1_delta_good = 0;
s0_delta_good = 0;
if ((sup(delta_1u) < inf(delta_max_1u)) && (inf(delta_1u > 0)))
  u1_delta_good = 1
end

if ((sup(delta_0s) < inf(delta_max_0s)) && (inf(delta_0s) > 0))
  s0_delta_good = 1
end


      

%==========================================================================
%Return Values:
%==========================================================================

varargout(1,1)={delta_0s};
varargout(2,1)={delta_1u};
varargout(3,1)={delta_max_0s};
varargout(4,1)={delta_max_1u};
varargout(5,1)={P0s_norm};
varargout(6,1)={P1u_norm};
varargout(7,1)={u1_delta_good};
varargout(8,1)={s0_delta_good};
varargout(9,1)={orderTest};


