function varargout = validateStableManifold_1D_3DHenon(...
    P0s1, P0s2, P0s3, p0, xi0_u1, xi0_u2, xi0_s, ...
    lambda0_s, N_f, N_dim, domRad0s, order_1, a, b, c, alpha, tau);




%Bounds.
max1 = polyval(mag(P0s1-p0(1)), domRad0s);
max2 = polyval(mag(P0s2-p0(2)), domRad0s);
max3 = polyval(mag(P0s3-p0(3)), domRad0s);
P0s_norm = max([sup(max1), sup(max2), sup(max3)])


%A Posteriori Errors: 1D                                               
                                                                                              
epsilon_s1D = sError_intval_1D(P0s1, P0s2, P0s3, alpha, tau, ...
                               a, b, c, lambda0_s, order_1, domRad0s)

   
                           
                           
K_1_center = max([2*sup(abs(a)), 2*sup(abs(c)), sup(abs(b))])
K_1_rad = max([2*rad(a), 2*rad(c), 2*rad(b)])
K_1 = midrad(K_1_center, K_1_rad)

Q0_0s = [xi0_u1, xi0_u2, xi0_s];                           
Q0_0s_inv = inv(Q0_0s);


C1_0s = norm(Q0_0s, inf)*norm(Q0_0s_inv, inf)
          

C2_0s = 4*K_1*P0s_norm


mu_up_0s = abs(lambda0_s)
mu_down_0s = abs(lambda0_s)


C_tilde_0s = C1_0s + mu_down_0s*C2_0s
OrderTest_0s = sup((log(mu_down_0s) - log(C_tilde_0s))/log(mu_up_0s))

orderTest = 0;

if ((order_1 +1) >= OrderTest_0s)
    orderTest = 1
end


denom_0s = 2*N_dim*exp(1)*intval('pi')*N_f*C_tilde_0s*K_1
delta_max_0s = ...
    (mu_down_0s - C_tilde_0s*mu_up_0s^(order_1 + 1))/denom_0s



delta_0s = ...
    (2*C_tilde_0s/(mu_down_0s - C_tilde_0s*mu_up_0s^(order_1 + 1)))*epsilon_s1D


s0_delta_good = 0;
if ((sup(delta_0s) < inf(delta_max_0s)) && (inf(delta_0s) > 0))
  s0_delta_good = 1
end

      

%==========================================================================
%Return Values:
%==========================================================================

varargout(1,1)={delta_0s};
varargout(2,1)={delta_max_0s};
varargout(3,1)={P0s_norm};
varargout(4,1)={s0_delta_good};
varargout(5,1)={orderTest};


