function varargout = validateStableManifold_2D_6DHenon(...
    P0s1, P0s2, P0s3, P0s4, P0s5, P0s6, ...
    p0, xi0_s1, xi0_s2, xi0_u1, xi0_u2, xi0_u3, xi0_u4, ...
    lambda0_s1, lambda0_s2, N_f, N_dim, domRad0s, Ns, ...
    a1, b1, c1, alpha1, tau1, ...
    a2, b2, c2, alpha2, tau2, ...
    epsilon);


 

max1 = polyval(mag(P0s1- p0(1)), domRad0s, domRad0s);
max2 = polyval(mag(P0s2- p0(2)), domRad0s, domRad0s);
max3 = polyval(mag(P0s3- p0(3)), domRad0s, domRad0s);
max4 = polyval(mag(P0s4- p0(4)), domRad0s, domRad0s);
max5 = polyval(mag(P0s5- p0(5)), domRad0s, domRad0s);
max6 = polyval(mag(P0s6- p0(6)), domRad0s, domRad0s);

P0s_norm = max([sup(max1), ...
                sup(max2), ...
                sup(max3), ...
                sup(max4), ...
                sup(max5), ...
                sup(max6)]) 

           
epsilon_s2D = sError_intval_2D6D(P0s1, P0s2, P0s3, ...
                                P0s4, P0s5, P0s6, ...
                                alpha1, tau1, a1, b1, c1, ...
                                alpha2, tau2, a2, b2, c2, ...
                                epsilon, ...
                                lambda0_s1, ...
                                lambda0_s2, ...
                                Ns, ...
                                domRad0s)


                           
K_1_center = max([2*sup(abs(a1)), ...
                  2*sup(abs(c1)), ...
                    sup(abs(b1)), ...
                  2*sup(abs(a2)), ...
                  2*sup(abs(c2)), ...
                    sup(abs(b2))]) + 2*sup(epsilon)
                
K_1_rad = 2*max([rad(a1), ...
                 rad(c1), ...
                 rad(b1), ...
                 rad(a2), ...
                 rad(c2), ...
                 rad(b2)]) ...
               + 2*rad(epsilon)

           
           
K_1 = midrad(K_1_center, K_1_rad)

Q0_0s = [xi0_u1, xi0_u2, xi0_u3, xi0_u4, xi0_s1, xi0_s2];
Q0_0s_inv = inv(Q0_0s);

C1_0s = norm(Q0_0s, inf)*norm(Q0_0s_inv, inf)
          
C2_0s = N_f*K_1*P0s_norm

mu_up_0s = max([sup(abs(lambda0_s1)), sup(abs(lambda0_s2))])
mu_down_0s = min([sup(abs(lambda0_s1)), sup(abs(lambda0_s2))])



C_tilde_0s = C1_0s + mu_down_0s*C2_0s
OrderTest_0s = sup((log(mu_down_0s) - log(C_tilde_0s))/log(mu_up_0s))

orderTest = 0;

if ((Ns +1) >= OrderTest_0s)
    orderTest = 1
end


denom_0s = 2*N_dim*exp(1)*intval('pi')*N_f*C_tilde_0s*K_1
delta_max_0s = ...
    (mu_down_0s - C_tilde_0s*mu_up_0s^(Ns + 1))/denom_0s

delta_0s = ...
    (2*C_tilde_0s/(mu_down_0s - C_tilde_0s*mu_up_0s^(Ns + 1)))*epsilon_s2D


s0_delta_good = 0;

if ((sup(delta_0s) < inf(delta_max_0s)) && (inf(delta_0s) > 0) )
  s0_delta_good = 1
  sup(delta_0s)
end

      

%==========================================================================
%Return Values:
%==========================================================================

varargout(1,1)={delta_0s};
varargout(2,1)={delta_max_0s};
varargout(3,1)={P0s_norm};
varargout(4,1)={s0_delta_good};
varargout(5,1)={orderTest};




