function varargout = validateUnstableManifold_2D_3DHenon(...
    P0u1, P0u2, P0u3, p0, xi0_u1, xi0_u2, xi0_s, ...
    lambda0_u1, lambda0_u2, N_f, N_dim, ...
    domRad0u, N, a, b, c, alpha, tau);


 

max1 = polyval(mag(P0u1- p0(1)), domRad0u, domRad0u);
max2 = polyval(mag(P0u2- p0(2)), domRad0u, domRad0u);
max3 = polyval(mag(P0u3- p0(3)), domRad0u, domRad0u);
P0u_norm = max([sup(max1), sup(max2), sup(max3)]) 


epsilon_u2D = uError_intval_2D(P0u1, P0u2, P0u3, alpha, tau, ...
                               a, b, c, lambda0_u1, lambda0_u2, N, domRad0u)

                                                     

                           
                           
K_1_center = max([2*sup(abs(a)), 2*sup(abs(c)), sup(abs(b))])
K_1_rad = max([2*rad(a), 2*rad(c), 2*rad(b)])
K_1 = midrad(K_1_center, K_1_rad)

Q0_0u = [xi0_s, xi0_u1, xi0_u2];
Q0_0u_inv = inv(Q0_0u);

C1_0u = norm(Q0_0u, inf)*norm(Q0_0u_inv, inf)
          
C2_0u = 4*K_1*P0u_norm

mu_up_0u = abs(lambda0_u1^(-1))
mu_down_0u = abs(lambda0_u2^(-1))



C_tilde_0u = C1_0u + mu_down_0u*C2_0u
OrderTest_0u = sup((log(mu_down_0u) - log(C_tilde_0u))/log(mu_up_0u))

orderTest = 0;

if ((N +1) >= OrderTest_0u)
    orderTest = 1
end


denom_0u = 2*N_dim*exp(1)*intval('pi')*N_f*C_tilde_0u*K_1
delta_max_0u = ...
    (mu_down_0u - C_tilde_0u*mu_up_0u^(N + 1))/denom_0u

delta_0u = ...
    (2*C_tilde_0u/(mu_down_0u - C_tilde_0u*mu_up_0u^(N + 1)))*epsilon_u2D


u0_delta_good = 0;

if ((sup(delta_0u) < inf(delta_max_0u)) && (inf(delta_0u) > 0) )
  u0_delta_good = 1
  sup(delta_0u)
end

      

%==========================================================================
%Return Values:
%==========================================================================

varargout(1,1)={delta_0u};
varargout(2,1)={delta_max_0u};
varargout(3,1)={P0u_norm};
varargout(4,1)={u0_delta_good};
varargout(5,1)={orderTest};


