function varargout = validateUnstableManifold_4D_6DHenon(...
    P0u1, P0u2, P0u3, P0u4, P0u5, P0u6, ...
    p0, xi0_s1, xi0_s2, xi0_u1, xi0_u2, xi0_u3, xi0_u4, ...
    lambda0_u1, lambda0_u2, lambda0_u3, lambda0_u4, ...
    N_f, N_dim, domRad0u, Nu, ...
    a1, b1, c1, alpha1, tau1, ...
    a2, b2, c2, alpha2, tau2, ...
    epsilon);


 

max1 = polyval(mag(P0u1- p0(1)), domRad0u, domRad0u, domRad0u, domRad0u);
max2 = polyval(mag(P0u2- p0(2)), domRad0u, domRad0u, domRad0u, domRad0u);
max3 = polyval(mag(P0u3- p0(3)), domRad0u, domRad0u, domRad0u, domRad0u);
max4 = polyval(mag(P0u4- p0(4)), domRad0u, domRad0u, domRad0u, domRad0u);
max5 = polyval(mag(P0u5- p0(5)), domRad0u, domRad0u, domRad0u, domRad0u);
max6 = polyval(mag(P0u6- p0(6)), domRad0u, domRad0u, domRad0u, domRad0u);

P0u_norm = max([sup(max1), ...
                sup(max2), ...
                sup(max3), ...
                sup(max4), ...
                sup(max5), ...
                sup(max6)]) 

           
epsilon_u4D = uError_intval_4D6D(P0u1, P0u2, P0u3, ...
                                P0u4, P0u5, P0u6, ...
                                alpha1, tau1, a1, b1, c1, ...
                                alpha2, tau2, a2, b2, c2, ...
                                epsilon, ...
                                lambda0_u1, ...
                                lambda0_u2, ...
                                lambda0_u3, ...
                                lambda0_u4, ...
                                Nu, ...
                                domRad0u)

                                                     
K_1_center = max([2*sup(abs(a1)), ...
                  2*sup(abs(c1)), ...
                    sup(abs(b1)), ...
                  2*sup(abs(a2)), ...
                  2*sup(abs(c2)), ...
                    sup(abs(b2))]) + 2*sup(epsilon)
                
K_1_rad = 2*max([rad(a1), ...
                 rad(c1), ...
                 rad(b1), ...
                 rad(a2), ...
                 rad(c2), ...
                 rad(b2)]) ...
               + 2*rad(epsilon)

           
           
K_1 = midrad(K_1_center, K_1_rad)

Q0_0u = [xi0_u1, xi0_u2, xi0_u3, xi0_u4, xi0_s1, xi0_s2];
Q0_0u_inv = inv(Q0_0u);

C1_0u = norm(Q0_0u, inf)*norm(Q0_0u_inv, inf)
          
C2_0u = N_f*K_1*P0u_norm

mu_up_0u   = max([sup(abs(lambda0_u1^(-1))), sup(abs(lambda0_u2^(-1)))])
mu_down_0u = min([sup(abs(lambda0_u1^(-1))), sup(abs(lambda0_u2^(-1)))])



C_tilde_0u = C1_0u + mu_down_0u*C2_0u
OrderTest_0u = sup((log(mu_down_0u) - log(C_tilde_0u))/log(mu_up_0u))

orderTest = 0;

if ((Nu +1) >= OrderTest_0u)
    orderTest = 1
end


denom_0u = 2*N_dim*exp(1)*intval('pi')*N_f*C_tilde_0u*K_1
delta_max_0u = ...
    (mu_down_0u - C_tilde_0u*mu_up_0u^(Nu + 1))/denom_0u

delta_0u = ...
    (2*C_tilde_0u/(mu_down_0u - C_tilde_0u*mu_up_0u^(Nu + 1)))*epsilon_u4D


u0_delta_good = 0;

if ((sup(delta_0u) < inf(delta_max_0u)) && (inf(delta_0u) > 0) )
  u0_delta_good = 1
  sup(delta_0u)
end

      


%==========================================================================
%Return Values:
%==========================================================================

varargout(1,1)={delta_0u};
varargout(2,1)={delta_max_0u};
varargout(3,1)={P0u_norm};
varargout(4,1)={u0_delta_good};
varargout(5,1)={orderTest};
