function varargout = validate_truncationErrorPartial_henonLike(...
    i, Lambda, lambda, A, Q, Q_inv, nu, delta, C_tilde, a,b, numDim)



Id =  intval(eye(numDim));

B = intval(zeros(numDim, numDim-1));
Sigma = intval(zeros(numDim, numDim));

Sigma(1:numDim-1, 1:numDim-1) = Lambda;
Sigma(numDim, numDim) = lambda;

vectorWeights = intval(ones(numDim-1, 1));
vectorWeights(i) = intval(2);

lambda_i = Lambda(i,i);
s_alpha = intval(zeros(numDim, 1));
xi_i = A(:, i);


for j = 1:numDim-1
    lambda_j = Lambda(j,j);
    xi_j = A(:, j);
    %compute s_alpha:
    s_alpha(j, 1) = a*xi_i(1)*xi_j(1);     
    
    
    %compute p_alpha:
    p_alpha = Q*inv([Sigma - lambda_i*lambda_j*Id])*Q_inv*s_alpha;
    B(:, j) = 2*p_alpha;
end




%==========================================================================
%Validation Algorithm:
%==========================================================================
goodComputation = 1;
M_tilde = 2*abs(a)*C_tilde*( norm(A(1, :), inf)*nu + delta);



if inf(M_tilde) >= 1
   goodComputation = 0
   M_tilde_2_big = 1
end

B_i_norm = norm(B, inf);
delta_i = (C_tilde/(1 - M_tilde))*...
    (M_tilde*B_i_norm*nu + 2*abs(a)*norm(xi_i, inf)*delta);



varargout(1,1)= {delta_i};
varargout(2,1)= {B_i_norm};
varargout(3,1)= {goodComputation};

