clear 
format long




%Map Parameter Set: Dullin to Lomeli Meiss.
   %Dullin Meiss Parms:
      a_dm = 1
      b_dm = 0.5
      c_dm = 0.5
            
      
      %eps_dm = 2.11    %boundary near 6.182001
      eps_dm = 0.32      %worked at 0.4
      mu_dm = -2.4
      
      
   %Convert to Lomeli:   
      a = c_dm
      b = b_dm - 2*c_dm
      c = c_dm + a_dm - b_dm
      
      tau =    2*a_dm*(3+mu_dm)/(2*a_dm - b_dm)
      alpha =  ((9+6*mu_dm+mu_dm^2)*a_dm - 4*eps_dm*a_dm^2 + ...
               4*eps_dm*a_dm*b_dm - eps_dm*b_dm^2)/(2*a_dm - b_dm)^2

     
      
   %Convert to Lomeli:   
      a = intval(a)      %c_dm
      b = intval(b)      %b_dm - 2*c_dm
      c = intval(c)      %c_dm + a_dm - b_dm
      
      tau =  intval(tau)  %2*a_dm*(3+mu_dm)/(2*a_dm - b_dm)
      alpha =  intval(alpha) %((9+6*mu_dm+mu_dm^2)*a_dm - 4*eps_dm*a_dm^2 + ...
                           %4*eps_dm*a_dm*b_dm - eps_dm*b_dm^2)/(2*a_dm - b_dm)^2

     

                           
                           
                           

                     
           
[p0, p1, lambda0_s, lambda0_u1, lambda0_u2, ...
         lambda1_u, lambda1_s1, lambda1_s2, ...
         xi0_s, xi0_u1, xi0_u2, ...
         xi1_u, xi1_s1, xi1_s2] ...
       = firstOrderData_intval_3DHenon(a, b, c, alpha, tau);
     
   
   
%=====================================================================
%Order Controls: %Order of manifold computation:
  %Order of 2D manifolds:
  N = 30;
  %Order of 1D manifold computations 
  order_1 = 50;
%=====================================================================
   
   

           
%=====================================================================
%One-D Manifolds 
%=====================================================================

%Step 1: Compute 1D Coefficients:


scale = intval('20');


[A0s, B0s, C0s] = oneDimManifold_intval_3DHenon(a, b, c, alpha, tau, ...
     order_1, p0, lambda0_s, xi0_s, scale);

 
scale = intval('50') 
 
[A1u, B1u, C1u] = oneDimManifold_intval_3DHenon(a, b, c, alpha, tau, ...
    order_1, p1, lambda1_u, xi1_u, scale);           
           
           

firstOrder = 1

           


%==========================================================================
%1D Validation
%==========================================================================

[P0s1, P0s2, P0s3] = convertToPoly_1D(A0s, B0s, C0s, order_1);                                                 

[P1u1, P1u2, P1u3] = convertToPoly_1D(A1u, B1u, C1u, order_1);                                                 
                                               


                                                                                            
%Phase Space Bounds: 1D  
domRad0s = intval('0.02')
domRad1u = intval('0.01')


N_f = 4
N_dim = 3

[delta_0s, delta_1u, delta_max_0s, delta_max_1u, ...
    P0s_norm, P1u_norm, ...
    u1_delta_good, s0_delta_good, OrderTest]...
    = validateManifolds_1D_3DHenon(...
    P0s1, P0s2, P0s3, P1u1, P1u2, P1u3, ...
    p0, p1, xi0_u1, xi0_u2, xi0_s, xi1_u, xi1_s1, xi1_s2,...
    lambda0_s, lambda1_u, N_f, N_dim, ...
    domRad0s, domRad1u, order_1, a, b, c, alpha, tau);


P0s_norm
P1u_norm

delta_0s
delta_1u



%==========================================================================
%Two-D Manifolds:
%==========================================================================

%Step 1: Compute Coefficients:
 scale1 = intval('25');
 scale2 = intval('25');
 
 N = 25;
 

 
 tic
 
 [A0u, B0u, C0u] = twoDimManifold_intval_3DHenon(a, b, c, alpha, tau, ...
     N, p0, lambda0_u1, lambda0_u2, xi0_u1, xi0_u2, scale1, scale2);
 
 
 [A1s, B1s, C1s] = twoDimManifold_intval_3DHenon(a, b, c, alpha, tau, ...
     N, p1, lambda1_s1, lambda1_s2, xi1_s1, xi1_s2, scale1, scale2);           
            
   
 time_1 = toc/60


%----------------------Put in Polynomial Data Structure--------------------



[P0u1, P0u2, P0u3] = convertToPoly_2D(A0u, B0u, C0u, N);

[P1s1, P1s2, P1s3] = convertToPoly_2D(A1s, B1s, C1s, N);
                                                
                                                 
                                                 
                                               
%Step 2: Validate the Manifolds                                               
                                               
                                                                                  
%Phase Space Bounds: 2D

domRad1s = intval('0.01');
              
domRad0u = intval('0.01');
                         
                     
%A-Posteriori Errors: 2D                           




[delta_0u, delta_1s, delta_max_0u, delta_max_1s,...
 P0u_norm, P1s_norm, u0_delta_good, s1_delta_good, orderTest] ...
    = validateManifolds_2D_3DHenon(...
    P0u1, P0u2, P0u3, P1s1, P1s2, P1s3, ...
    p0, p1, xi0_u1, xi0_u2, xi0_s, xi1_u, xi1_s1, xi1_s2, ...
    lambda0_u1, lambda0_u2, lambda1_s1, lambda1_s2, N_f, N_dim, ...
    domRad0u, domRad1s, N, a, b, c, alpha, tau);



P0s_norm
P1u_norm

delta_0s
delta_1u




P0u_norm
P1s_norm

delta_0u
delta_1s


